/* Application.c generated by valac 0.56.13, the Vala compiler
 * generated from Application.vala, do not modify */

/* Application.vala
 *
 * Copyright 2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <string.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <vte/vte.h>

#define TERMINAL_GETTEXT_PACKAGE "blackbox"
#define TERMINAL_LOCALEDIR "/usr/share/locale"
#define TERMINAL_APP_NAME "BlackBox"
#define TERMINAL_VERSION "0.14.0"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_APPLICATION (terminal_application_get_type ())
#define TERMINAL_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_APPLICATION, TerminalApplication))
#define TERMINAL_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_APPLICATION, TerminalApplicationClass))
#define TERMINAL_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_APPLICATION))
#define TERMINAL_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_APPLICATION))
#define TERMINAL_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_APPLICATION, TerminalApplicationClass))

typedef struct _TerminalApplication TerminalApplication;
typedef struct _TerminalApplicationClass TerminalApplicationClass;
typedef struct _TerminalApplicationPrivate TerminalApplicationPrivate;
enum  {
	TERMINAL_APPLICATION_0_PROPERTY,
	TERMINAL_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* terminal_application_properties[TERMINAL_APPLICATION_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);

#define TERMINAL_TYPE_KEYMAP (terminal_keymap_get_type ())
#define TERMINAL_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_KEYMAP, TerminalKeymap))
#define TERMINAL_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_KEYMAP, TerminalKeymapClass))
#define TERMINAL_IS_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_KEYMAP))
#define TERMINAL_IS_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_KEYMAP))
#define TERMINAL_KEYMAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_KEYMAP, TerminalKeymapClass))

typedef struct _TerminalKeymap TerminalKeymap;
typedef struct _TerminalKeymapClass TerminalKeymapClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_TYPE_WINDOW (terminal_window_get_type ())
#define TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_WINDOW, TerminalWindow))
#define TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_WINDOW, TerminalWindowClass))
#define TERMINAL_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_WINDOW))
#define TERMINAL_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_WINDOW))
#define TERMINAL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_WINDOW, TerminalWindowClass))

typedef struct _TerminalWindow TerminalWindow;
typedef struct _TerminalWindowClass TerminalWindowClass;

#define TERMINAL_TYPE_COMMAND_LINE_OPTIONS (terminal_command_line_options_get_type ())
typedef struct _TerminalCommandLineOptions TerminalCommandLineOptions;

#define TERMINAL_TYPE_TERMINAL (terminal_terminal_get_type ())
#define TERMINAL_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminal))
#define TERMINAL_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))
#define TERMINAL_IS_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_IS_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_TERMINAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))

typedef struct _TerminalTerminal TerminalTerminal;
typedef struct _TerminalTerminalClass TerminalTerminalClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TerminalApplication {
	AdwApplication parent_instance;
	TerminalApplicationPrivate * priv;
};

struct _TerminalApplicationClass {
	AdwApplicationClass parent_class;
};

struct _TerminalApplicationPrivate {
	GActionEntry* ACTIONS;
	gint ACTIONS_length1;
	gint _ACTIONS_size_;
};

struct _TerminalCommandLineOptions {
	gchar* command;
	gchar* current_working_dir;
	gboolean version;
	gboolean help;
};

static gint TerminalApplication_private_offset;
static gpointer terminal_application_parent_class = NULL;

VALA_EXTERN GType terminal_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalApplication, g_object_unref)
static void terminal_application_on_focus_next_tab (TerminalApplication* self);
static void _terminal_application_on_focus_next_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void terminal_application_on_focus_previous_tab (TerminalApplication* self);
static void _terminal_application_on_focus_previous_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void terminal_application_on_new_window (TerminalApplication* self);
static void _terminal_application_on_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void terminal_application_on_about (TerminalApplication* self);
static void _terminal_application_on_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
VALA_EXTERN TerminalApplication* terminal_application_new (void);
VALA_EXTERN TerminalApplication* terminal_application_construct (GType object_type);
VALA_EXTERN GType terminal_keymap_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalKeymap, g_object_unref)
VALA_EXTERN TerminalKeymap* terminal_keymap_get_default (void);
VALA_EXTERN void terminal_keymap_apply (TerminalKeymap* self,
                            GtkApplication* app);
static void terminal_application_real_activate (GApplication* base);
VALA_EXTERN GType terminal_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalWindow, g_object_unref)
VALA_EXTERN TerminalWindow* terminal_window_new (GtkApplication* app,
                                     const gchar* command,
                                     const gchar* cwd,
                                     gboolean skip_initial_tab);
VALA_EXTERN TerminalWindow* terminal_window_construct (GType object_type,
                                           GtkApplication* app,
                                           const gchar* command,
                                           const gchar* cwd,
                                           gboolean skip_initial_tab);
static gint terminal_application_real_command_line (GApplication* base,
                                             GApplicationCommandLine* cmd);
VALA_EXTERN GType terminal_command_line_options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalCommandLineOptions* terminal_command_line_options_dup (const TerminalCommandLineOptions* self);
VALA_EXTERN void terminal_command_line_options_free (TerminalCommandLineOptions* self);
VALA_EXTERN void terminal_command_line_options_copy (const TerminalCommandLineOptions* self,
                                         TerminalCommandLineOptions* dest);
VALA_EXTERN void terminal_command_line_options_destroy (TerminalCommandLineOptions* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TerminalCommandLineOptions, terminal_command_line_options_destroy)
VALA_EXTERN gboolean terminal_command_line_parse_command_line (GApplicationCommandLine* cmd,
                                                   TerminalCommandLineOptions* options);
VALA_EXTERN AdwAboutWindow* terminal_create_about_dialog (void);
VALA_EXTERN GType terminal_terminal_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalTerminal, g_object_unref)
VALA_EXTERN TerminalTerminal* terminal_window_get_active_terminal (TerminalWindow* self);
VALA_EXTERN gchar* terminal_terminal_get_current_working_directory_for_new_session (TerminalTerminal* previous_terminal);
VALA_EXTERN void terminal_window_focus_next_tab (TerminalWindow* self);
VALA_EXTERN void terminal_window_focus_previous_tab (TerminalWindow* self);
static void terminal_application_finalize (GObject * obj);
static GType terminal_application_get_type_once (void);

static inline gpointer
terminal_application_get_instance_private (TerminalApplication* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalApplication_private_offset);
}

static void
_terminal_application_on_focus_next_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 22 "../src/Application.vala"
	terminal_application_on_focus_next_tab ((TerminalApplication*) self);
#line 198 "Application.c"
}

static void
_terminal_application_on_focus_previous_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 22 "../src/Application.vala"
	terminal_application_on_focus_previous_tab ((TerminalApplication*) self);
#line 208 "Application.c"
}

static void
_terminal_application_on_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 22 "../src/Application.vala"
	terminal_application_on_new_window ((TerminalApplication*) self);
#line 218 "Application.c"
}

static void
_terminal_application_on_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 22 "../src/Application.vala"
	terminal_application_on_about ((TerminalApplication*) self);
#line 228 "Application.c"
}

TerminalApplication*
terminal_application_construct (GType object_type)
{
	TerminalApplication * self = NULL;
	GActionEntry* _tmp0_;
	gint _tmp0__length1;
	TerminalKeymap* keymap = NULL;
	TerminalKeymap* _tmp1_;
#line 31 "../src/Application.vala"
	self = (TerminalApplication*) g_object_new (object_type, "application-id", "com.raggesilver.BlackBox", "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
#line 36 "../src/Application.vala"
	setlocale (LC_ALL, "");
#line 37 "../src/Application.vala"
	textdomain (TERMINAL_GETTEXT_PACKAGE);
#line 38 "../src/Application.vala"
	bindtextdomain (TERMINAL_GETTEXT_PACKAGE, TERMINAL_LOCALEDIR);
#line 39 "../src/Application.vala"
	bind_textdomain_codeset (TERMINAL_GETTEXT_PACKAGE, "UTF-8");
#line 41 "../src/Application.vala"
	_tmp0_ = self->priv->ACTIONS;
#line 41 "../src/Application.vala"
	_tmp0__length1 = self->priv->ACTIONS_length1;
#line 41 "../src/Application.vala"
	g_action_map_add_action_entries ((GActionMap*) self, _tmp0_, (gint) _tmp0__length1, self);
#line 43 "../src/Application.vala"
	_tmp1_ = terminal_keymap_get_default ();
#line 43 "../src/Application.vala"
	keymap = _tmp1_;
#line 44 "../src/Application.vala"
	terminal_keymap_apply (keymap, (GtkApplication*) self);
#line 30 "../src/Application.vala"
	_g_object_unref0 (keymap);
#line 30 "../src/Application.vala"
	return self;
#line 265 "Application.c"
}

TerminalApplication*
terminal_application_new (void)
{
#line 30 "../src/Application.vala"
	return terminal_application_construct (TERMINAL_TYPE_APPLICATION);
#line 273 "Application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "../src/Application.vala"
	return self ? g_object_ref (self) : NULL;
#line 281 "Application.c"
}

static void
terminal_application_real_activate (GApplication* base)
{
	TerminalApplication * self;
	GList* _tmp0_;
	TerminalWindow* _tmp4_;
	TerminalWindow* _tmp5_;
#line 47 "../src/Application.vala"
	self = (TerminalApplication*) base;
#line 49 "../src/Application.vala"
	_tmp0_ = gtk_application_get_windows ((GtkApplication*) self);
#line 295 "Application.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 49 "../src/Application.vala"
		window_collection = _tmp0_;
#line 49 "../src/Application.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 303 "Application.c"
			GtkWindow* _tmp1_;
			GtkWindow* window = NULL;
#line 49 "../src/Application.vala"
			_tmp1_ = _g_object_ref0 ((GtkWindow*) window_it->data);
#line 49 "../src/Application.vala"
			window = _tmp1_;
#line 310 "Application.c"
			{
				GtkWindow* _tmp2_;
#line 50 "../src/Application.vala"
				_tmp2_ = window;
#line 50 "../src/Application.vala"
				if (TERMINAL_IS_WINDOW (_tmp2_)) {
#line 317 "Application.c"
					GtkWindow* _tmp3_;
#line 53 "../src/Application.vala"
					_tmp3_ = window;
#line 53 "../src/Application.vala"
					gtk_window_present (_tmp3_);
#line 54 "../src/Application.vala"
					_g_object_unref0 (window);
#line 54 "../src/Application.vala"
					return;
#line 327 "Application.c"
				}
#line 49 "../src/Application.vala"
				_g_object_unref0 (window);
#line 331 "Application.c"
			}
		}
	}
#line 58 "../src/Application.vala"
	_tmp4_ = terminal_window_new ((GtkApplication*) self, NULL, NULL, FALSE);
#line 58 "../src/Application.vala"
	g_object_ref_sink (_tmp4_);
#line 58 "../src/Application.vala"
	_tmp5_ = _tmp4_;
#line 58 "../src/Application.vala"
	gtk_widget_show ((GtkWidget*) _tmp5_);
#line 58 "../src/Application.vala"
	_g_object_unref0 (_tmp5_);
#line 345 "Application.c"
}

static gint
terminal_application_real_command_line (GApplication* base,
                                        GApplicationCommandLine* cmd)
{
	TerminalApplication * self;
	TerminalCommandLineOptions options = {0};
	TerminalCommandLineOptions _tmp0_ = {0};
	gboolean _tmp1_;
	gint result;
#line 61 "../src/Application.vala"
	self = (TerminalApplication*) base;
#line 61 "../src/Application.vala"
	g_return_val_if_fail (cmd != NULL, 0);
#line 64 "../src/Application.vala"
	g_application_hold ((GApplication*) self);
#line 66 "../src/Application.vala"
	_tmp1_ = terminal_command_line_parse_command_line (cmd, &_tmp0_);
#line 66 "../src/Application.vala"
	terminal_command_line_options_destroy (&options);
#line 66 "../src/Application.vala"
	options = _tmp0_;
#line 66 "../src/Application.vala"
	if (!_tmp1_) {
#line 67 "../src/Application.vala"
		g_application_release ((GApplication*) self);
#line 68 "../src/Application.vala"
		result = -1;
#line 68 "../src/Application.vala"
		terminal_command_line_options_destroy (&options);
#line 68 "../src/Application.vala"
		return result;
#line 379 "Application.c"
	} else {
		TerminalCommandLineOptions _tmp2_;
#line 70 "../src/Application.vala"
		_tmp2_ = options;
#line 70 "../src/Application.vala"
		if (_tmp2_.help) {
#line 386 "Application.c"
		} else {
			TerminalCommandLineOptions _tmp3_;
#line 73 "../src/Application.vala"
			_tmp3_ = options;
#line 73 "../src/Application.vala"
			if (_tmp3_.version) {
#line 74 "../src/Application.vala"
				g_application_command_line_print (cmd, "%s version %s%s\n", TERMINAL_APP_NAME, TERMINAL_VERSION, " (flatpak)");
#line 395 "Application.c"
			} else {
				TerminalCommandLineOptions _tmp4_;
				const gchar* _tmp5_;
				TerminalCommandLineOptions _tmp6_;
				const gchar* _tmp7_;
				TerminalWindow* _tmp8_;
				TerminalWindow* _tmp9_;
#line 86 "../src/Application.vala"
				_tmp4_ = options;
#line 86 "../src/Application.vala"
				_tmp5_ = _tmp4_.command;
#line 86 "../src/Application.vala"
				_tmp6_ = options;
#line 86 "../src/Application.vala"
				_tmp7_ = _tmp6_.current_working_dir;
#line 86 "../src/Application.vala"
				_tmp8_ = terminal_window_new ((GtkApplication*) self, _tmp5_, _tmp7_, FALSE);
#line 86 "../src/Application.vala"
				g_object_ref_sink (_tmp8_);
#line 86 "../src/Application.vala"
				_tmp9_ = _tmp8_;
#line 86 "../src/Application.vala"
				gtk_widget_show ((GtkWidget*) _tmp9_);
#line 86 "../src/Application.vala"
				_g_object_unref0 (_tmp9_);
#line 421 "Application.c"
			}
		}
	}
#line 93 "../src/Application.vala"
	g_application_release ((GApplication*) self);
#line 94 "../src/Application.vala"
	result = 0;
#line 94 "../src/Application.vala"
	terminal_command_line_options_destroy (&options);
#line 94 "../src/Application.vala"
	return result;
#line 433 "Application.c"
}

static void
terminal_application_on_about (TerminalApplication* self)
{
	GtkWindow* win = NULL;
	AdwAboutWindow* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
#line 102 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/Application.vala"
	_tmp0_ = terminal_create_about_dialog ();
#line 103 "../src/Application.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL;
#line 103 "../src/Application.vala"
	if (_tmp1_ == NULL) {
#line 103 "../src/Application.vala"
		_g_object_unref0 (_tmp0_);
#line 453 "Application.c"
	}
#line 103 "../src/Application.vala"
	win = _tmp1_;
#line 104 "../src/Application.vala"
	_tmp2_ = gtk_application_get_active_window ((GtkApplication*) self);
#line 104 "../src/Application.vala"
	gtk_window_set_transient_for (win, _tmp2_);
#line 105 "../src/Application.vala"
	gtk_widget_show ((GtkWidget*) win);
#line 102 "../src/Application.vala"
	_g_object_unref0 (win);
#line 465 "Application.c"
}

static void
terminal_application_on_new_window (TerminalApplication* self)
{
	GtkWindow* w = NULL;
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	TerminalTerminal* _tmp2_ = NULL;
	GtkWindow* _tmp3_;
	TerminalTerminal* active_terminal = NULL;
	TerminalTerminal* _tmp7_;
	gchar* cwd = NULL;
	gchar* _tmp8_;
	TerminalWindow* _tmp9_;
	TerminalWindow* _tmp10_;
#line 108 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/Application.vala"
	_tmp0_ = gtk_application_get_active_window ((GtkApplication*) self);
#line 113 "../src/Application.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 113 "../src/Application.vala"
	w = _tmp1_;
#line 114 "../src/Application.vala"
	_tmp3_ = w;
#line 114 "../src/Application.vala"
	if (TERMINAL_IS_WINDOW (_tmp3_)) {
#line 494 "Application.c"
		GtkWindow* _tmp4_;
		TerminalTerminal* _tmp5_;
		TerminalTerminal* _tmp6_;
#line 114 "../src/Application.vala"
		_tmp4_ = w;
#line 114 "../src/Application.vala"
		_tmp5_ = terminal_window_get_active_terminal ((TerminalWindow*) _tmp4_);
#line 114 "../src/Application.vala"
		_tmp6_ = _tmp5_;
#line 114 "../src/Application.vala"
		_tmp2_ = _tmp6_;
#line 506 "Application.c"
	} else {
#line 114 "../src/Application.vala"
		_tmp2_ = NULL;
#line 510 "Application.c"
	}
#line 114 "../src/Application.vala"
	_tmp7_ = _g_object_ref0 (_tmp2_);
#line 114 "../src/Application.vala"
	active_terminal = _tmp7_;
#line 116 "../src/Application.vala"
	_tmp8_ = terminal_terminal_get_current_working_directory_for_new_session (active_terminal);
#line 116 "../src/Application.vala"
	cwd = _tmp8_;
#line 119 "../src/Application.vala"
	_tmp9_ = terminal_window_new ((GtkApplication*) self, NULL, cwd, FALSE);
#line 119 "../src/Application.vala"
	g_object_ref_sink (_tmp9_);
#line 119 "../src/Application.vala"
	_tmp10_ = _tmp9_;
#line 119 "../src/Application.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 119 "../src/Application.vala"
	_g_object_unref0 (_tmp10_);
#line 108 "../src/Application.vala"
	_g_free0 (cwd);
#line 108 "../src/Application.vala"
	_g_object_unref0 (active_terminal);
#line 108 "../src/Application.vala"
	_g_object_unref0 (w);
#line 536 "Application.c"
}

static void
terminal_application_on_focus_next_tab (TerminalApplication* self)
{
	TerminalWindow* _tmp0_ = NULL;
	GtkWindow* _tmp1_;
#line 122 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/Application.vala"
	_tmp1_ = gtk_application_get_active_window ((GtkApplication*) self);
#line 123 "../src/Application.vala"
	_tmp0_ = TERMINAL_IS_WINDOW (_tmp1_) ? ((TerminalWindow*) _tmp1_) : NULL;
#line 123 "../src/Application.vala"
	if (_tmp0_ != NULL) {
#line 123 "../src/Application.vala"
		terminal_window_focus_next_tab (_tmp0_);
#line 554 "Application.c"
	}
}

static void
terminal_application_on_focus_previous_tab (TerminalApplication* self)
{
	TerminalWindow* _tmp0_ = NULL;
	GtkWindow* _tmp1_;
#line 126 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/Application.vala"
	_tmp1_ = gtk_application_get_active_window ((GtkApplication*) self);
#line 127 "../src/Application.vala"
	_tmp0_ = TERMINAL_IS_WINDOW (_tmp1_) ? ((TerminalWindow*) _tmp1_) : NULL;
#line 127 "../src/Application.vala"
	if (_tmp0_ != NULL) {
#line 127 "../src/Application.vala"
		terminal_window_focus_previous_tab (_tmp0_);
#line 573 "Application.c"
	}
}

static void
terminal_application_class_init (TerminalApplicationClass * klass,
                                 gpointer klass_data)
{
#line 21 "../src/Application.vala"
	terminal_application_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Application.vala"
	g_type_class_adjust_private_offset (klass, &TerminalApplication_private_offset);
#line 21 "../src/Application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) terminal_application_real_activate;
#line 21 "../src/Application.vala"
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) terminal_application_real_command_line;
#line 21 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_application_finalize;
#line 591 "Application.c"
}

static void
terminal_application_instance_init (TerminalApplication * self,
                                    gpointer klass)
{
	GActionEntry _tmp0_ = {0};
	GActionEntry _tmp1_ = {0};
	GActionEntry _tmp2_ = {0};
	GActionEntry _tmp3_ = {0};
	GActionEntry* _tmp4_;
#line 21 "../src/Application.vala"
	self->priv = terminal_application_get_instance_private (self);
#line 22 "../src/Application.vala"
	memset (&_tmp0_, 0, sizeof (GActionEntry));
#line 22 "../src/Application.vala"
	_tmp0_.name = "focus-next-tab";
#line 22 "../src/Application.vala"
	_tmp0_.activate = _terminal_application_on_focus_next_tab_gsimple_action_activate_callback;
#line 22 "../src/Application.vala"
	memset (&_tmp1_, 0, sizeof (GActionEntry));
#line 22 "../src/Application.vala"
	_tmp1_.name = "focus-previous-tab";
#line 22 "../src/Application.vala"
	_tmp1_.activate = _terminal_application_on_focus_previous_tab_gsimple_action_activate_callback;
#line 22 "../src/Application.vala"
	memset (&_tmp2_, 0, sizeof (GActionEntry));
#line 22 "../src/Application.vala"
	_tmp2_.name = "new-window";
#line 22 "../src/Application.vala"
	_tmp2_.activate = _terminal_application_on_new_window_gsimple_action_activate_callback;
#line 22 "../src/Application.vala"
	memset (&_tmp3_, 0, sizeof (GActionEntry));
#line 22 "../src/Application.vala"
	_tmp3_.name = "about";
#line 22 "../src/Application.vala"
	_tmp3_.activate = _terminal_application_on_about_gsimple_action_activate_callback;
#line 22 "../src/Application.vala"
	_tmp4_ = g_new0 (GActionEntry, 4);
#line 22 "../src/Application.vala"
	_tmp4_[0] = _tmp0_;
#line 22 "../src/Application.vala"
	_tmp4_[1] = _tmp1_;
#line 22 "../src/Application.vala"
	_tmp4_[2] = _tmp2_;
#line 22 "../src/Application.vala"
	_tmp4_[3] = _tmp3_;
#line 22 "../src/Application.vala"
	self->priv->ACTIONS = _tmp4_;
#line 22 "../src/Application.vala"
	self->priv->ACTIONS_length1 = 4;
#line 22 "../src/Application.vala"
	self->priv->_ACTIONS_size_ = self->priv->ACTIONS_length1;
#line 645 "Application.c"
}

static void
terminal_application_finalize (GObject * obj)
{
	TerminalApplication * self;
#line 21 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_APPLICATION, TerminalApplication);
#line 22 "../src/Application.vala"
	self->priv->ACTIONS = (g_free (self->priv->ACTIONS), NULL);
#line 21 "../src/Application.vala"
	G_OBJECT_CLASS (terminal_application_parent_class)->finalize (obj);
#line 658 "Application.c"
}

static GType
terminal_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalApplication), 0, (GInstanceInitFunc) terminal_application_instance_init, NULL };
	GType terminal_application_type_id;
	terminal_application_type_id = g_type_register_static (adw_application_get_type (), "TerminalApplication", &g_define_type_info, 0);
	TerminalApplication_private_offset = g_type_add_instance_private (terminal_application_type_id, sizeof (TerminalApplicationPrivate));
	return terminal_application_type_id;
}

GType
terminal_application_get_type (void)
{
	static volatile gsize terminal_application_type_id__once = 0;
	if (g_once_init_enter (&terminal_application_type_id__once)) {
		GType terminal_application_type_id;
		terminal_application_type_id = terminal_application_get_type_once ();
		g_once_init_leave (&terminal_application_type_id__once, terminal_application_type_id);
	}
	return terminal_application_type_id__once;
}

