/* CommandLine.c generated by valac 0.56.13, the Vala compiler
 * generated from CommandLine.vala, do not modify */

/* CommandLine.vala
 *
 * Copyright 2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_COMMAND_LINE_OPTIONS (terminal_command_line_options_get_type ())
typedef struct _TerminalCommandLineOptions TerminalCommandLineOptions;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TERMINAL_TYPE_COMMAND_LINE (terminal_command_line_get_type ())
#define TERMINAL_COMMAND_LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_COMMAND_LINE, TerminalCommandLine))
#define TERMINAL_COMMAND_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_COMMAND_LINE, TerminalCommandLineClass))
#define TERMINAL_IS_COMMAND_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_COMMAND_LINE))
#define TERMINAL_IS_COMMAND_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_COMMAND_LINE))
#define TERMINAL_COMMAND_LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_COMMAND_LINE, TerminalCommandLineClass))

typedef struct _TerminalCommandLine TerminalCommandLine;
typedef struct _TerminalCommandLineClass TerminalCommandLineClass;
typedef struct _TerminalCommandLinePrivate TerminalCommandLinePrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
typedef struct _TerminalParamSpecCommandLine TerminalParamSpecCommandLine;

struct _TerminalCommandLineOptions {
	gchar* command;
	gchar* current_working_dir;
	gboolean version;
	gboolean help;
};

struct _TerminalCommandLine {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TerminalCommandLinePrivate * priv;
};

struct _TerminalCommandLineClass {
	GTypeClass parent_class;
	void (*finalize) (TerminalCommandLine *self);
};

struct _TerminalParamSpecCommandLine {
	GParamSpec parent_instance;
};

static gpointer terminal_command_line_parent_class = NULL;

VALA_EXTERN GType terminal_command_line_options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalCommandLineOptions* terminal_command_line_options_dup (const TerminalCommandLineOptions* self);
VALA_EXTERN void terminal_command_line_options_free (TerminalCommandLineOptions* self);
VALA_EXTERN void terminal_command_line_options_copy (const TerminalCommandLineOptions* self,
                                         TerminalCommandLineOptions* dest);
VALA_EXTERN void terminal_command_line_options_destroy (TerminalCommandLineOptions* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TerminalCommandLineOptions, terminal_command_line_options_destroy)
VALA_EXTERN gpointer terminal_command_line_ref (gpointer instance);
VALA_EXTERN void terminal_command_line_unref (gpointer instance);
VALA_EXTERN GParamSpec* terminal_param_spec_command_line (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
VALA_EXTERN void terminal_value_set_command_line (GValue* value,
                                      gpointer v_object);
VALA_EXTERN void terminal_value_take_command_line (GValue* value,
                                       gpointer v_object);
VALA_EXTERN gpointer terminal_value_get_command_line (const GValue* value);
VALA_EXTERN GType terminal_command_line_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalCommandLine, terminal_command_line_unref)
VALA_EXTERN gboolean terminal_command_line_parse_command_line (GApplicationCommandLine* cmd,
                                                   TerminalCommandLineOptions* options);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN TerminalCommandLine* terminal_command_line_new (void);
VALA_EXTERN TerminalCommandLine* terminal_command_line_construct (GType object_type);
static void terminal_command_line_finalize (TerminalCommandLine * obj);
static GType terminal_command_line_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
terminal_command_line_options_copy (const TerminalCommandLineOptions* self,
                                    TerminalCommandLineOptions* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 21 "../src/CommandLine.vala"
	_tmp0_ = (*self).command;
#line 21 "../src/CommandLine.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 21 "../src/CommandLine.vala"
	_g_free0 ((*dest).command);
#line 21 "../src/CommandLine.vala"
	(*dest).command = _tmp1_;
#line 21 "../src/CommandLine.vala"
	_tmp2_ = (*self).current_working_dir;
#line 21 "../src/CommandLine.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 21 "../src/CommandLine.vala"
	_g_free0 ((*dest).current_working_dir);
#line 21 "../src/CommandLine.vala"
	(*dest).current_working_dir = _tmp3_;
#line 21 "../src/CommandLine.vala"
	(*dest).version = (*self).version;
#line 21 "../src/CommandLine.vala"
	(*dest).help = (*self).help;
#line 155 "CommandLine.c"
}

void
terminal_command_line_options_destroy (TerminalCommandLineOptions* self)
{
#line 22 "../src/CommandLine.vala"
	_g_free0 ((*self).command);
#line 23 "../src/CommandLine.vala"
	_g_free0 ((*self).current_working_dir);
#line 165 "CommandLine.c"
}

TerminalCommandLineOptions*
terminal_command_line_options_dup (const TerminalCommandLineOptions* self)
{
	TerminalCommandLineOptions* dup;
#line 21 "../src/CommandLine.vala"
	dup = g_new0 (TerminalCommandLineOptions, 1);
#line 21 "../src/CommandLine.vala"
	terminal_command_line_options_copy (self, dup);
#line 21 "../src/CommandLine.vala"
	return dup;
#line 178 "CommandLine.c"
}

void
terminal_command_line_options_free (TerminalCommandLineOptions* self)
{
#line 21 "../src/CommandLine.vala"
	terminal_command_line_options_destroy (self);
#line 21 "../src/CommandLine.vala"
	g_free (self);
#line 188 "CommandLine.c"
}

static GType
terminal_command_line_options_get_type_once (void)
{
	GType terminal_command_line_options_type_id;
	terminal_command_line_options_type_id = g_boxed_type_register_static ("TerminalCommandLineOptions", (GBoxedCopyFunc) terminal_command_line_options_dup, (GBoxedFreeFunc) terminal_command_line_options_free);
	return terminal_command_line_options_type_id;
}

GType
terminal_command_line_options_get_type (void)
{
	static volatile gsize terminal_command_line_options_type_id__once = 0;
	if (g_once_init_enter (&terminal_command_line_options_type_id__once)) {
		GType terminal_command_line_options_type_id;
		terminal_command_line_options_type_id = terminal_command_line_options_get_type_once ();
		g_once_init_leave (&terminal_command_line_options_type_id__once, terminal_command_line_options_type_id);
	}
	return terminal_command_line_options_type_id__once;
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 98 "../src/CommandLine.vala"
	if ((*length) == (*size)) {
#line 98 "../src/CommandLine.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 98 "../src/CommandLine.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 223 "CommandLine.c"
	}
#line 98 "../src/CommandLine.vala"
	(*array)[(*length)++] = value;
#line 98 "../src/CommandLine.vala"
	(*array)[*length] = NULL;
#line 229 "CommandLine.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 104 "../src/CommandLine.vala"
	if ((*length) == (*size)) {
#line 104 "../src/CommandLine.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 104 "../src/CommandLine.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 244 "CommandLine.c"
	}
#line 104 "../src/CommandLine.vala"
	(*array)[(*length)++] = value;
#line 104 "../src/CommandLine.vala"
	(*array)[*length] = NULL;
#line 250 "CommandLine.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 264 "CommandLine.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 268 "CommandLine.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 274 "CommandLine.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 279 "CommandLine.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 285 "CommandLine.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 289 "CommandLine.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 293 "CommandLine.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 297 "CommandLine.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 301 "CommandLine.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 305 "CommandLine.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 320 "CommandLine.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 329 "CommandLine.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 336 "CommandLine.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 342 "CommandLine.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 350 "CommandLine.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 354 "CommandLine.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 360 "CommandLine.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 365 "CommandLine.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 371 "CommandLine.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 375 "CommandLine.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 379 "CommandLine.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 385 "CommandLine.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 391 "CommandLine.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 403 "CommandLine.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 407 "CommandLine.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 411 "CommandLine.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 416 "CommandLine.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 424 "CommandLine.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 442 "CommandLine.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 448 "CommandLine.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 452 "CommandLine.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 460 "CommandLine.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 469 "CommandLine.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 478 "CommandLine.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 484 "CommandLine.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 492 "CommandLine.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 504 "CommandLine.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 510 "CommandLine.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 514 "CommandLine.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 522 "CommandLine.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 533 "CommandLine.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 542 "CommandLine.c"
	}
}

gboolean
terminal_command_line_parse_command_line (GApplicationCommandLine* cmd,
                                          TerminalCommandLineOptions* options)
{
	TerminalCommandLineOptions _vala_options = {0};
	TerminalCommandLineOptions _tmp0_ = {0};
	GOptionEntry* option_entries = NULL;
	GOptionEntry _tmp1_ = {0};
	GOptionEntry _tmp2_ = {0};
	GOptionEntry _tmp3_ = {0};
	GOptionEntry _tmp4_ = {0};
	GOptionEntry* _tmp5_;
	gint option_entries_length1;
	gint _option_entries_size_;
	GOptionContext* ctx = NULL;
	GOptionContext* _tmp6_;
	GOptionContext* _tmp7_;
	GOptionContext* _tmp8_;
	GOptionEntry* _tmp9_;
	gint _tmp9__length1;
	gchar** original_argv = NULL;
	gint _tmp10_ = 0;
	gchar** _tmp11_;
	gint original_argv_length1;
	gint _original_argv_size_;
	gchar** real_argv = NULL;
	gchar** _tmp12_;
	gint real_argv_length1;
	gint _real_argv_size_;
	gchar** commandv = NULL;
	gchar** _tmp13_;
	gint commandv_length1;
	gint _commandv_size_;
	gboolean dd = FALSE;
	gchar** _tmp14_;
	gint _tmp14__length1;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 38 "../src/CommandLine.vala"
	g_return_val_if_fail (cmd != NULL, FALSE);
#line 41 "../src/CommandLine.vala"
	terminal_command_line_options_destroy (&_vala_options);
#line 41 "../src/CommandLine.vala"
	_vala_options = _tmp0_;
#line 43 "../src/CommandLine.vala"
	memset (&_tmp1_, 0, sizeof (GOptionEntry));
#line 43 "../src/CommandLine.vala"
	_tmp1_.long_name = "version";
#line 43 "../src/CommandLine.vala"
	_tmp1_.short_name = 'v';
#line 43 "../src/CommandLine.vala"
	_tmp1_.description = _ ("Show app version");
#line 43 "../src/CommandLine.vala"
	_tmp1_.flags = (gint) G_OPTION_FLAG_NONE;
#line 43 "../src/CommandLine.vala"
	_tmp1_.arg = G_OPTION_ARG_NONE;
#line 43 "../src/CommandLine.vala"
	_tmp1_.arg_data = &_vala_options.version;
#line 43 "../src/CommandLine.vala"
	_tmp1_.arg_description = NULL;
#line 43 "../src/CommandLine.vala"
	memset (&_tmp2_, 0, sizeof (GOptionEntry));
#line 43 "../src/CommandLine.vala"
	_tmp2_.long_name = "working-directory";
#line 43 "../src/CommandLine.vala"
	_tmp2_.short_name = 'w';
#line 43 "../src/CommandLine.vala"
	_tmp2_.description = _ ("Set current working directory");
#line 43 "../src/CommandLine.vala"
	_tmp2_.flags = (gint) G_OPTION_FLAG_NONE;
#line 43 "../src/CommandLine.vala"
	_tmp2_.arg = G_OPTION_ARG_FILENAME;
#line 43 "../src/CommandLine.vala"
	_tmp2_.arg_data = &_vala_options.current_working_dir;
#line 43 "../src/CommandLine.vala"
	_tmp2_.arg_description = NULL;
#line 43 "../src/CommandLine.vala"
	memset (&_tmp3_, 0, sizeof (GOptionEntry));
#line 43 "../src/CommandLine.vala"
	_tmp3_.long_name = "command";
#line 43 "../src/CommandLine.vala"
	_tmp3_.short_name = 'c';
#line 43 "../src/CommandLine.vala"
	_tmp3_.description = _ ("Execute command in a terminal");
#line 43 "../src/CommandLine.vala"
	_tmp3_.flags = (gint) G_OPTION_FLAG_NONE;
#line 43 "../src/CommandLine.vala"
	_tmp3_.arg = G_OPTION_ARG_STRING;
#line 43 "../src/CommandLine.vala"
	_tmp3_.arg_data = &_vala_options.command;
#line 43 "../src/CommandLine.vala"
	_tmp3_.arg_description = NULL;
#line 43 "../src/CommandLine.vala"
	memset (&_tmp4_, 0, sizeof (GOptionEntry));
#line 43 "../src/CommandLine.vala"
	_tmp4_.long_name = "help";
#line 43 "../src/CommandLine.vala"
	_tmp4_.short_name = 'h';
#line 43 "../src/CommandLine.vala"
	_tmp4_.description = _ ("Show help");
#line 43 "../src/CommandLine.vala"
	_tmp4_.flags = (gint) G_OPTION_FLAG_NONE;
#line 43 "../src/CommandLine.vala"
	_tmp4_.arg = G_OPTION_ARG_NONE;
#line 43 "../src/CommandLine.vala"
	_tmp4_.arg_data = &_vala_options.help;
#line 43 "../src/CommandLine.vala"
	_tmp4_.arg_description = NULL;
#line 43 "../src/CommandLine.vala"
	_tmp5_ = g_new0 (GOptionEntry, 4);
#line 43 "../src/CommandLine.vala"
	_tmp5_[0] = _tmp1_;
#line 43 "../src/CommandLine.vala"
	_tmp5_[1] = _tmp2_;
#line 43 "../src/CommandLine.vala"
	_tmp5_[2] = _tmp3_;
#line 43 "../src/CommandLine.vala"
	_tmp5_[3] = _tmp4_;
#line 43 "../src/CommandLine.vala"
	option_entries = _tmp5_;
#line 43 "../src/CommandLine.vala"
	option_entries_length1 = 4;
#line 43 "../src/CommandLine.vala"
	_option_entries_size_ = option_entries_length1;
#line 82 "../src/CommandLine.vala"
	_tmp6_ = g_option_context_new ("[-- COMMAND ...]");
#line 82 "../src/CommandLine.vala"
	ctx = _tmp6_;
#line 86 "../src/CommandLine.vala"
	_tmp7_ = ctx;
#line 86 "../src/CommandLine.vala"
	g_option_context_set_help_enabled (_tmp7_, FALSE);
#line 87 "../src/CommandLine.vala"
	_tmp8_ = ctx;
#line 87 "../src/CommandLine.vala"
	_tmp9_ = option_entries;
#line 87 "../src/CommandLine.vala"
	_tmp9__length1 = option_entries_length1;
#line 87 "../src/CommandLine.vala"
	g_option_context_add_main_entries (_tmp8_, _tmp9_, NULL);
#line 89 "../src/CommandLine.vala"
	_tmp11_ = g_application_command_line_get_arguments (cmd, &_tmp10_);
#line 89 "../src/CommandLine.vala"
	original_argv = _tmp11_;
#line 89 "../src/CommandLine.vala"
	original_argv_length1 = _tmp10_;
#line 89 "../src/CommandLine.vala"
	_original_argv_size_ = original_argv_length1;
#line 90 "../src/CommandLine.vala"
	_tmp12_ = g_new0 (gchar*, 0 + 1);
#line 90 "../src/CommandLine.vala"
	real_argv = _tmp12_;
#line 90 "../src/CommandLine.vala"
	real_argv_length1 = 0;
#line 90 "../src/CommandLine.vala"
	_real_argv_size_ = real_argv_length1;
#line 91 "../src/CommandLine.vala"
	_tmp13_ = g_new0 (gchar*, 0 + 1);
#line 91 "../src/CommandLine.vala"
	commandv = _tmp13_;
#line 91 "../src/CommandLine.vala"
	commandv_length1 = 0;
#line 91 "../src/CommandLine.vala"
	_commandv_size_ = commandv_length1;
#line 92 "../src/CommandLine.vala"
	dd = FALSE;
#line 96 "../src/CommandLine.vala"
	_tmp14_ = original_argv;
#line 96 "../src/CommandLine.vala"
	_tmp14__length1 = original_argv_length1;
#line 716 "CommandLine.c"
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
#line 96 "../src/CommandLine.vala"
		s_collection = _tmp14_;
#line 96 "../src/CommandLine.vala"
		s_collection_length1 = _tmp14__length1;
#line 96 "../src/CommandLine.vala"
		for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 728 "CommandLine.c"
			const gchar* s = NULL;
#line 96 "../src/CommandLine.vala"
			s = s_collection[s_it];
#line 732 "CommandLine.c"
			{
#line 97 "../src/CommandLine.vala"
				if (dd) {
#line 736 "CommandLine.c"
					const gchar* _tmp15_;
					gchar* _tmp16_;
#line 98 "../src/CommandLine.vala"
					_tmp15_ = s;
#line 98 "../src/CommandLine.vala"
					_tmp16_ = g_strdup (_tmp15_);
#line 98 "../src/CommandLine.vala"
					_vala_array_add1 (&commandv, &commandv_length1, &_commandv_size_, _tmp16_);
#line 745 "CommandLine.c"
				} else {
					const gchar* _tmp17_;
#line 100 "../src/CommandLine.vala"
					_tmp17_ = s;
#line 100 "../src/CommandLine.vala"
					if (g_strcmp0 (_tmp17_, "--") == 0) {
#line 101 "../src/CommandLine.vala"
						dd = TRUE;
#line 754 "CommandLine.c"
					} else {
						const gchar* _tmp18_;
						gchar* _tmp19_;
#line 104 "../src/CommandLine.vala"
						_tmp18_ = s;
#line 104 "../src/CommandLine.vala"
						_tmp19_ = g_strdup (_tmp18_);
#line 104 "../src/CommandLine.vala"
						_vala_array_add2 (&real_argv, &real_argv_length1, &_real_argv_size_, _tmp19_);
#line 764 "CommandLine.c"
					}
				}
			}
		}
	}
	{
		GOptionContext* _tmp20_;
		TerminalCommandLineOptions _tmp21_;
		gboolean _tmp25_ = FALSE;
#line 109 "../src/CommandLine.vala"
		_tmp20_ = ctx;
#line 109 "../src/CommandLine.vala"
		g_option_context_parse_strv (_tmp20_, &real_argv, &_inner_error0_);
#line 109 "../src/CommandLine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 780 "CommandLine.c"
			goto __catch0_g_error;
		}
#line 111 "../src/CommandLine.vala"
		_tmp21_ = _vala_options;
#line 111 "../src/CommandLine.vala"
		if (_tmp21_.help) {
#line 787 "CommandLine.c"
			GOptionContext* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 112 "../src/CommandLine.vala"
			_tmp22_ = ctx;
#line 112 "../src/CommandLine.vala"
			_tmp23_ = g_option_context_get_help (_tmp22_, TRUE, NULL);
#line 112 "../src/CommandLine.vala"
			_tmp24_ = _tmp23_;
#line 112 "../src/CommandLine.vala"
			G_TYPE_INSTANCE_GET_CLASS (cmd, g_application_command_line_get_type (), GApplicationCommandLineClass)->print_literal (cmd, _tmp24_);
#line 112 "../src/CommandLine.vala"
			_g_free0 (_tmp24_);
#line 801 "CommandLine.c"
		}
#line 115 "../src/CommandLine.vala"
		if (dd) {
#line 805 "CommandLine.c"
			TerminalCommandLineOptions _tmp26_;
			const gchar* _tmp27_;
#line 115 "../src/CommandLine.vala"
			_tmp26_ = _vala_options;
#line 115 "../src/CommandLine.vala"
			_tmp27_ = _tmp26_.command;
#line 115 "../src/CommandLine.vala"
			_tmp25_ = _tmp27_ == NULL;
#line 814 "CommandLine.c"
		} else {
#line 115 "../src/CommandLine.vala"
			_tmp25_ = FALSE;
#line 818 "CommandLine.c"
		}
#line 115 "../src/CommandLine.vala"
		if (_tmp25_) {
#line 822 "CommandLine.c"
			gchar** _tmp28_;
			gint _tmp28__length1;
			gchar* _tmp29_;
#line 116 "../src/CommandLine.vala"
			_tmp28_ = commandv;
#line 116 "../src/CommandLine.vala"
			_tmp28__length1 = commandv_length1;
#line 116 "../src/CommandLine.vala"
			_tmp29_ = _vala_g_strjoinv (" ", _tmp28_, (gint) _tmp28__length1);
#line 116 "../src/CommandLine.vala"
			_g_free0 (_vala_options.command);
#line 116 "../src/CommandLine.vala"
			_vala_options.command = _tmp29_;
#line 836 "CommandLine.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
		gchar** _tmp32_;
		gint _tmp32__length1;
		const gchar* _tmp33_;
#line 108 "../src/CommandLine.vala"
		e = _inner_error0_;
#line 108 "../src/CommandLine.vala"
		_inner_error0_ = NULL;
#line 120 "../src/CommandLine.vala"
		_tmp30_ = e;
#line 120 "../src/CommandLine.vala"
		_tmp31_ = _tmp30_->message;
#line 120 "../src/CommandLine.vala"
		g_application_command_line_printerr (cmd, "%s\n", _tmp31_);
#line 121 "../src/CommandLine.vala"
		_tmp32_ = original_argv;
#line 121 "../src/CommandLine.vala"
		_tmp32__length1 = original_argv_length1;
#line 121 "../src/CommandLine.vala"
		_tmp33_ = _tmp32_[0];
#line 121 "../src/CommandLine.vala"
		g_application_command_line_printerr (cmd, _ ("Run %s --help to get help\n"), _tmp33_);
#line 122 "../src/CommandLine.vala"
		result = FALSE;
#line 122 "../src/CommandLine.vala"
		_g_error_free0 (e);
#line 122 "../src/CommandLine.vala"
		commandv = (_vala_array_free (commandv, commandv_length1, (GDestroyNotify) g_free), NULL);
#line 122 "../src/CommandLine.vala"
		real_argv = (_vala_array_free (real_argv, real_argv_length1, (GDestroyNotify) g_free), NULL);
#line 122 "../src/CommandLine.vala"
		original_argv = (_vala_array_free (original_argv, original_argv_length1, (GDestroyNotify) g_free), NULL);
#line 122 "../src/CommandLine.vala"
		_g_option_context_free0 (ctx);
#line 122 "../src/CommandLine.vala"
		option_entries = (g_free (option_entries), NULL);
#line 122 "../src/CommandLine.vala"
		if (options) {
#line 122 "../src/CommandLine.vala"
			*options = _vala_options;
#line 884 "CommandLine.c"
		} else {
#line 122 "../src/CommandLine.vala"
			terminal_command_line_options_destroy (&_vala_options);
#line 888 "CommandLine.c"
		}
#line 122 "../src/CommandLine.vala"
		return result;
#line 892 "CommandLine.c"
	}
	__finally0:
#line 108 "../src/CommandLine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 897 "CommandLine.c"
		gboolean _tmp34_ = FALSE;
#line 108 "../src/CommandLine.vala"
		commandv = (_vala_array_free (commandv, commandv_length1, (GDestroyNotify) g_free), NULL);
#line 108 "../src/CommandLine.vala"
		real_argv = (_vala_array_free (real_argv, real_argv_length1, (GDestroyNotify) g_free), NULL);
#line 108 "../src/CommandLine.vala"
		original_argv = (_vala_array_free (original_argv, original_argv_length1, (GDestroyNotify) g_free), NULL);
#line 108 "../src/CommandLine.vala"
		_g_option_context_free0 (ctx);
#line 108 "../src/CommandLine.vala"
		option_entries = (g_free (option_entries), NULL);
#line 108 "../src/CommandLine.vala"
		terminal_command_line_options_destroy (&_vala_options);
#line 108 "../src/CommandLine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "../src/CommandLine.vala"
		g_clear_error (&_inner_error0_);
#line 108 "../src/CommandLine.vala"
		return _tmp34_;
#line 917 "CommandLine.c"
	}
#line 125 "../src/CommandLine.vala"
	result = TRUE;
#line 125 "../src/CommandLine.vala"
	commandv = (_vala_array_free (commandv, commandv_length1, (GDestroyNotify) g_free), NULL);
#line 125 "../src/CommandLine.vala"
	real_argv = (_vala_array_free (real_argv, real_argv_length1, (GDestroyNotify) g_free), NULL);
#line 125 "../src/CommandLine.vala"
	original_argv = (_vala_array_free (original_argv, original_argv_length1, (GDestroyNotify) g_free), NULL);
#line 125 "../src/CommandLine.vala"
	_g_option_context_free0 (ctx);
#line 125 "../src/CommandLine.vala"
	option_entries = (g_free (option_entries), NULL);
#line 125 "../src/CommandLine.vala"
	if (options) {
#line 125 "../src/CommandLine.vala"
		*options = _vala_options;
#line 935 "CommandLine.c"
	} else {
#line 125 "../src/CommandLine.vala"
		terminal_command_line_options_destroy (&_vala_options);
#line 939 "CommandLine.c"
	}
#line 125 "../src/CommandLine.vala"
	return result;
#line 943 "CommandLine.c"
}

TerminalCommandLine*
terminal_command_line_construct (GType object_type)
{
	TerminalCommandLine* self = NULL;
#line 37 "../src/CommandLine.vala"
	self = (TerminalCommandLine*) g_type_create_instance (object_type);
#line 37 "../src/CommandLine.vala"
	return self;
#line 954 "CommandLine.c"
}

TerminalCommandLine*
terminal_command_line_new (void)
{
#line 37 "../src/CommandLine.vala"
	return terminal_command_line_construct (TERMINAL_TYPE_COMMAND_LINE);
#line 962 "CommandLine.c"
}

static void
terminal_value_command_line_init (GValue* value)
{
#line 37 "../src/CommandLine.vala"
	value->data[0].v_pointer = NULL;
#line 970 "CommandLine.c"
}

static void
terminal_value_command_line_free_value (GValue* value)
{
#line 37 "../src/CommandLine.vala"
	if (value->data[0].v_pointer) {
#line 37 "../src/CommandLine.vala"
		terminal_command_line_unref (value->data[0].v_pointer);
#line 980 "CommandLine.c"
	}
}

static void
terminal_value_command_line_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 37 "../src/CommandLine.vala"
	if (src_value->data[0].v_pointer) {
#line 37 "../src/CommandLine.vala"
		dest_value->data[0].v_pointer = terminal_command_line_ref (src_value->data[0].v_pointer);
#line 992 "CommandLine.c"
	} else {
#line 37 "../src/CommandLine.vala"
		dest_value->data[0].v_pointer = NULL;
#line 996 "CommandLine.c"
	}
}

static gpointer
terminal_value_command_line_peek_pointer (const GValue* value)
{
#line 37 "../src/CommandLine.vala"
	return value->data[0].v_pointer;
#line 1005 "CommandLine.c"
}

static gchar*
terminal_value_command_line_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 37 "../src/CommandLine.vala"
	if (collect_values[0].v_pointer) {
#line 1016 "CommandLine.c"
		TerminalCommandLine * object;
		object = collect_values[0].v_pointer;
#line 37 "../src/CommandLine.vala"
		if (object->parent_instance.g_class == NULL) {
#line 37 "../src/CommandLine.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1023 "CommandLine.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 37 "../src/CommandLine.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1027 "CommandLine.c"
		}
#line 37 "../src/CommandLine.vala"
		value->data[0].v_pointer = terminal_command_line_ref (object);
#line 1031 "CommandLine.c"
	} else {
#line 37 "../src/CommandLine.vala"
		value->data[0].v_pointer = NULL;
#line 1035 "CommandLine.c"
	}
#line 37 "../src/CommandLine.vala"
	return NULL;
#line 1039 "CommandLine.c"
}

static gchar*
terminal_value_command_line_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	TerminalCommandLine ** object_p;
	object_p = collect_values[0].v_pointer;
#line 37 "../src/CommandLine.vala"
	if (!object_p) {
#line 37 "../src/CommandLine.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1054 "CommandLine.c"
	}
#line 37 "../src/CommandLine.vala"
	if (!value->data[0].v_pointer) {
#line 37 "../src/CommandLine.vala"
		*object_p = NULL;
#line 1060 "CommandLine.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 37 "../src/CommandLine.vala"
		*object_p = value->data[0].v_pointer;
#line 1064 "CommandLine.c"
	} else {
#line 37 "../src/CommandLine.vala"
		*object_p = terminal_command_line_ref (value->data[0].v_pointer);
#line 1068 "CommandLine.c"
	}
#line 37 "../src/CommandLine.vala"
	return NULL;
#line 1072 "CommandLine.c"
}

GParamSpec*
terminal_param_spec_command_line (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	TerminalParamSpecCommandLine* spec;
#line 37 "../src/CommandLine.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TERMINAL_TYPE_COMMAND_LINE), NULL);
#line 37 "../src/CommandLine.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 37 "../src/CommandLine.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 37 "../src/CommandLine.vala"
	return G_PARAM_SPEC (spec);
#line 1091 "CommandLine.c"
}

gpointer
terminal_value_get_command_line (const GValue* value)
{
#line 37 "../src/CommandLine.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TERMINAL_TYPE_COMMAND_LINE), NULL);
#line 37 "../src/CommandLine.vala"
	return value->data[0].v_pointer;
#line 1101 "CommandLine.c"
}

void
terminal_value_set_command_line (GValue* value,
                                 gpointer v_object)
{
	TerminalCommandLine * old;
#line 37 "../src/CommandLine.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TERMINAL_TYPE_COMMAND_LINE));
#line 37 "../src/CommandLine.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/CommandLine.vala"
	if (v_object) {
#line 37 "../src/CommandLine.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TERMINAL_TYPE_COMMAND_LINE));
#line 37 "../src/CommandLine.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/CommandLine.vala"
		value->data[0].v_pointer = v_object;
#line 37 "../src/CommandLine.vala"
		terminal_command_line_ref (value->data[0].v_pointer);
#line 1123 "CommandLine.c"
	} else {
#line 37 "../src/CommandLine.vala"
		value->data[0].v_pointer = NULL;
#line 1127 "CommandLine.c"
	}
#line 37 "../src/CommandLine.vala"
	if (old) {
#line 37 "../src/CommandLine.vala"
		terminal_command_line_unref (old);
#line 1133 "CommandLine.c"
	}
}

void
terminal_value_take_command_line (GValue* value,
                                  gpointer v_object)
{
	TerminalCommandLine * old;
#line 37 "../src/CommandLine.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TERMINAL_TYPE_COMMAND_LINE));
#line 37 "../src/CommandLine.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/CommandLine.vala"
	if (v_object) {
#line 37 "../src/CommandLine.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TERMINAL_TYPE_COMMAND_LINE));
#line 37 "../src/CommandLine.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/CommandLine.vala"
		value->data[0].v_pointer = v_object;
#line 1154 "CommandLine.c"
	} else {
#line 37 "../src/CommandLine.vala"
		value->data[0].v_pointer = NULL;
#line 1158 "CommandLine.c"
	}
#line 37 "../src/CommandLine.vala"
	if (old) {
#line 37 "../src/CommandLine.vala"
		terminal_command_line_unref (old);
#line 1164 "CommandLine.c"
	}
}

static void
terminal_command_line_class_init (TerminalCommandLineClass * klass,
                                  gpointer klass_data)
{
#line 37 "../src/CommandLine.vala"
	terminal_command_line_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/CommandLine.vala"
	((TerminalCommandLineClass *) klass)->finalize = terminal_command_line_finalize;
#line 1176 "CommandLine.c"
}

static void
terminal_command_line_instance_init (TerminalCommandLine * self,
                                     gpointer klass)
{
#line 37 "../src/CommandLine.vala"
	self->ref_count = 1;
#line 1185 "CommandLine.c"
}

static void
terminal_command_line_finalize (TerminalCommandLine * obj)
{
	TerminalCommandLine * self;
#line 37 "../src/CommandLine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_COMMAND_LINE, TerminalCommandLine);
#line 37 "../src/CommandLine.vala"
	g_signal_handlers_destroy (self);
#line 1196 "CommandLine.c"
}

static GType
terminal_command_line_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { terminal_value_command_line_init, terminal_value_command_line_free_value, terminal_value_command_line_copy_value, terminal_value_command_line_peek_pointer, "p", terminal_value_command_line_collect_value, "p", terminal_value_command_line_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TerminalCommandLineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_command_line_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalCommandLine), 0, (GInstanceInitFunc) terminal_command_line_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType terminal_command_line_type_id;
	terminal_command_line_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TerminalCommandLine", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return terminal_command_line_type_id;
}

GType
terminal_command_line_get_type (void)
{
	static volatile gsize terminal_command_line_type_id__once = 0;
	if (g_once_init_enter (&terminal_command_line_type_id__once)) {
		GType terminal_command_line_type_id;
		terminal_command_line_type_id = terminal_command_line_get_type_once ();
		g_once_init_leave (&terminal_command_line_type_id__once, terminal_command_line_type_id);
	}
	return terminal_command_line_type_id__once;
}

gpointer
terminal_command_line_ref (gpointer instance)
{
	TerminalCommandLine * self;
	self = instance;
#line 37 "../src/CommandLine.vala"
	g_atomic_int_inc (&self->ref_count);
#line 37 "../src/CommandLine.vala"
	return instance;
#line 1231 "CommandLine.c"
}

void
terminal_command_line_unref (gpointer instance)
{
	TerminalCommandLine * self;
	self = instance;
#line 37 "../src/CommandLine.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 37 "../src/CommandLine.vala"
		TERMINAL_COMMAND_LINE_GET_CLASS (self)->finalize (self);
#line 37 "../src/CommandLine.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1245 "CommandLine.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

