/* Constants.c generated by valac 0.56.13, the Vala compiler
 * generated from Constants.vala, do not modify */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define TERMINAL_CONSTANTS_USERCHARS "-[:alnum:]"
#define TERMINAL_CONSTANTS_USERCHARS_CLASS "[" TERMINAL_CONSTANTS_USERCHARS "]"
#define TERMINAL_CONSTANTS_PASSCHARS_CLASS "[-[:alnum:]\\Q,?;.:/!%$^*&~\"#'\\E]"
#define TERMINAL_CONSTANTS_HOSTCHARS_CLASS "[-[:alnum:]]"
#define TERMINAL_CONSTANTS_HOST TERMINAL_CONSTANTS_HOSTCHARS_CLASS "+(\\." TERMINAL_CONSTANTS_HOSTCHARS_CLASS "+)*"
#define TERMINAL_CONSTANTS_PORT "(?:\\:[[:digit:]]{1,5})?"
#define TERMINAL_CONSTANTS_PATHCHARS_CLASS "[-[:alnum:]\\Q_$.+!*,;:@&=?/~#%\\E]"
#define TERMINAL_CONSTANTS_PATHTERM_CLASS "[^\\Q]'.}>) \t\r\n,\"\\E]"
#define TERMINAL_CONSTANTS_SCHEME "(?:news:|telnet:|nntp:|file:\\/|https?:|ftps?:|sftp:|webcal:" "|irc:|sftp:|ldaps?:|nfs:|smb:|rsync:|ssh:|rlogin:|telnet:|git:" "|git\\+ssh:|bzr:|bzr\\+ssh:|svn:|svn\\+ssh:|hg:|mailto:|magnet:)"
#define TERMINAL_CONSTANTS_USERPASS TERMINAL_CONSTANTS_USERCHARS_CLASS "+(?:" TERMINAL_CONSTANTS_PASSCHARS_CLASS "+)?"
#define TERMINAL_CONSTANTS_URLPATH "(?:(/" TERMINAL_CONSTANTS_PATHCHARS_CLASS "+(?:[(]" TERMINAL_CONSTANTS_PATHCHARS_CLASS "*[)])*" TERMINAL_CONSTANTS_PATHCHARS_CLASS "*)*" TERMINAL_CONSTANTS_PATHTERM_CLASS ")?"
#define TERMINAL_CONSTANTS_MENU_BUTTON_ALTERNATIVE _ ("You can still access the menu by right-clicking any terminal.")
#define TERMINAL_CONSTANTS_COPYING_NOT_IMPLEMENTED_WARNING_FMT _ ("%s uses an early Gtk 4 port of VTE as a terminal widget. While a lot o" \
"f progress has been made on this port, copying has yet to be implement" \
"ed. This means there's currently no way to copy text in %s.")
#define TERMINAL_CONSTANTS_INFINITE_SCROLLBACK_WARNING _ ("Warning: unlimited scrollback saves content to disk, which may cause y" \
"our system to run out of storage.")
#define TERMINAL_DATADIR "/usr/share"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

VALA_EXTERN gchar* terminal_constants_get_user_schemes_dir (void);
VALA_EXTERN gchar* terminal_constants_get_user_keybindings_path (void);
VALA_EXTERN gchar* terminal_constants_get_app_schemes_dir (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const gchar* TERMINAL_CONSTANTS_URL_REGEX_STRINGS[5] = {TERMINAL_CONSTANTS_SCHEME "//(?:" TERMINAL_CONSTANTS_USERPASS "\\@)?" TERMINAL_CONSTANTS_HOST TERMINAL_CONSTANTS_PORT TERMINAL_CONSTANTS_URLPATH, "(?:www|ftp)" TERMINAL_CONSTANTS_HOSTCHARS_CLASS "*\\." TERMINAL_CONSTANTS_HOST TERMINAL_CONSTANTS_PORT TERMINAL_CONSTANTS_URLPATH, "(?:callto:|h323:|sip:)" TERMINAL_CONSTANTS_USERCHARS_CLASS "[" TERMINAL_CONSTANTS_USERCHARS ".]*(?:" TERMINAL_CONSTANTS_PORT "/[a-z0-9]+)?\\@" TERMINAL_CONSTANTS_HOST, "(?:mailto:)?" TERMINAL_CONSTANTS_USERCHARS_CLASS "[" TERMINAL_CONSTANTS_USERCHARS ".]*\\@" TERMINAL_CONSTANTS_HOSTCHARS_CLASS "+\\." TERMINAL_CONSTANTS_HOST, "(?:news:|man:|info:)[[:alnum:]\\Q^_{|}~!\"#$%&'()*+,./;:=?`\\E]+"};

gchar*
terminal_constants_get_user_schemes_dir (void)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 41 "../src/utils/Constants.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 41 "../src/utils/Constants.vala"
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "blackbox", "schemes", NULL);
#line 41 "../src/utils/Constants.vala"
	result = _tmp1_;
#line 41 "../src/utils/Constants.vala"
	return result;
#line 57 "Constants.c"
}

gchar*
terminal_constants_get_user_keybindings_path (void)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 47 "../src/utils/Constants.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 47 "../src/utils/Constants.vala"
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "blackbox", "user-keymap.json", NULL);
#line 47 "../src/utils/Constants.vala"
	result = _tmp1_;
#line 47 "../src/utils/Constants.vala"
	return result;
#line 74 "Constants.c"
}

gchar*
terminal_constants_get_app_schemes_dir (void)
{
	gchar* _tmp0_;
	gchar* result;
#line 53 "../src/utils/Constants.vala"
	_tmp0_ = g_build_path (G_DIR_SEPARATOR_S, TERMINAL_DATADIR, "blackbox", "schemes", NULL);
#line 53 "../src/utils/Constants.vala"
	result = _tmp0_;
#line 53 "../src/utils/Constants.vala"
	return result;
#line 88 "Constants.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

