/* File.c generated by valac 0.56.13, the Vala compiler
 * generated from File.vala, do not modify */

/* File.vala
 *
 * Copyright 2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>
#include <glib/gstdio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_FILE (terminal_file_get_type ())
#define TERMINAL_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_FILE, TerminalFile))
#define TERMINAL_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_FILE, TerminalFileClass))
#define TERMINAL_IS_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_FILE))
#define TERMINAL_IS_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_FILE))
#define TERMINAL_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_FILE, TerminalFileClass))

typedef struct _TerminalFile TerminalFile;
typedef struct _TerminalFileClass TerminalFileClass;
typedef struct _TerminalFilePrivate TerminalFilePrivate;
enum  {
	TERMINAL_FILE_0_PROPERTY,
	TERMINAL_FILE_FILE_PROPERTY,
	TERMINAL_FILE_PATH_PROPERTY,
	TERMINAL_FILE_NUM_PROPERTIES
};
static GParamSpec* terminal_file_properties[TERMINAL_FILE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

struct _TerminalFile {
	GObject parent_instance;
	TerminalFilePrivate * priv;
};

struct _TerminalFileClass {
	GObjectClass parent_class;
};

struct _TerminalFilePrivate {
	GFile* _file;
};

static gint TerminalFile_private_offset;
static gpointer terminal_file_parent_class = NULL;

VALA_EXTERN GType terminal_file_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalFile, g_object_unref)
VALA_EXTERN TerminalFile* terminal_file_new (const gchar* path);
VALA_EXTERN TerminalFile* terminal_file_construct (GType object_type,
                                       const gchar* path);
VALA_EXTERN void terminal_file_set_file (TerminalFile* self,
                             GFile* value);
VALA_EXTERN TerminalFile* terminal_file_new_new_from_file (GFile* _file);
VALA_EXTERN TerminalFile* terminal_file_construct_new_from_file (GType object_type,
                                                     GFile* _file);
VALA_EXTERN gchar* terminal_file_read_all (TerminalFile* self,
                               gsize* bytes_read,
                               GError** error);
VALA_EXTERN gchar* terminal_file_get_path (TerminalFile* self);
VALA_EXTERN void terminal_file_write_plus (TerminalFile* self,
                               const gchar* str,
                               GError** error);
VALA_EXTERN GFile* terminal_file_get_file (TerminalFile* self);
static void terminal_file_finalize (GObject * obj);
static GType terminal_file_get_type_once (void);
static void _vala_terminal_file_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_terminal_file_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
terminal_file_get_instance_private (TerminalFile* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalFile_private_offset);
}

TerminalFile*
terminal_file_construct (GType object_type,
                         const gchar* path)
{
	TerminalFile * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 31 "../src/utils/File.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 32 "../src/utils/File.vala"
	self = (TerminalFile*) g_object_new (object_type, NULL);
#line 34 "../src/utils/File.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 34 "../src/utils/File.vala"
	_tmp1_ = _tmp0_;
#line 34 "../src/utils/File.vala"
	terminal_file_set_file (self, _tmp1_);
#line 34 "../src/utils/File.vala"
	_g_object_unref0 (_tmp1_);
#line 31 "../src/utils/File.vala"
	return self;
#line 138 "File.c"
}

TerminalFile*
terminal_file_new (const gchar* path)
{
#line 31 "../src/utils/File.vala"
	return terminal_file_construct (TERMINAL_TYPE_FILE, path);
#line 146 "File.c"
}

TerminalFile*
terminal_file_construct_new_from_file (GType object_type,
                                       GFile* _file)
{
	TerminalFile * self = NULL;
#line 37 "../src/utils/File.vala"
	g_return_val_if_fail (_file != NULL, NULL);
#line 38 "../src/utils/File.vala"
	self = (TerminalFile*) g_object_new (object_type, NULL);
#line 40 "../src/utils/File.vala"
	terminal_file_set_file (self, _file);
#line 37 "../src/utils/File.vala"
	return self;
#line 162 "File.c"
}

TerminalFile*
terminal_file_new_new_from_file (GFile* _file)
{
#line 37 "../src/utils/File.vala"
	return terminal_file_construct_new_from_file (TERMINAL_TYPE_FILE, _file);
#line 170 "File.c"
}

gchar*
terminal_file_read_all (TerminalFile* self,
                        gsize* bytes_read,
                        GError** error)
{
	gsize _vala_bytes_read = 0UL;
	FILE* is = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	FILE* _tmp3_;
	FILE* _tmp4_;
	FILE* _tmp5_;
	gsize size = 0UL;
	FILE* _tmp6_;
	FILE* _tmp7_;
	guint8* buf = NULL;
	guint8* _tmp8_;
	gint buf_length1;
	gint _buf_size_;
	gsize read = 0UL;
	FILE* _tmp9_;
	guint8* _tmp10_;
	gint _tmp10__length1;
	gchar* _tmp11_ = NULL;
	gchar* result;
#line 43 "../src/utils/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/utils/File.vala"
	_vala_bytes_read = (gsize) 0;
#line 46 "../src/utils/File.vala"
	_tmp0_ = terminal_file_get_path (self);
#line 46 "../src/utils/File.vala"
	_tmp1_ = _tmp0_;
#line 46 "../src/utils/File.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/utils/File.vala"
	_tmp3_ = g_fopen (_tmp2_, "r");
#line 46 "../src/utils/File.vala"
	_tmp4_ = _tmp3_;
#line 46 "../src/utils/File.vala"
	_g_free0 (_tmp2_);
#line 46 "../src/utils/File.vala"
	is = _tmp4_;
#line 47 "../src/utils/File.vala"
	_tmp5_ = is;
#line 47 "../src/utils/File.vala"
	fseek (_tmp5_, (glong) 0, SEEK_END);
#line 49 "../src/utils/File.vala"
	_tmp6_ = is;
#line 49 "../src/utils/File.vala"
	size = (gsize) ftell (_tmp6_);
#line 50 "../src/utils/File.vala"
	_tmp7_ = is;
#line 50 "../src/utils/File.vala"
	rewind (_tmp7_);
#line 52 "../src/utils/File.vala"
	_tmp8_ = g_new0 (guint8, size);
#line 52 "../src/utils/File.vala"
	buf = _tmp8_;
#line 52 "../src/utils/File.vala"
	buf_length1 = size;
#line 52 "../src/utils/File.vala"
	_buf_size_ = buf_length1;
#line 53 "../src/utils/File.vala"
	_tmp9_ = is;
#line 53 "../src/utils/File.vala"
	_tmp10_ = buf;
#line 53 "../src/utils/File.vala"
	_tmp10__length1 = buf_length1;
#line 53 "../src/utils/File.vala"
	read = fread (_tmp10_, (gsize) 1, (gint) _tmp10__length1, _tmp9_);
#line 55 "../src/utils/File.vala"
	_vala_bytes_read = read;
#line 57 "../src/utils/File.vala"
	if (read != size) {
#line 58 "../src/utils/File.vala"
		g_warning ("File.vala:58: Invalid read size");
#line 251 "File.c"
	}
#line 61 "../src/utils/File.vala"
	if (read == ((gsize) 0)) {
#line 62 "../src/utils/File.vala"
		_g_free0 (_tmp11_);
#line 62 "../src/utils/File.vala"
		_tmp11_ = NULL;
#line 259 "File.c"
	} else {
		guint8* _tmp12_;
		gint _tmp12__length1;
		gchar* _tmp13_;
#line 63 "../src/utils/File.vala"
		_tmp12_ = buf;
#line 63 "../src/utils/File.vala"
		_tmp12__length1 = buf_length1;
#line 63 "../src/utils/File.vala"
		_tmp13_ = g_utf8_make_valid ((const gchar*) _tmp12_, (gssize) read);
#line 63 "../src/utils/File.vala"
		_g_free0 (_tmp11_);
#line 63 "../src/utils/File.vala"
		_tmp11_ = _tmp13_;
#line 274 "File.c"
	}
#line 61 "../src/utils/File.vala"
	result = _tmp11_;
#line 61 "../src/utils/File.vala"
	buf = (g_free (buf), NULL);
#line 61 "../src/utils/File.vala"
	_fclose0 (is);
#line 61 "../src/utils/File.vala"
	if (bytes_read) {
#line 61 "../src/utils/File.vala"
		*bytes_read = _vala_bytes_read;
#line 286 "File.c"
	}
#line 61 "../src/utils/File.vala"
	return result;
#line 290 "File.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 68 "../src/utils/File.vala"
	return self ? g_object_ref (self) : NULL;
#line 298 "File.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1563 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1564 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1564 "glib-2.0.vapi"
	res_length1 = -1;
#line 1564 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1565 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1565 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1565 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1566 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1566 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1566 "glib-2.0.vapi"
	if (result_length1) {
#line 1566 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 335 "File.c"
	}
#line 1566 "glib-2.0.vapi"
	result = _tmp2_;
#line 1566 "glib-2.0.vapi"
	return result;
#line 341 "File.c"
}

void
terminal_file_write_plus (TerminalFile* self,
                          const gchar* str,
                          GError** error)
{
	GFileIOStream* iostream = NULL;
	GFile* _tmp0_;
	GFileIOStream* _tmp1_;
	GOutputStream* os = NULL;
	GFileIOStream* _tmp2_;
	GOutputStream* _tmp3_;
	GOutputStream* _tmp4_;
	GOutputStream* _tmp5_;
	GOutputStream* _tmp6_;
	guint8* _tmp7_;
	gint _tmp7__length1;
	gint _tmp8_ = 0;
	guint8* _tmp9_;
	gint _tmp9__length1;
	GError* _inner_error0_ = NULL;
#line 66 "../src/utils/File.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/utils/File.vala"
	g_return_if_fail (str != NULL);
#line 67 "../src/utils/File.vala"
	_tmp0_ = self->priv->_file;
#line 67 "../src/utils/File.vala"
	_tmp1_ = g_file_replace_readwrite (_tmp0_, NULL, FALSE, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 67 "../src/utils/File.vala"
	iostream = _tmp1_;
#line 67 "../src/utils/File.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../src/utils/File.vala"
		g_propagate_error (error, _inner_error0_);
#line 67 "../src/utils/File.vala"
		return;
#line 380 "File.c"
	}
#line 68 "../src/utils/File.vala"
	_tmp2_ = iostream;
#line 68 "../src/utils/File.vala"
	_tmp3_ = g_io_stream_get_output_stream ((GIOStream*) _tmp2_);
#line 68 "../src/utils/File.vala"
	_tmp4_ = _tmp3_;
#line 68 "../src/utils/File.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 68 "../src/utils/File.vala"
	os = _tmp5_;
#line 69 "../src/utils/File.vala"
	_tmp6_ = os;
#line 69 "../src/utils/File.vala"
	_tmp7_ = string_get_data (str, &_tmp8_);
#line 69 "../src/utils/File.vala"
	_tmp7__length1 = _tmp8_;
#line 69 "../src/utils/File.vala"
	_tmp9_ = _tmp7_;
#line 69 "../src/utils/File.vala"
	_tmp9__length1 = _tmp7__length1;
#line 69 "../src/utils/File.vala"
	g_output_stream_write_all (_tmp6_, _tmp9_, (gsize) _tmp9__length1, NULL, NULL, &_inner_error0_);
#line 69 "../src/utils/File.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/utils/File.vala"
		g_propagate_error (error, _inner_error0_);
#line 69 "../src/utils/File.vala"
		_g_object_unref0 (os);
#line 69 "../src/utils/File.vala"
		_g_object_unref0 (iostream);
#line 69 "../src/utils/File.vala"
		return;
#line 414 "File.c"
	}
#line 66 "../src/utils/File.vala"
	_g_object_unref0 (os);
#line 66 "../src/utils/File.vala"
	_g_object_unref0 (iostream);
#line 420 "File.c"
}

GFile*
terminal_file_get_file (TerminalFile* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 23 "../src/utils/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/utils/File.vala"
	_tmp0_ = self->priv->_file;
#line 23 "../src/utils/File.vala"
	result = _tmp0_;
#line 23 "../src/utils/File.vala"
	return result;
#line 436 "File.c"
}

void
terminal_file_set_file (TerminalFile* self,
                        GFile* value)
{
	GFile* old_value;
#line 23 "../src/utils/File.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/utils/File.vala"
	old_value = terminal_file_get_file (self);
#line 23 "../src/utils/File.vala"
	if (old_value != value) {
#line 450 "File.c"
		GFile* _tmp0_;
#line 23 "../src/utils/File.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/utils/File.vala"
		_g_object_unref0 (self->priv->_file);
#line 23 "../src/utils/File.vala"
		self->priv->_file = _tmp0_;
#line 23 "../src/utils/File.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_file_properties[TERMINAL_FILE_FILE_PROPERTY]);
#line 460 "File.c"
	}
}

gchar*
terminal_file_get_path (TerminalFile* self)
{
	gchar* result;
	GFile* _tmp0_;
	gchar* _tmp1_;
#line 26 "../src/utils/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/utils/File.vala"
	_tmp0_ = self->priv->_file;
#line 27 "../src/utils/File.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 27 "../src/utils/File.vala"
	result = _tmp1_;
#line 27 "../src/utils/File.vala"
	return result;
#line 480 "File.c"
}

static void
terminal_file_class_init (TerminalFileClass * klass,
                          gpointer klass_data)
{
#line 21 "../src/utils/File.vala"
	terminal_file_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/utils/File.vala"
	g_type_class_adjust_private_offset (klass, &TerminalFile_private_offset);
#line 21 "../src/utils/File.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_file_get_property;
#line 21 "../src/utils/File.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_file_set_property;
#line 21 "../src/utils/File.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_file_finalize;
#line 21 "../src/utils/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_FILE_FILE_PROPERTY, terminal_file_properties[TERMINAL_FILE_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/utils/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_FILE_PATH_PROPERTY, terminal_file_properties[TERMINAL_FILE_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 501 "File.c"
}

static void
terminal_file_instance_init (TerminalFile * self,
                             gpointer klass)
{
#line 21 "../src/utils/File.vala"
	self->priv = terminal_file_get_instance_private (self);
#line 510 "File.c"
}

static void
terminal_file_finalize (GObject * obj)
{
	TerminalFile * self;
#line 21 "../src/utils/File.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_FILE, TerminalFile);
#line 23 "../src/utils/File.vala"
	_g_object_unref0 (self->priv->_file);
#line 21 "../src/utils/File.vala"
	G_OBJECT_CLASS (terminal_file_parent_class)->finalize (obj);
#line 523 "File.c"
}

static GType
terminal_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalFile), 0, (GInstanceInitFunc) terminal_file_instance_init, NULL };
	GType terminal_file_type_id;
	terminal_file_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminalFile", &g_define_type_info, 0);
	TerminalFile_private_offset = g_type_add_instance_private (terminal_file_type_id, sizeof (TerminalFilePrivate));
	return terminal_file_type_id;
}

GType
terminal_file_get_type (void)
{
	static volatile gsize terminal_file_type_id__once = 0;
	if (g_once_init_enter (&terminal_file_type_id__once)) {
		GType terminal_file_type_id;
		terminal_file_type_id = terminal_file_get_type_once ();
		g_once_init_leave (&terminal_file_type_id__once, terminal_file_type_id);
	}
	return terminal_file_type_id__once;
}

static void
_vala_terminal_file_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	TerminalFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_FILE, TerminalFile);
#line 21 "../src/utils/File.vala"
	switch (property_id) {
#line 21 "../src/utils/File.vala"
		case TERMINAL_FILE_FILE_PROPERTY:
#line 21 "../src/utils/File.vala"
		g_value_set_object (value, terminal_file_get_file (self));
#line 21 "../src/utils/File.vala"
		break;
#line 21 "../src/utils/File.vala"
		case TERMINAL_FILE_PATH_PROPERTY:
#line 21 "../src/utils/File.vala"
		g_value_take_string (value, terminal_file_get_path (self));
#line 21 "../src/utils/File.vala"
		break;
#line 570 "File.c"
		default:
#line 21 "../src/utils/File.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/utils/File.vala"
		break;
#line 576 "File.c"
	}
}

static void
_vala_terminal_file_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	TerminalFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_FILE, TerminalFile);
#line 21 "../src/utils/File.vala"
	switch (property_id) {
#line 21 "../src/utils/File.vala"
		case TERMINAL_FILE_FILE_PROPERTY:
#line 21 "../src/utils/File.vala"
		terminal_file_set_file (self, g_value_get_object (value));
#line 21 "../src/utils/File.vala"
		break;
#line 596 "File.c"
		default:
#line 21 "../src/utils/File.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/utils/File.vala"
		break;
#line 602 "File.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

