/* ShortcutDialog.c generated by valac 0.56.13, the Vala compiler
 * generated from ShortcutDialog.vala, do not modify */

/* ShortcutDialog.vala
 *
 * Copyright 2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define TERMINAL_DEVEL FALSE
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_SHORTCUT_DIALOG (terminal_shortcut_dialog_get_type ())
#define TERMINAL_SHORTCUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog))
#define TERMINAL_SHORTCUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialogClass))
#define TERMINAL_IS_SHORTCUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SHORTCUT_DIALOG))
#define TERMINAL_IS_SHORTCUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SHORTCUT_DIALOG))
#define TERMINAL_SHORTCUT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialogClass))

typedef struct _TerminalShortcutDialog TerminalShortcutDialog;
typedef struct _TerminalShortcutDialogClass TerminalShortcutDialogClass;
typedef struct _TerminalShortcutDialogPrivate TerminalShortcutDialogPrivate;
enum  {
	TERMINAL_SHORTCUT_DIALOG_0_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_HEADING_TEXT_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_TYPE_KEYMAP (terminal_keymap_get_type ())
#define TERMINAL_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_KEYMAP, TerminalKeymap))
#define TERMINAL_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_KEYMAP, TerminalKeymapClass))
#define TERMINAL_IS_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_KEYMAP))
#define TERMINAL_IS_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_KEYMAP))
#define TERMINAL_KEYMAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_KEYMAP, TerminalKeymapClass))

typedef struct _TerminalKeymap TerminalKeymap;
typedef struct _TerminalKeymapClass TerminalKeymapClass;
enum  {
	TERMINAL_SHORTCUT_DIALOG_RESPONSE_SIGNAL,
	TERMINAL_SHORTCUT_DIALOG_SHORTCUT_SET_SIGNAL,
	TERMINAL_SHORTCUT_DIALOG_NUM_SIGNALS
};
static guint terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_NUM_SIGNALS] = {0};

struct _TerminalShortcutDialog {
	AdwWindow parent_instance;
	TerminalShortcutDialogPrivate * priv;
};

struct _TerminalShortcutDialogClass {
	AdwWindowClass parent_class;
};

struct _TerminalShortcutDialogPrivate {
	gchar* _shortcut_name;
	gchar* _current_accel;
	gchar* _new_accel;
	gboolean _is_in_use;
	gboolean _is_shortcut_set;
	GtkShortcutLabel* shortcut_label;
};

static gint TerminalShortcutDialog_private_offset;
static gpointer terminal_shortcut_dialog_parent_class = NULL;
static GtkKeyvalTrigger* terminal_shortcut_dialog_JUST_ESCAPE;
static GtkKeyvalTrigger* terminal_shortcut_dialog_JUST_ESCAPE = NULL;
static GtkKeyvalTrigger* terminal_shortcut_dialog_JUST_BACKSPACE;
static GtkKeyvalTrigger* terminal_shortcut_dialog_JUST_BACKSPACE = NULL;

VALA_EXTERN GType terminal_shortcut_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalShortcutDialog, g_object_unref)
static void terminal_shortcut_dialog_setup_key_controller (TerminalShortcutDialog* self);
static gboolean __lambda56_ (TerminalShortcutDialog* self,
                      GtkEventControllerKey* event,
                      guint keyval,
                      guint _keycode,
                      GdkModifierType modifier);
static void terminal_shortcut_dialog_cancel (TerminalShortcutDialog* self);
static void terminal_shortcut_dialog_apply (TerminalShortcutDialog* self);
static GdkModifierType* _gdk_modifier_type_dup (GdkModifierType* self);
VALA_EXTERN GType terminal_keymap_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalKeymap, g_object_unref)
VALA_EXTERN TerminalKeymap* terminal_keymap_get_default (void);
VALA_EXTERN gchar* terminal_keymap_get_action_for_shortcut (TerminalKeymap* self,
                                                const gchar* shortcut);
static void terminal_shortcut_dialog_set_is_in_use (TerminalShortcutDialog* self,
                                             gboolean value);
VALA_EXTERN gboolean terminal_shortcut_dialog_get_is_in_use (TerminalShortcutDialog* self);
VALA_EXTERN void terminal_shortcut_dialog_set_is_shortcut_set (TerminalShortcutDialog* self,
                                                   gboolean value);
VALA_EXTERN gboolean terminal_shortcut_dialog_get_is_shortcut_set (TerminalShortcutDialog* self);
static gboolean ___lambda56__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                            guint keyval,
                                                            guint keycode,
                                                            GdkModifierType state,
                                                            gpointer self);
static void _terminal_shortcut_dialog_cancel_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static void _terminal_shortcut_dialog_apply_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self);
VALA_EXTERN TerminalShortcutDialog* terminal_shortcut_dialog_new (void);
VALA_EXTERN TerminalShortcutDialog* terminal_shortcut_dialog_construct (GType object_type);
VALA_EXTERN const gchar* terminal_shortcut_dialog_get_shortcut_name (TerminalShortcutDialog* self);
VALA_EXTERN void terminal_shortcut_dialog_set_shortcut_name (TerminalShortcutDialog* self,
                                                 const gchar* value);
VALA_EXTERN const gchar* terminal_shortcut_dialog_get_current_accel (TerminalShortcutDialog* self);
VALA_EXTERN void terminal_shortcut_dialog_set_current_accel (TerminalShortcutDialog* self,
                                                 const gchar* value);
VALA_EXTERN const gchar* terminal_shortcut_dialog_get_new_accel (TerminalShortcutDialog* self);
static void terminal_shortcut_dialog_set_new_accel (TerminalShortcutDialog* self,
                                             const gchar* value);
VALA_EXTERN gchar* terminal_shortcut_dialog_get_heading_text (TerminalShortcutDialog* self);
static GObject * terminal_shortcut_dialog_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _gtk_window_close_terminal_shortcut_dialog_response (TerminalShortcutDialog* _sender,
                                                          GtkResponseType response,
                                                          gpointer self);
static void _terminal_shortcut_dialog___lambda57_ (TerminalShortcutDialog* self);
static void __terminal_shortcut_dialog___lambda57__g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static gboolean _terminal_shortcut_dialog___lambda58_ (TerminalShortcutDialog* self,
                                                GBinding* _binding,
                                                GValue* from_value,
                                                GValue* to_value_ref);
static gboolean __terminal_shortcut_dialog___lambda58__gbinding_transform_func (GBinding* binding,
                                                                         GValue* from_value,
                                                                         GValue* to_value,
                                                                         gpointer self);
static void terminal_shortcut_dialog_finalize (GObject * obj);
static GType terminal_shortcut_dialog_get_type_once (void);
static void _vala_terminal_shortcut_dialog_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_terminal_shortcut_dialog_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
terminal_shortcut_dialog_get_instance_private (TerminalShortcutDialog* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalShortcutDialog_private_offset);
}

static GdkModifierType*
_gdk_modifier_type_dup (GdkModifierType* self)
{
	GdkModifierType* dup;
#line 114 "../src/widgets/ShortcutDialog.vala"
	dup = g_new0 (GdkModifierType, 1);
#line 114 "../src/widgets/ShortcutDialog.vala"
	memcpy (dup, self, sizeof (GdkModifierType));
#line 114 "../src/widgets/ShortcutDialog.vala"
	return dup;
#line 200 "ShortcutDialog.c"
}

static gpointer
__gdk_modifier_type_dup0 (gpointer self)
{
#line 114 "../src/widgets/ShortcutDialog.vala"
	return self ? _gdk_modifier_type_dup (self) : NULL;
#line 208 "ShortcutDialog.c"
}

static gboolean
__lambda56_ (TerminalShortcutDialog* self,
             GtkEventControllerKey* event,
             guint keyval,
             guint _keycode,
             GdkModifierType modifier)
{
#line 86 "../src/widgets/ShortcutDialog.vala"
	static const GdkModifierType valid_modifiers = (GDK_CONTROL_MASK | GDK_SHIFT_MASK) | GDK_ALT_MASK;
#line 220 "ShortcutDialog.c"
	GdkModifierType real_modifiers = 0U;
	GtkKeyvalTrigger* k = NULL;
	GtkKeyvalTrigger* _tmp0_;
	GtkKeyvalTrigger* _tmp1_;
	GtkKeyvalTrigger* _tmp2_;
	guint accel_key = 0U;
	GdkModifierType mods = 0U;
	gboolean is_valid_gtk_accel = FALSE;
	GtkKeyvalTrigger* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	guint _tmp8_ = 0U;
	GdkModifierType _tmp9_ = 0U;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GdkKeyEvent* _tmp12_ = NULL;
	GdkEvent* _tmp13_;
	GdkModifierType* _tmp14_ = NULL;
	GdkModifierType* _tmp17_ = NULL;
	GdkModifierType* _tmp18_;
	GdkModifierType consumed = 0U;
	GdkModifierType* _tmp21_;
	GdkModifierType* _tmp22_;
	GdkModifierType _tmp23_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean is_valid = FALSE;
	GtkShortcutLabel* _tmp31_;
	GtkKeyvalTrigger* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	TerminalKeymap* _tmp35_;
	TerminalKeymap* _tmp36_;
	GtkKeyvalTrigger* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gboolean _tmp42_ = FALSE;
	gchar* _tmp44_ = NULL;
	gboolean _tmp45_;
	gboolean result;
#line 85 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 91 "../src/widgets/ShortcutDialog.vala"
	real_modifiers = valid_modifiers & modifier;
#line 93 "../src/widgets/ShortcutDialog.vala"
	_tmp0_ = (GtkKeyvalTrigger*) gtk_keyval_trigger_new (keyval, real_modifiers);
#line 93 "../src/widgets/ShortcutDialog.vala"
	k = _tmp0_;
#line 95 "../src/widgets/ShortcutDialog.vala"
	_tmp1_ = k;
#line 95 "../src/widgets/ShortcutDialog.vala"
	_tmp2_ = terminal_shortcut_dialog_JUST_ESCAPE;
#line 95 "../src/widgets/ShortcutDialog.vala"
	if (gtk_shortcut_trigger_compare ((GtkShortcutTrigger*) _tmp1_, (GtkShortcutTrigger*) _tmp2_) == 0) {
#line 96 "../src/widgets/ShortcutDialog.vala"
		terminal_shortcut_dialog_cancel (self);
#line 97 "../src/widgets/ShortcutDialog.vala"
		result = FALSE;
#line 97 "../src/widgets/ShortcutDialog.vala"
		_g_object_unref0 (k);
#line 97 "../src/widgets/ShortcutDialog.vala"
		return result;
#line 286 "ShortcutDialog.c"
	} else {
		GtkKeyvalTrigger* _tmp3_;
		GtkKeyvalTrigger* _tmp4_;
#line 99 "../src/widgets/ShortcutDialog.vala"
		_tmp3_ = k;
#line 99 "../src/widgets/ShortcutDialog.vala"
		_tmp4_ = terminal_shortcut_dialog_JUST_BACKSPACE;
#line 99 "../src/widgets/ShortcutDialog.vala"
		if (gtk_shortcut_trigger_compare ((GtkShortcutTrigger*) _tmp3_, (GtkShortcutTrigger*) _tmp4_) == 0) {
#line 100 "../src/widgets/ShortcutDialog.vala"
			g_signal_emit (self, terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_SET_SIGNAL], 0, NULL);
#line 101 "../src/widgets/ShortcutDialog.vala"
			terminal_shortcut_dialog_apply (self);
#line 102 "../src/widgets/ShortcutDialog.vala"
			result = TRUE;
#line 102 "../src/widgets/ShortcutDialog.vala"
			_g_object_unref0 (k);
#line 102 "../src/widgets/ShortcutDialog.vala"
			return result;
#line 306 "ShortcutDialog.c"
		}
	}
#line 105 "../src/widgets/ShortcutDialog.vala"
	accel_key = (guint) 0;
#line 106 "../src/widgets/ShortcutDialog.vala"
	mods = 0;
#line 108 "../src/widgets/ShortcutDialog.vala"
	_tmp5_ = k;
#line 108 "../src/widgets/ShortcutDialog.vala"
	_tmp6_ = gtk_shortcut_trigger_to_string ((GtkShortcutTrigger*) _tmp5_);
#line 108 "../src/widgets/ShortcutDialog.vala"
	_tmp7_ = _tmp6_;
#line 108 "../src/widgets/ShortcutDialog.vala"
	_tmp10_ = gtk_accelerator_parse (_tmp7_, &_tmp8_, &_tmp9_);
#line 108 "../src/widgets/ShortcutDialog.vala"
	accel_key = _tmp8_;
#line 108 "../src/widgets/ShortcutDialog.vala"
	mods = _tmp9_;
#line 108 "../src/widgets/ShortcutDialog.vala"
	_tmp11_ = _tmp10_;
#line 108 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (_tmp7_);
#line 108 "../src/widgets/ShortcutDialog.vala"
	is_valid_gtk_accel = _tmp11_;
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp13_ = gtk_event_controller_get_current_event ((GtkEventController*) event);
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, gdk_key_event_get_type ()) ? ((GdkKeyEvent*) _tmp13_) : NULL;
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp14_ = NULL;
#line 114 "../src/widgets/ShortcutDialog.vala"
	if (_tmp12_ != NULL) {
#line 339 "ShortcutDialog.c"
		GdkModifierType _tmp15_;
		GdkModifierType* _tmp16_;
#line 114 "../src/widgets/ShortcutDialog.vala"
		_tmp15_ = gdk_key_event_get_consumed_modifiers (_tmp12_);
#line 114 "../src/widgets/ShortcutDialog.vala"
		_tmp16_ = __gdk_modifier_type_dup0 (&_tmp15_);
#line 114 "../src/widgets/ShortcutDialog.vala"
		_g_free0 (_tmp14_);
#line 114 "../src/widgets/ShortcutDialog.vala"
		_tmp14_ = _tmp16_;
#line 350 "ShortcutDialog.c"
	}
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp18_ = _tmp14_;
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp14_ = NULL;
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp17_ = _tmp18_;
#line 114 "../src/widgets/ShortcutDialog.vala"
	if (_tmp17_ == NULL) {
#line 360 "ShortcutDialog.c"
		GdkModifierType _tmp19_;
		GdkModifierType* _tmp20_;
#line 115 "../src/widgets/ShortcutDialog.vala"
		_tmp19_ = 0;
#line 115 "../src/widgets/ShortcutDialog.vala"
		_tmp20_ = __gdk_modifier_type_dup0 (&_tmp19_);
#line 115 "../src/widgets/ShortcutDialog.vala"
		_g_free0 (_tmp17_);
#line 115 "../src/widgets/ShortcutDialog.vala"
		_tmp17_ = _tmp20_;
#line 371 "ShortcutDialog.c"
	}
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp21_ = _tmp17_;
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp17_ = NULL;
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp22_ = _tmp21_;
#line 114 "../src/widgets/ShortcutDialog.vala"
	_tmp23_ = *_tmp22_;
#line 114 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (_tmp22_);
#line 114 "../src/widgets/ShortcutDialog.vala"
	consumed = _tmp23_;
#line 117 "../src/widgets/ShortcutDialog.vala"
	mods &= ~consumed;
#line 120 "../src/widgets/ShortcutDialog.vala"
	if (is_valid_gtk_accel) {
#line 389 "ShortcutDialog.c"
		const gchar* _tmp27_;
#line 123 "../src/widgets/ShortcutDialog.vala"
		_tmp27_ = gdk_keyval_name (keyval);
#line 123 "../src/widgets/ShortcutDialog.vala"
		_tmp26_ = !g_str_has_suffix (_tmp27_, "_L");
#line 395 "ShortcutDialog.c"
	} else {
#line 120 "../src/widgets/ShortcutDialog.vala"
		_tmp26_ = FALSE;
#line 399 "ShortcutDialog.c"
	}
#line 120 "../src/widgets/ShortcutDialog.vala"
	if (_tmp26_) {
#line 403 "ShortcutDialog.c"
		const gchar* _tmp28_;
#line 124 "../src/widgets/ShortcutDialog.vala"
		_tmp28_ = gdk_keyval_name (keyval);
#line 124 "../src/widgets/ShortcutDialog.vala"
		_tmp25_ = !g_str_has_suffix (_tmp28_, "_R");
#line 409 "ShortcutDialog.c"
	} else {
#line 120 "../src/widgets/ShortcutDialog.vala"
		_tmp25_ = FALSE;
#line 413 "ShortcutDialog.c"
	}
#line 120 "../src/widgets/ShortcutDialog.vala"
	if (_tmp25_) {
#line 417 "ShortcutDialog.c"
		gboolean _tmp29_ = FALSE;
		gboolean _tmp30_ = FALSE;
#line 128 "../src/widgets/ShortcutDialog.vala"
		if (keyval >= GDK_KEY_F1) {
#line 128 "../src/widgets/ShortcutDialog.vala"
			_tmp30_ = keyval <= GDK_KEY_F35;
#line 424 "ShortcutDialog.c"
		} else {
#line 128 "../src/widgets/ShortcutDialog.vala"
			_tmp30_ = FALSE;
#line 428 "ShortcutDialog.c"
		}
#line 127 "../src/widgets/ShortcutDialog.vala"
		if (_tmp30_) {
#line 128 "../src/widgets/ShortcutDialog.vala"
			_tmp29_ = TRUE;
#line 434 "ShortcutDialog.c"
		} else {
#line 128 "../src/widgets/ShortcutDialog.vala"
			_tmp29_ = mods > 0;
#line 438 "ShortcutDialog.c"
		}
#line 127 "../src/widgets/ShortcutDialog.vala"
		_tmp24_ = _tmp29_;
#line 442 "ShortcutDialog.c"
	} else {
#line 120 "../src/widgets/ShortcutDialog.vala"
		_tmp24_ = FALSE;
#line 446 "ShortcutDialog.c"
	}
#line 119 "../src/widgets/ShortcutDialog.vala"
	is_valid = _tmp24_;
#line 131 "../src/widgets/ShortcutDialog.vala"
	_tmp31_ = self->priv->shortcut_label;
#line 131 "../src/widgets/ShortcutDialog.vala"
	_tmp32_ = k;
#line 131 "../src/widgets/ShortcutDialog.vala"
	_tmp33_ = gtk_shortcut_trigger_to_string ((GtkShortcutTrigger*) _tmp32_);
#line 131 "../src/widgets/ShortcutDialog.vala"
	_tmp34_ = _tmp33_;
#line 131 "../src/widgets/ShortcutDialog.vala"
	gtk_shortcut_label_set_accelerator (_tmp31_, _tmp34_);
#line 131 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (_tmp34_);
#line 137 "../src/widgets/ShortcutDialog.vala"
	_tmp35_ = terminal_keymap_get_default ();
#line 137 "../src/widgets/ShortcutDialog.vala"
	_tmp36_ = _tmp35_;
#line 137 "../src/widgets/ShortcutDialog.vala"
	_tmp37_ = k;
#line 137 "../src/widgets/ShortcutDialog.vala"
	_tmp38_ = gtk_shortcut_trigger_to_string ((GtkShortcutTrigger*) _tmp37_);
#line 137 "../src/widgets/ShortcutDialog.vala"
	_tmp39_ = _tmp38_;
#line 137 "../src/widgets/ShortcutDialog.vala"
	_tmp40_ = terminal_keymap_get_action_for_shortcut (_tmp36_, _tmp39_);
#line 137 "../src/widgets/ShortcutDialog.vala"
	_tmp41_ = _tmp40_;
#line 137 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_set_is_in_use (self, _tmp41_ != NULL);
#line 137 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (_tmp41_);
#line 137 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (_tmp39_);
#line 137 "../src/widgets/ShortcutDialog.vala"
	_g_object_unref0 (_tmp36_);
#line 141 "../src/widgets/ShortcutDialog.vala"
	if (is_valid) {
#line 486 "ShortcutDialog.c"
		gboolean _tmp43_;
#line 141 "../src/widgets/ShortcutDialog.vala"
		_tmp43_ = self->priv->_is_in_use;
#line 141 "../src/widgets/ShortcutDialog.vala"
		_tmp42_ = !_tmp43_;
#line 492 "ShortcutDialog.c"
	} else {
#line 141 "../src/widgets/ShortcutDialog.vala"
		_tmp42_ = FALSE;
#line 496 "ShortcutDialog.c"
	}
#line 141 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_set_is_shortcut_set (self, _tmp42_);
#line 142 "../src/widgets/ShortcutDialog.vala"
	_tmp45_ = self->priv->_is_shortcut_set;
#line 142 "../src/widgets/ShortcutDialog.vala"
	if (_tmp45_) {
#line 504 "ShortcutDialog.c"
		GtkKeyvalTrigger* _tmp46_;
		gchar* _tmp47_;
#line 142 "../src/widgets/ShortcutDialog.vala"
		_tmp46_ = k;
#line 142 "../src/widgets/ShortcutDialog.vala"
		_tmp47_ = gtk_shortcut_trigger_to_string ((GtkShortcutTrigger*) _tmp46_);
#line 142 "../src/widgets/ShortcutDialog.vala"
		_g_free0 (_tmp44_);
#line 142 "../src/widgets/ShortcutDialog.vala"
		_tmp44_ = _tmp47_;
#line 515 "ShortcutDialog.c"
	} else {
#line 142 "../src/widgets/ShortcutDialog.vala"
		_g_free0 (_tmp44_);
#line 142 "../src/widgets/ShortcutDialog.vala"
		_tmp44_ = NULL;
#line 521 "ShortcutDialog.c"
	}
#line 142 "../src/widgets/ShortcutDialog.vala"
	g_signal_emit (self, terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_SET_SIGNAL], 0, _tmp44_);
#line 144 "../src/widgets/ShortcutDialog.vala"
	result = TRUE;
#line 144 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (_tmp44_);
#line 144 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (_tmp17_);
#line 144 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (_tmp14_);
#line 144 "../src/widgets/ShortcutDialog.vala"
	_g_object_unref0 (k);
#line 144 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 537 "ShortcutDialog.c"
}

static gboolean
___lambda56__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                   guint keyval,
                                                   guint keycode,
                                                   GdkModifierType state,
                                                   gpointer self)
{
	gboolean result;
	result = __lambda56_ ((TerminalShortcutDialog*) self, _sender, keyval, keycode, state);
#line 85 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 551 "ShortcutDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 147 "../src/widgets/ShortcutDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 559 "ShortcutDialog.c"
}

static void
terminal_shortcut_dialog_setup_key_controller (TerminalShortcutDialog* self)
{
	GtkEventControllerKey* kpc = NULL;
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
	GtkWidget* _tmp2_ = NULL;
#line 82 "../src/widgets/ShortcutDialog.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/widgets/ShortcutDialog.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 83 "../src/widgets/ShortcutDialog.vala"
	kpc = _tmp0_;
#line 85 "../src/widgets/ShortcutDialog.vala"
	_tmp1_ = kpc;
#line 85 "../src/widgets/ShortcutDialog.vala"
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) ___lambda56__gtk_event_controller_key_key_pressed, self, 0);
#line 147 "../src/widgets/ShortcutDialog.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 147 "../src/widgets/ShortcutDialog.vala"
	if (_tmp2_ != NULL) {
#line 583 "ShortcutDialog.c"
		GtkEventControllerKey* _tmp3_;
		GtkEventController* _tmp4_;
#line 147 "../src/widgets/ShortcutDialog.vala"
		_tmp3_ = kpc;
#line 147 "../src/widgets/ShortcutDialog.vala"
		_tmp4_ = _g_object_ref0 ((GtkEventController*) _tmp3_);
#line 147 "../src/widgets/ShortcutDialog.vala"
		gtk_widget_add_controller (_tmp2_, _tmp4_);
#line 592 "ShortcutDialog.c"
	}
#line 82 "../src/widgets/ShortcutDialog.vala"
	_g_object_unref0 (kpc);
#line 596 "ShortcutDialog.c"
}

static void
terminal_shortcut_dialog_cancel (TerminalShortcutDialog* self)
{
#line 151 "../src/widgets/ShortcutDialog.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/widgets/ShortcutDialog.vala"
	g_signal_emit (self, terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_RESPONSE_SIGNAL], 0, GTK_RESPONSE_CANCEL);
#line 606 "ShortcutDialog.c"
}

static void
_terminal_shortcut_dialog_cancel_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
#line 22 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_cancel ((TerminalShortcutDialog*) self);
#line 615 "ShortcutDialog.c"
}

static void
terminal_shortcut_dialog_apply (TerminalShortcutDialog* self)
{
#line 156 "../src/widgets/ShortcutDialog.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/widgets/ShortcutDialog.vala"
	g_signal_emit (self, terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_RESPONSE_SIGNAL], 0, GTK_RESPONSE_APPLY);
#line 625 "ShortcutDialog.c"
}

static void
_terminal_shortcut_dialog_apply_gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self)
{
#line 22 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_apply ((TerminalShortcutDialog*) self);
#line 634 "ShortcutDialog.c"
}

TerminalShortcutDialog*
terminal_shortcut_dialog_construct (GType object_type)
{
	TerminalShortcutDialog * self = NULL;
#line 22 "../src/widgets/ShortcutDialog.vala"
	self = (TerminalShortcutDialog*) g_object_new (object_type, NULL);
#line 22 "../src/widgets/ShortcutDialog.vala"
	return self;
#line 645 "ShortcutDialog.c"
}

TerminalShortcutDialog*
terminal_shortcut_dialog_new (void)
{
#line 22 "../src/widgets/ShortcutDialog.vala"
	return terminal_shortcut_dialog_construct (TERMINAL_TYPE_SHORTCUT_DIALOG);
#line 653 "ShortcutDialog.c"
}

const gchar*
terminal_shortcut_dialog_get_shortcut_name (TerminalShortcutDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/widgets/ShortcutDialog.vala"
	_tmp0_ = self->priv->_shortcut_name;
#line 37 "../src/widgets/ShortcutDialog.vala"
	result = _tmp0_;
#line 37 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 669 "ShortcutDialog.c"
}

void
terminal_shortcut_dialog_set_shortcut_name (TerminalShortcutDialog* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 37 "../src/widgets/ShortcutDialog.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/widgets/ShortcutDialog.vala"
	old_value = terminal_shortcut_dialog_get_shortcut_name (self);
#line 37 "../src/widgets/ShortcutDialog.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 683 "ShortcutDialog.c"
		gchar* _tmp0_;
#line 37 "../src/widgets/ShortcutDialog.vala"
		_tmp0_ = g_strdup (value);
#line 37 "../src/widgets/ShortcutDialog.vala"
		_g_free0 (self->priv->_shortcut_name);
#line 37 "../src/widgets/ShortcutDialog.vala"
		self->priv->_shortcut_name = _tmp0_;
#line 37 "../src/widgets/ShortcutDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY]);
#line 693 "ShortcutDialog.c"
	}
}

const gchar*
terminal_shortcut_dialog_get_current_accel (TerminalShortcutDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 38 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/widgets/ShortcutDialog.vala"
	_tmp0_ = self->priv->_current_accel;
#line 38 "../src/widgets/ShortcutDialog.vala"
	result = _tmp0_;
#line 38 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 710 "ShortcutDialog.c"
}

void
terminal_shortcut_dialog_set_current_accel (TerminalShortcutDialog* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 38 "../src/widgets/ShortcutDialog.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/widgets/ShortcutDialog.vala"
	old_value = terminal_shortcut_dialog_get_current_accel (self);
#line 38 "../src/widgets/ShortcutDialog.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 724 "ShortcutDialog.c"
		gchar* _tmp0_;
#line 38 "../src/widgets/ShortcutDialog.vala"
		_tmp0_ = g_strdup (value);
#line 38 "../src/widgets/ShortcutDialog.vala"
		_g_free0 (self->priv->_current_accel);
#line 38 "../src/widgets/ShortcutDialog.vala"
		self->priv->_current_accel = _tmp0_;
#line 38 "../src/widgets/ShortcutDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY]);
#line 734 "ShortcutDialog.c"
	}
}

const gchar*
terminal_shortcut_dialog_get_new_accel (TerminalShortcutDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/widgets/ShortcutDialog.vala"
	_tmp0_ = self->priv->_new_accel;
#line 39 "../src/widgets/ShortcutDialog.vala"
	result = _tmp0_;
#line 39 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 751 "ShortcutDialog.c"
}

static void
terminal_shortcut_dialog_set_new_accel (TerminalShortcutDialog* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 39 "../src/widgets/ShortcutDialog.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/widgets/ShortcutDialog.vala"
	old_value = terminal_shortcut_dialog_get_new_accel (self);
#line 39 "../src/widgets/ShortcutDialog.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 765 "ShortcutDialog.c"
		gchar* _tmp0_;
#line 39 "../src/widgets/ShortcutDialog.vala"
		_tmp0_ = g_strdup (value);
#line 39 "../src/widgets/ShortcutDialog.vala"
		_g_free0 (self->priv->_new_accel);
#line 39 "../src/widgets/ShortcutDialog.vala"
		self->priv->_new_accel = _tmp0_;
#line 39 "../src/widgets/ShortcutDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY]);
#line 775 "ShortcutDialog.c"
	}
}

gboolean
terminal_shortcut_dialog_get_is_in_use (TerminalShortcutDialog* self)
{
	gboolean result;
#line 40 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/widgets/ShortcutDialog.vala"
	result = self->priv->_is_in_use;
#line 40 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 789 "ShortcutDialog.c"
}

static void
terminal_shortcut_dialog_set_is_in_use (TerminalShortcutDialog* self,
                                        gboolean value)
{
	gboolean old_value;
#line 40 "../src/widgets/ShortcutDialog.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/widgets/ShortcutDialog.vala"
	old_value = terminal_shortcut_dialog_get_is_in_use (self);
#line 40 "../src/widgets/ShortcutDialog.vala"
	if (old_value != value) {
#line 40 "../src/widgets/ShortcutDialog.vala"
		self->priv->_is_in_use = value;
#line 40 "../src/widgets/ShortcutDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY]);
#line 807 "ShortcutDialog.c"
	}
}

gboolean
terminal_shortcut_dialog_get_is_shortcut_set (TerminalShortcutDialog* self)
{
	gboolean result;
#line 41 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/widgets/ShortcutDialog.vala"
	result = self->priv->_is_shortcut_set;
#line 41 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 821 "ShortcutDialog.c"
}

void
terminal_shortcut_dialog_set_is_shortcut_set (TerminalShortcutDialog* self,
                                              gboolean value)
{
	gboolean old_value;
#line 41 "../src/widgets/ShortcutDialog.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/widgets/ShortcutDialog.vala"
	old_value = terminal_shortcut_dialog_get_is_shortcut_set (self);
#line 41 "../src/widgets/ShortcutDialog.vala"
	if (old_value != value) {
#line 41 "../src/widgets/ShortcutDialog.vala"
		self->priv->_is_shortcut_set = value;
#line 41 "../src/widgets/ShortcutDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY]);
#line 839 "ShortcutDialog.c"
	}
}

gchar*
terminal_shortcut_dialog_get_heading_text (TerminalShortcutDialog* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 44 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/widgets/ShortcutDialog.vala"
	_tmp1_ = self->priv->_shortcut_name;
#line 45 "../src/widgets/ShortcutDialog.vala"
	if (_tmp1_ == NULL) {
#line 855 "ShortcutDialog.c"
		gchar* _tmp2_;
#line 46 "../src/widgets/ShortcutDialog.vala"
		_tmp2_ = g_strdup (_ ("Enter new shortcut"));
#line 46 "../src/widgets/ShortcutDialog.vala"
		_g_free0 (_tmp0_);
#line 46 "../src/widgets/ShortcutDialog.vala"
		_tmp0_ = _tmp2_;
#line 863 "ShortcutDialog.c"
	} else {
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 47 "../src/widgets/ShortcutDialog.vala"
		_tmp3_ = self->priv->_shortcut_name;
#line 47 "../src/widgets/ShortcutDialog.vala"
		_tmp4_ = g_strdup_printf (_ ("Enter new shortcut for \"%s\""), _tmp3_);
#line 47 "../src/widgets/ShortcutDialog.vala"
		_g_free0 (_tmp0_);
#line 47 "../src/widgets/ShortcutDialog.vala"
		_tmp0_ = _tmp4_;
#line 875 "ShortcutDialog.c"
	}
#line 45 "../src/widgets/ShortcutDialog.vala"
	result = _tmp0_;
#line 45 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 881 "ShortcutDialog.c"
}

static void
_gtk_window_close_terminal_shortcut_dialog_response (TerminalShortcutDialog* _sender,
                                                     GtkResponseType response,
                                                     gpointer self)
{
#line 58 "../src/widgets/ShortcutDialog.vala"
	gtk_window_close ((GtkWindow*) self);
#line 891 "ShortcutDialog.c"
}

static void
_terminal_shortcut_dialog___lambda57_ (TerminalShortcutDialog* self)
{
#line 61 "../src/widgets/ShortcutDialog.vala"
	g_object_notify ((GObject*) self, "heading-text");
#line 899 "ShortcutDialog.c"
}

static void
__terminal_shortcut_dialog___lambda57__g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 60 "../src/widgets/ShortcutDialog.vala"
	_terminal_shortcut_dialog___lambda57_ ((TerminalShortcutDialog*) self);
#line 909 "ShortcutDialog.c"
}

static gboolean
_terminal_shortcut_dialog___lambda58_ (TerminalShortcutDialog* self,
                                       GBinding* _binding,
                                       GValue* from_value,
                                       GValue* to_value_ref)
{
	gchar* current = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	GValue _tmp4_ = {0};
	gboolean result;
#line 71 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (_binding != NULL, FALSE);
#line 71 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (from_value != NULL, FALSE);
#line 71 "../src/widgets/ShortcutDialog.vala"
	g_return_val_if_fail (to_value_ref != NULL, FALSE);
#line 72 "../src/widgets/ShortcutDialog.vala"
	_tmp0_ = g_value_get_string (from_value);
#line 72 "../src/widgets/ShortcutDialog.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 72 "../src/widgets/ShortcutDialog.vala"
	current = _tmp1_;
#line 73 "../src/widgets/ShortcutDialog.vala"
	_tmp3_ = current;
#line 73 "../src/widgets/ShortcutDialog.vala"
	_tmp2_ = _tmp3_;
#line 73 "../src/widgets/ShortcutDialog.vala"
	if (_tmp2_ == NULL) {
#line 73 "../src/widgets/ShortcutDialog.vala"
		_tmp2_ = "";
#line 945 "ShortcutDialog.c"
	}
#line 73 "../src/widgets/ShortcutDialog.vala"
	g_value_init (&_tmp4_, G_TYPE_STRING);
#line 73 "../src/widgets/ShortcutDialog.vala"
	g_value_set_string (&_tmp4_, _tmp2_);
#line 73 "../src/widgets/ShortcutDialog.vala"
	G_IS_VALUE (to_value_ref) ? (g_value_unset (to_value_ref), NULL) : NULL;
#line 73 "../src/widgets/ShortcutDialog.vala"
	*to_value_ref = _tmp4_;
#line 74 "../src/widgets/ShortcutDialog.vala"
	result = TRUE;
#line 74 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (current);
#line 74 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 961 "ShortcutDialog.c"
}

static gboolean
__terminal_shortcut_dialog___lambda58__gbinding_transform_func (GBinding* binding,
                                                                GValue* from_value,
                                                                GValue* to_value,
                                                                gpointer self)
{
	gboolean result;
	result = _terminal_shortcut_dialog___lambda58_ ((TerminalShortcutDialog*) self, binding, from_value, to_value);
#line 65 "../src/widgets/ShortcutDialog.vala"
	return result;
#line 974 "ShortcutDialog.c"
}

static GObject *
terminal_shortcut_dialog_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TerminalShortcutDialog * self;
	GtkShortcutLabel* _tmp0_;
#line 53 "../src/widgets/ShortcutDialog.vala"
	parent_class = G_OBJECT_CLASS (terminal_shortcut_dialog_parent_class);
#line 53 "../src/widgets/ShortcutDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 53 "../src/widgets/ShortcutDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog);
#line 54 "../src/widgets/ShortcutDialog.vala"
	if (TERMINAL_DEVEL) {
#line 55 "../src/widgets/ShortcutDialog.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "devel");
#line 996 "ShortcutDialog.c"
	}
#line 58 "../src/widgets/ShortcutDialog.vala"
	g_signal_connect_object (self, "response", (GCallback) _gtk_window_close_terminal_shortcut_dialog_response, (GtkWindow*) self, G_CONNECT_AFTER);
#line 60 "../src/widgets/ShortcutDialog.vala"
	g_signal_connect_object ((GObject*) self, "notify::shortcut-name", (GCallback) __terminal_shortcut_dialog___lambda57__g_object_notify, self, 0);
#line 65 "../src/widgets/ShortcutDialog.vala"
	_tmp0_ = self->priv->shortcut_label;
#line 65 "../src/widgets/ShortcutDialog.vala"
	g_object_bind_property_with_closures ((GObject*) self, "current-accel", (GObject*) _tmp0_, "accelerator", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((__terminal_shortcut_dialog___lambda58__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) __terminal_shortcut_dialog___lambda58__gbinding_transform_func, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 79 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_setup_key_controller (self);
#line 53 "../src/widgets/ShortcutDialog.vala"
	return obj;
#line 1010 "ShortcutDialog.c"
}

static void
terminal_shortcut_dialog_class_init (TerminalShortcutDialogClass * klass,
                                     gpointer klass_data)
{
	GtkKeyvalTrigger* _tmp0_;
	GtkKeyvalTrigger* _tmp1_;
#line 22 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/widgets/ShortcutDialog.vala"
	g_type_class_adjust_private_offset (klass, &TerminalShortcutDialog_private_offset);
#line 22 "../src/widgets/ShortcutDialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_shortcut_dialog_get_property;
#line 22 "../src/widgets/ShortcutDialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_shortcut_dialog_set_property;
#line 22 "../src/widgets/ShortcutDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = terminal_shortcut_dialog_constructor;
#line 22 "../src/widgets/ShortcutDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_shortcut_dialog_finalize;
#line 22 "../src/widgets/ShortcutDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY] = g_param_spec_string ("shortcut-name", "shortcut-name", "shortcut-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/widgets/ShortcutDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY] = g_param_spec_string ("current-accel", "current-accel", "current-accel", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/widgets/ShortcutDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY] = g_param_spec_string ("new-accel", "new-accel", "new-accel", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/widgets/ShortcutDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY] = g_param_spec_boolean ("is-in-use", "is-in-use", "is-in-use", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/widgets/ShortcutDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY] = g_param_spec_boolean ("is-shortcut-set", "is-shortcut-set", "is-shortcut-set", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/widgets/ShortcutDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_HEADING_TEXT_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_HEADING_TEXT_PROPERTY] = g_param_spec_string ("heading-text", "heading-text", "heading-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/widgets/ShortcutDialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/raggesilver/BlackBox/gtk/shortcut-dialog.ui");
#line 22 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_RESPONSE_SIGNAL] = g_signal_new ("response", TERMINAL_TYPE_SHORTCUT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, gtk_response_type_get_type ());
#line 22 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_SET_SIGNAL] = g_signal_new ("shortcut-set", TERMINAL_TYPE_SHORTCUT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 24 "../src/widgets/ShortcutDialog.vala"
	_tmp0_ = (GtkKeyvalTrigger*) gtk_keyval_trigger_new (GDK_KEY_Escape, 0);
#line 24 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_JUST_ESCAPE = _tmp0_;
#line 29 "../src/widgets/ShortcutDialog.vala"
	_tmp1_ = (GtkKeyvalTrigger*) gtk_keyval_trigger_new (GDK_KEY_BackSpace, 0);
#line 29 "../src/widgets/ShortcutDialog.vala"
	terminal_shortcut_dialog_JUST_BACKSPACE = _tmp1_;
#line 22 "../src/widgets/ShortcutDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "shortcut_label", FALSE, TerminalShortcutDialog_private_offset + G_STRUCT_OFFSET (TerminalShortcutDialogPrivate, shortcut_label));
#line 22 "../src/widgets/ShortcutDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel", G_CALLBACK(_terminal_shortcut_dialog_cancel_gtk_button_clicked));
#line 22 "../src/widgets/ShortcutDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "apply", G_CALLBACK(_terminal_shortcut_dialog_apply_gtk_button_clicked));
#line 1063 "ShortcutDialog.c"
}

static void
terminal_shortcut_dialog_instance_init (TerminalShortcutDialog * self,
                                        gpointer klass)
{
#line 22 "../src/widgets/ShortcutDialog.vala"
	self->priv = terminal_shortcut_dialog_get_instance_private (self);
#line 37 "../src/widgets/ShortcutDialog.vala"
	self->priv->_shortcut_name = NULL;
#line 38 "../src/widgets/ShortcutDialog.vala"
	self->priv->_current_accel = NULL;
#line 39 "../src/widgets/ShortcutDialog.vala"
	self->priv->_new_accel = NULL;
#line 40 "../src/widgets/ShortcutDialog.vala"
	self->priv->_is_in_use = FALSE;
#line 41 "../src/widgets/ShortcutDialog.vala"
	self->priv->_is_shortcut_set = FALSE;
#line 22 "../src/widgets/ShortcutDialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1084 "ShortcutDialog.c"
}

static void
terminal_shortcut_dialog_finalize (GObject * obj)
{
	TerminalShortcutDialog * self;
#line 22 "../src/widgets/ShortcutDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog);
#line 37 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (self->priv->_shortcut_name);
#line 38 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (self->priv->_current_accel);
#line 39 "../src/widgets/ShortcutDialog.vala"
	_g_free0 (self->priv->_new_accel);
#line 22 "../src/widgets/ShortcutDialog.vala"
	G_OBJECT_CLASS (terminal_shortcut_dialog_parent_class)->finalize (obj);
#line 1101 "ShortcutDialog.c"
}

static GType
terminal_shortcut_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalShortcutDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_shortcut_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalShortcutDialog), 0, (GInstanceInitFunc) terminal_shortcut_dialog_instance_init, NULL };
	GType terminal_shortcut_dialog_type_id;
	terminal_shortcut_dialog_type_id = g_type_register_static (adw_window_get_type (), "TerminalShortcutDialog", &g_define_type_info, 0);
	TerminalShortcutDialog_private_offset = g_type_add_instance_private (terminal_shortcut_dialog_type_id, sizeof (TerminalShortcutDialogPrivate));
	return terminal_shortcut_dialog_type_id;
}

GType
terminal_shortcut_dialog_get_type (void)
{
	static volatile gsize terminal_shortcut_dialog_type_id__once = 0;
	if (g_once_init_enter (&terminal_shortcut_dialog_type_id__once)) {
		GType terminal_shortcut_dialog_type_id;
		terminal_shortcut_dialog_type_id = terminal_shortcut_dialog_get_type_once ();
		g_once_init_leave (&terminal_shortcut_dialog_type_id__once, terminal_shortcut_dialog_type_id);
	}
	return terminal_shortcut_dialog_type_id__once;
}

static void
_vala_terminal_shortcut_dialog_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	TerminalShortcutDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog);
#line 22 "../src/widgets/ShortcutDialog.vala"
	switch (property_id) {
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		g_value_set_string (value, terminal_shortcut_dialog_get_shortcut_name (self));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		g_value_set_string (value, terminal_shortcut_dialog_get_current_accel (self));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		g_value_set_string (value, terminal_shortcut_dialog_get_new_accel (self));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		g_value_set_boolean (value, terminal_shortcut_dialog_get_is_in_use (self));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		g_value_set_boolean (value, terminal_shortcut_dialog_get_is_shortcut_set (self));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_HEADING_TEXT_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		g_value_take_string (value, terminal_shortcut_dialog_get_heading_text (self));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 1172 "ShortcutDialog.c"
		default:
#line 22 "../src/widgets/ShortcutDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 1178 "ShortcutDialog.c"
	}
}

static void
_vala_terminal_shortcut_dialog_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	TerminalShortcutDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog);
#line 22 "../src/widgets/ShortcutDialog.vala"
	switch (property_id) {
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		terminal_shortcut_dialog_set_shortcut_name (self, g_value_get_string (value));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		terminal_shortcut_dialog_set_current_accel (self, g_value_get_string (value));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		terminal_shortcut_dialog_set_new_accel (self, g_value_get_string (value));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		terminal_shortcut_dialog_set_is_in_use (self, g_value_get_boolean (value));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 22 "../src/widgets/ShortcutDialog.vala"
		case TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY:
#line 22 "../src/widgets/ShortcutDialog.vala"
		terminal_shortcut_dialog_set_is_shortcut_set (self, g_value_get_boolean (value));
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 1222 "ShortcutDialog.c"
		default:
#line 22 "../src/widgets/ShortcutDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/widgets/ShortcutDialog.vala"
		break;
#line 1228 "ShortcutDialog.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

