/* StyleSwitcher.c generated by valac 0.56.13, the Vala compiler
 * generated from StyleSwitcher.vala, do not modify */

/* StyleSwitcher.vala
 *
 * Copyright 2023 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <pqmarble.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_STYLE_SWITCHER (terminal_style_switcher_get_type ())
#define TERMINAL_STYLE_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_STYLE_SWITCHER, TerminalStyleSwitcher))
#define TERMINAL_STYLE_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_STYLE_SWITCHER, TerminalStyleSwitcherClass))
#define TERMINAL_IS_STYLE_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_STYLE_SWITCHER))
#define TERMINAL_IS_STYLE_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_STYLE_SWITCHER))
#define TERMINAL_STYLE_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_STYLE_SWITCHER, TerminalStyleSwitcherClass))

typedef struct _TerminalStyleSwitcher TerminalStyleSwitcher;
typedef struct _TerminalStyleSwitcherClass TerminalStyleSwitcherClass;
typedef struct _TerminalStyleSwitcherPrivate TerminalStyleSwitcherPrivate;
enum  {
	TERMINAL_STYLE_SWITCHER_0_PROPERTY,
	TERMINAL_STYLE_SWITCHER_STYLE_PROPERTY,
	TERMINAL_STYLE_SWITCHER_SHOW_SYSTEM_PROPERTY,
	TERMINAL_STYLE_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* terminal_style_switcher_properties[TERMINAL_STYLE_SWITCHER_NUM_PROPERTIES];
typedef enum  {
	TERMINAL_APPLICATION_STYLE_SYSTEM = 0,
	TERMINAL_APPLICATION_STYLE_LIGHT = 1,
	TERMINAL_APPLICATION_STYLE_DARK = 2
} TerminalApplicationStyle;

#define TERMINAL_TYPE_APPLICATION_STYLE (terminal_application_style_get_type ())

#define TERMINAL_TYPE_SETTINGS (terminal_settings_get_type ())
#define TERMINAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettings))
#define TERMINAL_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))
#define TERMINAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))

typedef struct _TerminalSettings TerminalSettings;
typedef struct _TerminalSettingsClass TerminalSettingsClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _TerminalStyleSwitcher {
	GtkWidget parent_instance;
	TerminalStyleSwitcherPrivate * priv;
};

struct _TerminalStyleSwitcherClass {
	GtkWidgetClass parent_class;
};

struct _TerminalStyleSwitcherPrivate {
	GtkCheckButton* system_selector;
	GtkCheckButton* light_selector;
	GtkCheckButton* dark_selector;
	guint _style;
	gboolean _show_system;
};

static gint TerminalStyleSwitcher_private_offset;
static gpointer terminal_style_switcher_parent_class = NULL;

VALA_EXTERN GType terminal_style_switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalStyleSwitcher, g_object_unref)
static void terminal_style_switcher_on_style_changed (TerminalStyleSwitcher* self);
VALA_EXTERN guint terminal_style_switcher_get_style (TerminalStyleSwitcher* self);
VALA_EXTERN GType terminal_application_style_get_type (void) G_GNUC_CONST ;
static void terminal_style_switcher_theme_check_active_changed (TerminalStyleSwitcher* self);
VALA_EXTERN void terminal_style_switcher_set_style (TerminalStyleSwitcher* self,
                                        guint value);
static void _terminal_style_switcher_theme_check_active_changed_gtk_check_button_toggled (GtkCheckButton* _sender,
                                                                                   gpointer self);
VALA_EXTERN TerminalStyleSwitcher* terminal_style_switcher_new (void);
VALA_EXTERN TerminalStyleSwitcher* terminal_style_switcher_construct (GType object_type);
VALA_EXTERN gboolean terminal_style_switcher_get_show_system (TerminalStyleSwitcher* self);
VALA_EXTERN void terminal_style_switcher_set_show_system (TerminalStyleSwitcher* self,
                                              gboolean value);
static GObject * terminal_style_switcher_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _terminal_style_switcher_on_style_changed_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
VALA_EXTERN GType terminal_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalSettings, g_object_unref)
VALA_EXTERN TerminalSettings* terminal_settings_get_default (void);
static void terminal_style_switcher_finalize (GObject * obj);
static GType terminal_style_switcher_get_type_once (void);
static void _vala_terminal_style_switcher_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_terminal_style_switcher_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
terminal_style_switcher_get_instance_private (TerminalStyleSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalStyleSwitcher_private_offset);
}

static void
terminal_style_switcher_on_style_changed (TerminalStyleSwitcher* self)
{
	guint _tmp0_;
#line 49 "../src/widgets/StyleSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/widgets/StyleSwitcher.vala"
	g_object_freeze_notify ((GObject*) self);
#line 51 "../src/widgets/StyleSwitcher.vala"
	_tmp0_ = self->priv->_style;
#line 51 "../src/widgets/StyleSwitcher.vala"
	if (_tmp0_ == ((guint) TERMINAL_APPLICATION_STYLE_SYSTEM)) {
#line 152 "StyleSwitcher.c"
		GtkCheckButton* _tmp1_;
		GtkCheckButton* _tmp2_;
		GtkCheckButton* _tmp3_;
#line 52 "../src/widgets/StyleSwitcher.vala"
		_tmp1_ = self->priv->system_selector;
#line 52 "../src/widgets/StyleSwitcher.vala"
		gtk_check_button_set_active (_tmp1_, TRUE);
#line 53 "../src/widgets/StyleSwitcher.vala"
		_tmp2_ = self->priv->light_selector;
#line 53 "../src/widgets/StyleSwitcher.vala"
		gtk_check_button_set_active (_tmp2_, FALSE);
#line 54 "../src/widgets/StyleSwitcher.vala"
		_tmp3_ = self->priv->dark_selector;
#line 54 "../src/widgets/StyleSwitcher.vala"
		gtk_check_button_set_active (_tmp3_, FALSE);
#line 168 "StyleSwitcher.c"
	} else {
		guint _tmp4_;
#line 56 "../src/widgets/StyleSwitcher.vala"
		_tmp4_ = self->priv->_style;
#line 56 "../src/widgets/StyleSwitcher.vala"
		if (_tmp4_ == ((guint) TERMINAL_APPLICATION_STYLE_LIGHT)) {
#line 175 "StyleSwitcher.c"
			GtkCheckButton* _tmp5_;
			GtkCheckButton* _tmp6_;
			GtkCheckButton* _tmp7_;
#line 57 "../src/widgets/StyleSwitcher.vala"
			_tmp5_ = self->priv->system_selector;
#line 57 "../src/widgets/StyleSwitcher.vala"
			gtk_check_button_set_active (_tmp5_, FALSE);
#line 58 "../src/widgets/StyleSwitcher.vala"
			_tmp6_ = self->priv->light_selector;
#line 58 "../src/widgets/StyleSwitcher.vala"
			gtk_check_button_set_active (_tmp6_, TRUE);
#line 59 "../src/widgets/StyleSwitcher.vala"
			_tmp7_ = self->priv->dark_selector;
#line 59 "../src/widgets/StyleSwitcher.vala"
			gtk_check_button_set_active (_tmp7_, FALSE);
#line 191 "StyleSwitcher.c"
		} else {
			GtkCheckButton* _tmp8_;
			GtkCheckButton* _tmp9_;
			GtkCheckButton* _tmp10_;
#line 62 "../src/widgets/StyleSwitcher.vala"
			_tmp8_ = self->priv->system_selector;
#line 62 "../src/widgets/StyleSwitcher.vala"
			gtk_check_button_set_active (_tmp8_, FALSE);
#line 63 "../src/widgets/StyleSwitcher.vala"
			_tmp9_ = self->priv->light_selector;
#line 63 "../src/widgets/StyleSwitcher.vala"
			gtk_check_button_set_active (_tmp9_, FALSE);
#line 64 "../src/widgets/StyleSwitcher.vala"
			_tmp10_ = self->priv->dark_selector;
#line 64 "../src/widgets/StyleSwitcher.vala"
			gtk_check_button_set_active (_tmp10_, TRUE);
#line 208 "StyleSwitcher.c"
		}
	}
#line 66 "../src/widgets/StyleSwitcher.vala"
	g_object_thaw_notify ((GObject*) self);
#line 213 "StyleSwitcher.c"
}

static void
terminal_style_switcher_theme_check_active_changed (TerminalStyleSwitcher* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 70 "../src/widgets/StyleSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/widgets/StyleSwitcher.vala"
	_tmp0_ = self->priv->system_selector;
#line 71 "../src/widgets/StyleSwitcher.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 71 "../src/widgets/StyleSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 71 "../src/widgets/StyleSwitcher.vala"
	if (_tmp2_) {
#line 232 "StyleSwitcher.c"
		guint _tmp3_;
#line 72 "../src/widgets/StyleSwitcher.vala"
		_tmp3_ = self->priv->_style;
#line 72 "../src/widgets/StyleSwitcher.vala"
		if (_tmp3_ != ((guint) TERMINAL_APPLICATION_STYLE_SYSTEM)) {
#line 73 "../src/widgets/StyleSwitcher.vala"
			terminal_style_switcher_set_style (self, (guint) TERMINAL_APPLICATION_STYLE_SYSTEM);
#line 240 "StyleSwitcher.c"
		}
	} else {
		GtkCheckButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 76 "../src/widgets/StyleSwitcher.vala"
		_tmp4_ = self->priv->light_selector;
#line 76 "../src/widgets/StyleSwitcher.vala"
		_tmp5_ = gtk_check_button_get_active (_tmp4_);
#line 76 "../src/widgets/StyleSwitcher.vala"
		_tmp6_ = _tmp5_;
#line 76 "../src/widgets/StyleSwitcher.vala"
		if (_tmp6_) {
#line 254 "StyleSwitcher.c"
			guint _tmp7_;
#line 77 "../src/widgets/StyleSwitcher.vala"
			_tmp7_ = self->priv->_style;
#line 77 "../src/widgets/StyleSwitcher.vala"
			if (_tmp7_ != ((guint) TERMINAL_APPLICATION_STYLE_LIGHT)) {
#line 78 "../src/widgets/StyleSwitcher.vala"
				terminal_style_switcher_set_style (self, (guint) TERMINAL_APPLICATION_STYLE_LIGHT);
#line 262 "StyleSwitcher.c"
			}
		} else {
			guint _tmp8_;
#line 82 "../src/widgets/StyleSwitcher.vala"
			_tmp8_ = self->priv->_style;
#line 82 "../src/widgets/StyleSwitcher.vala"
			if (_tmp8_ != ((guint) TERMINAL_APPLICATION_STYLE_DARK)) {
#line 83 "../src/widgets/StyleSwitcher.vala"
				terminal_style_switcher_set_style (self, (guint) TERMINAL_APPLICATION_STYLE_DARK);
#line 272 "StyleSwitcher.c"
			}
		}
	}
}

static void
_terminal_style_switcher_theme_check_active_changed_gtk_check_button_toggled (GtkCheckButton* _sender,
                                                                              gpointer self)
{
#line 23 "../src/widgets/StyleSwitcher.vala"
	terminal_style_switcher_theme_check_active_changed ((TerminalStyleSwitcher*) self);
#line 284 "StyleSwitcher.c"
}

TerminalStyleSwitcher*
terminal_style_switcher_construct (GType object_type)
{
	TerminalStyleSwitcher * self = NULL;
#line 23 "../src/widgets/StyleSwitcher.vala"
	self = (TerminalStyleSwitcher*) g_object_new (object_type, NULL);
#line 23 "../src/widgets/StyleSwitcher.vala"
	return self;
#line 295 "StyleSwitcher.c"
}

TerminalStyleSwitcher*
terminal_style_switcher_new (void)
{
#line 23 "../src/widgets/StyleSwitcher.vala"
	return terminal_style_switcher_construct (TERMINAL_TYPE_STYLE_SWITCHER);
#line 303 "StyleSwitcher.c"
}

guint
terminal_style_switcher_get_style (TerminalStyleSwitcher* self)
{
	guint result;
#line 29 "../src/widgets/StyleSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 29 "../src/widgets/StyleSwitcher.vala"
	result = self->priv->_style;
#line 29 "../src/widgets/StyleSwitcher.vala"
	return result;
#line 316 "StyleSwitcher.c"
}

void
terminal_style_switcher_set_style (TerminalStyleSwitcher* self,
                                   guint value)
{
	guint old_value;
#line 29 "../src/widgets/StyleSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/widgets/StyleSwitcher.vala"
	old_value = terminal_style_switcher_get_style (self);
#line 29 "../src/widgets/StyleSwitcher.vala"
	if (old_value != value) {
#line 29 "../src/widgets/StyleSwitcher.vala"
		self->priv->_style = value;
#line 29 "../src/widgets/StyleSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_style_switcher_properties[TERMINAL_STYLE_SWITCHER_STYLE_PROPERTY]);
#line 334 "StyleSwitcher.c"
	}
}

gboolean
terminal_style_switcher_get_show_system (TerminalStyleSwitcher* self)
{
	gboolean result;
#line 30 "../src/widgets/StyleSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/widgets/StyleSwitcher.vala"
	result = self->priv->_show_system;
#line 30 "../src/widgets/StyleSwitcher.vala"
	return result;
#line 348 "StyleSwitcher.c"
}

void
terminal_style_switcher_set_show_system (TerminalStyleSwitcher* self,
                                         gboolean value)
{
	gboolean old_value;
#line 30 "../src/widgets/StyleSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/widgets/StyleSwitcher.vala"
	old_value = terminal_style_switcher_get_show_system (self);
#line 30 "../src/widgets/StyleSwitcher.vala"
	if (old_value != value) {
#line 30 "../src/widgets/StyleSwitcher.vala"
		self->priv->_show_system = value;
#line 30 "../src/widgets/StyleSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_style_switcher_properties[TERMINAL_STYLE_SWITCHER_SHOW_SYSTEM_PROPERTY]);
#line 366 "StyleSwitcher.c"
	}
}

static void
_terminal_style_switcher_on_style_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 38 "../src/widgets/StyleSwitcher.vala"
	terminal_style_switcher_on_style_changed ((TerminalStyleSwitcher*) self);
#line 377 "StyleSwitcher.c"
}

static GObject *
terminal_style_switcher_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TerminalStyleSwitcher * self;
	TerminalSettings* s = NULL;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
#line 37 "../src/widgets/StyleSwitcher.vala"
	parent_class = G_OBJECT_CLASS (terminal_style_switcher_parent_class);
#line 37 "../src/widgets/StyleSwitcher.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/widgets/StyleSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_STYLE_SWITCHER, TerminalStyleSwitcher);
#line 38 "../src/widgets/StyleSwitcher.vala"
	g_signal_connect_object ((GObject*) self, "notify::style", (GCallback) _terminal_style_switcher_on_style_changed_g_object_notify, self, 0);
#line 40 "../src/widgets/StyleSwitcher.vala"
	_tmp0_ = terminal_settings_get_default ();
#line 40 "../src/widgets/StyleSwitcher.vala"
	s = _tmp0_;
#line 41 "../src/widgets/StyleSwitcher.vala"
	_tmp1_ = s;
#line 41 "../src/widgets/StyleSwitcher.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp1_, "style-preference", (GObject*) self, "style", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 37 "../src/widgets/StyleSwitcher.vala"
	_g_object_unref0 (s);
#line 37 "../src/widgets/StyleSwitcher.vala"
	return obj;
#line 411 "StyleSwitcher.c"
}

static void
terminal_style_switcher_class_init (TerminalStyleSwitcherClass * klass,
                                    gpointer klass_data)
{
#line 23 "../src/widgets/StyleSwitcher.vala"
	terminal_style_switcher_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/widgets/StyleSwitcher.vala"
	g_type_class_adjust_private_offset (klass, &TerminalStyleSwitcher_private_offset);
#line 23 "../src/widgets/StyleSwitcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_style_switcher_get_property;
#line 23 "../src/widgets/StyleSwitcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_style_switcher_set_property;
#line 23 "../src/widgets/StyleSwitcher.vala"
	G_OBJECT_CLASS (klass)->constructor = terminal_style_switcher_constructor;
#line 23 "../src/widgets/StyleSwitcher.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_style_switcher_finalize;
#line 23 "../src/widgets/StyleSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_STYLE_SWITCHER_STYLE_PROPERTY, terminal_style_switcher_properties[TERMINAL_STYLE_SWITCHER_STYLE_PROPERTY] = g_param_spec_uint ("style", "style", "style", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/widgets/StyleSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_STYLE_SWITCHER_SHOW_SYSTEM_PROPERTY, terminal_style_switcher_properties[TERMINAL_STYLE_SWITCHER_SHOW_SYSTEM_PROPERTY] = g_param_spec_boolean ("show-system", "show-system", "show-system", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/widgets/StyleSwitcher.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/raggesilver/BlackBox/gtk/style-switcher.ui");
#line 23 "../src/widgets/StyleSwitcher.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "system_selector", FALSE, TerminalStyleSwitcher_private_offset + G_STRUCT_OFFSET (TerminalStyleSwitcherPrivate, system_selector));
#line 23 "../src/widgets/StyleSwitcher.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "light_selector", FALSE, TerminalStyleSwitcher_private_offset + G_STRUCT_OFFSET (TerminalStyleSwitcherPrivate, light_selector));
#line 23 "../src/widgets/StyleSwitcher.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "dark_selector", FALSE, TerminalStyleSwitcher_private_offset + G_STRUCT_OFFSET (TerminalStyleSwitcherPrivate, dark_selector));
#line 23 "../src/widgets/StyleSwitcher.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "theme_check_active_changed", G_CALLBACK(_terminal_style_switcher_theme_check_active_changed_gtk_check_button_toggled));
#line 33 "../src/widgets/StyleSwitcher.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_bin_layout_get_type ());
#line 34 "../src/widgets/StyleSwitcher.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "themeswitcher");
#line 448 "StyleSwitcher.c"
}

static void
terminal_style_switcher_instance_init (TerminalStyleSwitcher * self,
                                       gpointer klass)
{
#line 23 "../src/widgets/StyleSwitcher.vala"
	self->priv = terminal_style_switcher_get_instance_private (self);
#line 30 "../src/widgets/StyleSwitcher.vala"
	self->priv->_show_system = TRUE;
#line 23 "../src/widgets/StyleSwitcher.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 461 "StyleSwitcher.c"
}

static void
terminal_style_switcher_finalize (GObject * obj)
{
	TerminalStyleSwitcher * self;
#line 23 "../src/widgets/StyleSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_STYLE_SWITCHER, TerminalStyleSwitcher);
#line 23 "../src/widgets/StyleSwitcher.vala"
	G_OBJECT_CLASS (terminal_style_switcher_parent_class)->finalize (obj);
#line 472 "StyleSwitcher.c"
}

static GType
terminal_style_switcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalStyleSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_style_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalStyleSwitcher), 0, (GInstanceInitFunc) terminal_style_switcher_instance_init, NULL };
	GType terminal_style_switcher_type_id;
	terminal_style_switcher_type_id = g_type_register_static (gtk_widget_get_type (), "TerminalStyleSwitcher", &g_define_type_info, 0);
	TerminalStyleSwitcher_private_offset = g_type_add_instance_private (terminal_style_switcher_type_id, sizeof (TerminalStyleSwitcherPrivate));
	return terminal_style_switcher_type_id;
}

GType
terminal_style_switcher_get_type (void)
{
	static volatile gsize terminal_style_switcher_type_id__once = 0;
	if (g_once_init_enter (&terminal_style_switcher_type_id__once)) {
		GType terminal_style_switcher_type_id;
		terminal_style_switcher_type_id = terminal_style_switcher_get_type_once ();
		g_once_init_leave (&terminal_style_switcher_type_id__once, terminal_style_switcher_type_id);
	}
	return terminal_style_switcher_type_id__once;
}

static void
_vala_terminal_style_switcher_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	TerminalStyleSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_STYLE_SWITCHER, TerminalStyleSwitcher);
#line 23 "../src/widgets/StyleSwitcher.vala"
	switch (property_id) {
#line 23 "../src/widgets/StyleSwitcher.vala"
		case TERMINAL_STYLE_SWITCHER_STYLE_PROPERTY:
#line 23 "../src/widgets/StyleSwitcher.vala"
		g_value_set_uint (value, terminal_style_switcher_get_style (self));
#line 23 "../src/widgets/StyleSwitcher.vala"
		break;
#line 23 "../src/widgets/StyleSwitcher.vala"
		case TERMINAL_STYLE_SWITCHER_SHOW_SYSTEM_PROPERTY:
#line 23 "../src/widgets/StyleSwitcher.vala"
		g_value_set_boolean (value, terminal_style_switcher_get_show_system (self));
#line 23 "../src/widgets/StyleSwitcher.vala"
		break;
#line 519 "StyleSwitcher.c"
		default:
#line 23 "../src/widgets/StyleSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/widgets/StyleSwitcher.vala"
		break;
#line 525 "StyleSwitcher.c"
	}
}

static void
_vala_terminal_style_switcher_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	TerminalStyleSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_STYLE_SWITCHER, TerminalStyleSwitcher);
#line 23 "../src/widgets/StyleSwitcher.vala"
	switch (property_id) {
#line 23 "../src/widgets/StyleSwitcher.vala"
		case TERMINAL_STYLE_SWITCHER_STYLE_PROPERTY:
#line 23 "../src/widgets/StyleSwitcher.vala"
		terminal_style_switcher_set_style (self, g_value_get_uint (value));
#line 23 "../src/widgets/StyleSwitcher.vala"
		break;
#line 23 "../src/widgets/StyleSwitcher.vala"
		case TERMINAL_STYLE_SWITCHER_SHOW_SYSTEM_PROPERTY:
#line 23 "../src/widgets/StyleSwitcher.vala"
		terminal_style_switcher_set_show_system (self, g_value_get_boolean (value));
#line 23 "../src/widgets/StyleSwitcher.vala"
		break;
#line 551 "StyleSwitcher.c"
		default:
#line 23 "../src/widgets/StyleSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/widgets/StyleSwitcher.vala"
		break;
#line 557 "StyleSwitcher.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

