/* Terminal.c generated by valac 0.56.13, the Vala compiler
 * generated from Terminal.vala, do not modify */

/* Terminal.vala
 *
 * Copyright 2020-2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#define _GNU_SOURCE

#include <vte/vte.h>
#include <glib-object.h>
#include <adwaita.h>
#include <glib.h>
#include <gio/gio.h>
#include <pqmarble.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pcre2.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>

#define TERMINAL_APP_NAME "BlackBox"
#define TERMINAL_CONSTANTS_SCHEME "(?:news:|telnet:|nntp:|file:\\/|https?:|ftps?:|sftp:|webcal:" "|irc:|sftp:|ldaps?:|nfs:|smb:|rsync:|ssh:|rlogin:|telnet:|git:" "|git\\+ssh:|bzr:|bzr\\+ssh:|svn:|svn\\+ssh:|hg:|mailto:|magnet:)"
#define TERMINAL_CONSTANTS_USERCHARS "-[:alnum:]"
#define TERMINAL_CONSTANTS_USERCHARS_CLASS "[" TERMINAL_CONSTANTS_USERCHARS "]"
#define TERMINAL_CONSTANTS_PASSCHARS_CLASS "[-[:alnum:]\\Q,?;.:/!%$^*&~\"#'\\E]"
#define TERMINAL_CONSTANTS_USERPASS TERMINAL_CONSTANTS_USERCHARS_CLASS "+(?:" TERMINAL_CONSTANTS_PASSCHARS_CLASS "+)?"
#define TERMINAL_CONSTANTS_HOSTCHARS_CLASS "[-[:alnum:]]"
#define TERMINAL_CONSTANTS_HOST TERMINAL_CONSTANTS_HOSTCHARS_CLASS "+(\\." TERMINAL_CONSTANTS_HOSTCHARS_CLASS "+)*"
#define TERMINAL_CONSTANTS_PORT "(?:\\:[[:digit:]]{1,5})?"
#define TERMINAL_CONSTANTS_PATHCHARS_CLASS "[-[:alnum:]\\Q_$.+!*,;:@&=?/~#%\\E]"
#define TERMINAL_CONSTANTS_PATHTERM_CLASS "[^\\Q]'.}>) \t\r\n,\"\\E]"
#define TERMINAL_CONSTANTS_URLPATH "(?:(/" TERMINAL_CONSTANTS_PATHCHARS_CLASS "+(?:[(]" TERMINAL_CONSTANTS_PATHCHARS_CLASS "*[)])*" TERMINAL_CONSTANTS_PATHCHARS_CLASS "*)*" TERMINAL_CONSTANTS_PATHTERM_CLASS ")?"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_TERMINAL (terminal_terminal_get_type ())
#define TERMINAL_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminal))
#define TERMINAL_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))
#define TERMINAL_IS_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_IS_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_TERMINAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))

typedef struct _TerminalTerminal TerminalTerminal;
typedef struct _TerminalTerminalClass TerminalTerminalClass;
typedef struct _TerminalTerminalPrivate TerminalTerminalPrivate;

#define TERMINAL_TYPE_WINDOW (terminal_window_get_type ())
#define TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_WINDOW, TerminalWindow))
#define TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_WINDOW, TerminalWindowClass))
#define TERMINAL_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_WINDOW))
#define TERMINAL_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_WINDOW))
#define TERMINAL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_WINDOW, TerminalWindowClass))

typedef struct _TerminalWindow TerminalWindow;
typedef struct _TerminalWindowClass TerminalWindowClass;

#define TERMINAL_TYPE_SCHEME (terminal_scheme_get_type ())
#define TERMINAL_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SCHEME, TerminalScheme))
#define TERMINAL_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SCHEME, TerminalSchemeClass))
#define TERMINAL_IS_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SCHEME))
#define TERMINAL_IS_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SCHEME))
#define TERMINAL_SCHEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SCHEME, TerminalSchemeClass))

typedef struct _TerminalScheme TerminalScheme;
typedef struct _TerminalSchemeClass TerminalSchemeClass;

#define TERMINAL_TYPE_PROCESS (terminal_process_get_type ())
#define TERMINAL_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS, TerminalProcess))
#define TERMINAL_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS, TerminalProcessClass))
#define TERMINAL_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS))
#define TERMINAL_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS))
#define TERMINAL_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS, TerminalProcessClass))

typedef struct _TerminalProcess TerminalProcess;
typedef struct _TerminalProcessClass TerminalProcessClass;

#define TERMINAL_TYPE_SETTINGS (terminal_settings_get_type ())
#define TERMINAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettings))
#define TERMINAL_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))
#define TERMINAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))

typedef struct _TerminalSettings TerminalSettings;
typedef struct _TerminalSettingsClass TerminalSettingsClass;
enum  {
	TERMINAL_TERMINAL_0_PROPERTY,
	TERMINAL_TERMINAL_SCHEME_PROPERTY,
	TERMINAL_TERMINAL_PID_PROPERTY,
	TERMINAL_TERMINAL_PROCESS_PROPERTY,
	TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY,
	TERMINAL_TERMINAL_NUM_PROPERTIES
};
static GParamSpec* terminal_terminal_properties[TERMINAL_TERMINAL_NUM_PROPERTIES];
typedef enum  {
	TERMINAL_TERMINAL_DROP_TARGETS_URILIST,
	TERMINAL_TERMINAL_DROP_TARGETS_STRING,
	TERMINAL_TERMINAL_DROP_TARGETS_TEXT
} TerminalTerminalDropTargets;

#define TERMINAL_TERMINAL_TYPE_DROP_TARGETS (terminal_terminal_drop_targets_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_TYPE_THEME_PROVIDER (terminal_theme_provider_get_type ())
#define TERMINAL_THEME_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProvider))
#define TERMINAL_THEME_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProviderClass))
#define TERMINAL_IS_THEME_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_THEME_PROVIDER))
#define TERMINAL_IS_THEME_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_THEME_PROVIDER))
#define TERMINAL_THEME_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProviderClass))

typedef struct _TerminalThemeProvider TerminalThemeProvider;
typedef struct _TerminalThemeProviderClass TerminalThemeProviderClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GdkFileList_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkFileList_free (var), NULL)))
#define _vte_regex_unref0(var) ((var == NULL) ? NULL : (var = (vte_regex_unref (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))
typedef struct _TerminalThemeProviderPrivate TerminalThemeProviderPrivate;

#define TERMINAL_TYPE_PADDING (terminal_padding_get_type ())
typedef struct _TerminalPadding TerminalPadding;
#define _gdk_event_unref0(var) ((var == NULL) ? NULL : (var = (gdk_event_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef enum  {
	TERMINAL_PROCESS_CONTEXT_DEFAULT,
	TERMINAL_PROCESS_CONTEXT_ROOT,
	TERMINAL_PROCESS_CONTEXT_SSH
} TerminalProcessContext;

#define TERMINAL_TYPE_PROCESS_CONTEXT (terminal_process_context_get_type ())

#define TERMINAL_TYPE_PROCESS_WATCHER (terminal_process_watcher_get_type ())
#define TERMINAL_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcher))
#define TERMINAL_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))
#define TERMINAL_IS_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_IS_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_PROCESS_WATCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))

typedef struct _TerminalProcessWatcher TerminalProcessWatcher;
typedef struct _TerminalProcessWatcherClass TerminalProcessWatcherClass;
typedef void (*TerminalHostCommandExitedCallback) (guint pid, guint status, gpointer user_data);
typedef struct _TerminalTerminalSpawnOnFlatpakData TerminalTerminalSpawnOnFlatpakData;
typedef struct _TerminalTerminalGetCanCloseData TerminalTerminalGetCanCloseData;
typedef struct _TerminalTerminalDoPasteFromSelectionClipboardData TerminalTerminalDoPasteFromSelectionClipboardData;
typedef enum  {
	TERMINAL_WORKING_DIRECTORY_MODE_PREVIOUS_SESSION = 0,
	TERMINAL_WORKING_DIRECTORY_MODE_HOME_DIRECTORY = 1,
	TERMINAL_WORKING_DIRECTORY_MODE_CUSTOM = 2
} TerminalWorkingDirectoryMode;

#define TERMINAL_TYPE_WORKING_DIRECTORY_MODE (terminal_working_directory_mode_get_type ())
typedef enum  {
	TERMINAL_SCROLLBACK_MODE_FIXED = 0,
	TERMINAL_SCROLLBACK_MODE_UNLIMITED = 1,
	TERMINAL_SCROLLBACK_MODE_DISABLED = 2
} TerminalScrollbackMode;

#define TERMINAL_TYPE_SCROLLBACK_MODE (terminal_scrollback_mode_get_type ())
enum  {
	TERMINAL_TERMINAL_EXIT_SIGNAL,
	TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL,
	TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL,
	TERMINAL_TERMINAL_NUM_SIGNALS
};
static guint terminal_terminal_signals[TERMINAL_TERMINAL_NUM_SIGNALS] = {0};

struct _TerminalTerminal {
	VteTerminal parent_instance;
	TerminalTerminalPrivate * priv;
	TerminalWindow* window;
};

struct _TerminalTerminalClass {
	VteTerminalClass parent_class;
};

struct _TerminalTerminalPrivate {
	TerminalScheme* _scheme;
	GPid _pid;
	TerminalProcess* _process;
	guint original_scrollback_lines;
	GCancellable* fp_spawn_host_command_callback_cancellable;
	TerminalSettings* settings;
	GtkCssProvider* padding_provider;
};

struct _TerminalThemeProvider {
	GObject parent_instance;
	TerminalThemeProviderPrivate * priv;
	GHashTable* themes;
};

struct _TerminalThemeProviderClass {
	GObjectClass parent_class;
};

struct _TerminalPadding {
	guint top;
	guint right;
	guint bottom;
	guint left;
};

struct _TerminalTerminalSpawnOnFlatpakData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TerminalTerminal* self;
	VtePtyFlags flags;
	gchar* cwd;
	GArray* argv;
	GArray* envv;
	GPid p;
	gboolean result;
	VtePty* _ppty;
	VtePty* _tmp0_;
	VtePty* _tmp1_;
	VtePty* _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	gint pty_master;
	VtePty* _tmp5_;
	gint* pty_slaves;
	gint* _tmp6_;
	gint pty_slaves_length1;
	gint _pty_slaves_size_;
	const gchar* _tmp7_;
	gint* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	gint* _tmp10_;
	gint _tmp10__length1;
	gint _tmp11_;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
	GCancellable* _tmp14_;
	gboolean res;
	gint* _tmp15_;
	gint _tmp15__length1;
	GCancellable* _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_;
	VtePty* _tmp19_;
	GError* _inner_error0_;
};

struct _TerminalTerminalGetCanCloseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TerminalTerminal* self;
	gchar* command;
	gboolean result;
	gboolean _tmp0_;
	GPid _tmp1_;
	VtePty* _tmp2_;
	VtePty* _tmp3_;
	gint fd;
	VtePty* _tmp4_;
	VtePty* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint fgpid;
	GPid _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
};

struct _TerminalTerminalDoPasteFromSelectionClipboardData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TerminalTerminal* self;
	GdkClipboard* clipboard;
	GdkDisplay* _tmp0_;
	GdkClipboard* _tmp1_;
	GdkClipboard* _tmp2_;
	gchar* text;
	gchar* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

static gint TerminalTerminal_private_offset;
static gpointer terminal_terminal_parent_class = NULL;
static gchar** terminal_terminal_blackbox_envv;
static gint terminal_terminal_blackbox_envv_length1;
static gchar** terminal_terminal_blackbox_envv = NULL;
static gint terminal_terminal_blackbox_envv_length1 = 0;
static gint _terminal_terminal_blackbox_envv_size_ = 0;

VALA_EXTERN GType terminal_terminal_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalTerminal, g_object_unref)
VALA_EXTERN GType terminal_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalWindow, g_object_unref)
VALA_EXTERN GType terminal_scheme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalScheme, g_object_unref)
VALA_EXTERN GType terminal_process_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcess, g_object_unref)
VALA_EXTERN GType terminal_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalSettings, g_object_unref)
static GType terminal_terminal_drop_targets_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN gchar* terminal_constants_get_user_schemes_dir (void);
VALA_EXTERN TerminalTerminal* terminal_terminal_new (TerminalWindow* window,
                                         const gchar* command,
                                         const gchar* cwd);
VALA_EXTERN TerminalTerminal* terminal_terminal_construct (GType object_type,
                                               TerminalWindow* window,
                                               const gchar* command,
                                               const gchar* cwd);
static void terminal_terminal_on_child_exited (TerminalTerminal* self,
                                        gint status);
static void _terminal_terminal_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                                   gint status,
                                                                   gpointer self);
VALA_EXTERN TerminalSettings* terminal_settings_get_default (void);
VALA_EXTERN GType terminal_theme_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalThemeProvider, g_object_unref)
VALA_EXTERN TerminalThemeProvider* terminal_theme_provider_get_default (void);
static void terminal_terminal_on_theme_changed (TerminalTerminal* self);
static void _terminal_terminal_on_theme_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void terminal_terminal_on_font_changed (TerminalTerminal* self);
static void _terminal_terminal_on_font_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void terminal_terminal_on_padding_changed (TerminalTerminal* self);
static void _terminal_terminal_on_padding_changed_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void terminal_terminal_setup_drag_drop (TerminalTerminal* self);
static void terminal_terminal_setup_regexes (TerminalTerminal* self);
static void terminal_terminal_connect_signals (TerminalTerminal* self);
static void terminal_terminal_bind_data (TerminalTerminal* self);
static void terminal_terminal_spawn (TerminalTerminal* self,
                              const gchar* command,
                              const gchar* cwd,
                              GError** error);
static void terminal_terminal_real_dispose (GObject* base);
static gboolean terminal_terminal_on_drag_data_received (TerminalTerminal* self,
                                                  GtkDropTarget* target,
                                                  GValue* value,
                                                  gdouble x,
                                                  gdouble y);
static gboolean _terminal_terminal_on_drag_data_received_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                                        GValue* value,
                                                                        gdouble x,
                                                                        gdouble y,
                                                                        gpointer self);
static GdkFileList* _vala_GdkFileList_copy (GdkFileList* self);
static void _vala_GdkFileList_free (GdkFileList* self);
VALA_EXTERN const gchar* terminal_settings_get_font (TerminalSettings* self);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void terminal_terminal_get_background_color (TerminalTerminal* self,
                                             TerminalScheme* theme,
                                             GdkRGBA* result);
VALA_EXTERN GdkRGBA* terminal_scheme_get_background_color (TerminalScheme* self);
VALA_EXTERN guint terminal_settings_get_opacity (TerminalSettings* self);
static void _vala_GdkRGBA_free (GdkRGBA* self);
VALA_EXTERN const gchar* terminal_theme_provider_get_current_theme (TerminalThemeProvider* self);
VALA_EXTERN GdkRGBA* terminal_scheme_get_foreground_color (TerminalScheme* self);
VALA_EXTERN GArray* terminal_scheme_get_palette (TerminalScheme* self);
VALA_EXTERN GType terminal_padding_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalPadding* terminal_padding_dup (const TerminalPadding* self);
VALA_EXTERN void terminal_padding_free (TerminalPadding* self);
VALA_EXTERN void terminal_settings_get_padding (TerminalSettings* self,
                                    TerminalPadding* result);
static gboolean terminal_terminal_on_key_pressed (TerminalTerminal* self,
                                           guint keyval,
                                           guint keycode,
                                           GdkModifierType state);
static gboolean _terminal_terminal_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                 guint keyval,
                                                                                 guint keycode,
                                                                                 GdkModifierType state,
                                                                                 gpointer self);
static void __lambda11_ (TerminalTerminal* self,
                  GtkGestureClick* gesture,
                  gint n_clicked,
                  gdouble x,
                  gdouble y);
static void ___lambda11__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static void __lambda12_ (TerminalTerminal* self);
static void ___lambda12__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda13_ (TerminalTerminal* self);
static void ___lambda13__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void _g_free0_ (gpointer var);
static void _vala_gchar_free_function_content_of (gpointer data);
VALA_EXTERN gboolean terminal_settings_get_use_custom_command (TerminalSettings* self);
VALA_EXTERN const gchar* terminal_settings_get_custom_shell_command (TerminalSettings* self);
VALA_EXTERN gchar* terminal_fp_guess_shell (GCancellable* cancellable,
                                GError** error);
VALA_EXTERN gchar** terminal_fp_get_env (GCancellable* cancellable,
                             gint* result_length1,
                             GError** error);
VALA_EXTERN gboolean terminal_settings_get_command_as_login_shell (TerminalSettings* self);
static void terminal_terminal_spawn_on_flatpak (TerminalTerminal* self,
                                         VtePtyFlags flags,
                                         const gchar* cwd,
                                         GArray* argv,
                                         GArray* envv,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static gboolean terminal_terminal_spawn_on_flatpak_finish (TerminalTerminal* self,
                                                    GAsyncResult* _res_,
                                                    GPid* p,
                                                    GError** error);
static void __lambda15_ (TerminalTerminal* self,
                  GObject* o,
                  GAsyncResult* _);
VALA_EXTERN void terminal_terminal_set_pid (TerminalTerminal* self,
                                GPid value);
static void terminal_terminal_on_spawn_finished (TerminalTerminal* self);
static void ___lambda15__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
VALA_EXTERN GPid terminal_terminal_get_pid (TerminalTerminal* self);
VALA_EXTERN TerminalProcess* terminal_process_new (void);
VALA_EXTERN TerminalProcess* terminal_process_construct (GType object_type);
VALA_EXTERN void terminal_process_set_terminal_fd (TerminalProcess* self,
                                       gint value);
VALA_EXTERN void terminal_process_set_pid (TerminalProcess* self,
                               GPid value);
VALA_EXTERN void terminal_process_set_foreground_pid (TerminalProcess* self,
                                          GPid value);
VALA_EXTERN void terminal_terminal_set_process (TerminalTerminal* self,
                                    TerminalProcess* value);
VALA_EXTERN TerminalProcess* terminal_terminal_get_process (TerminalTerminal* self);
static void __lambda16_ (TerminalTerminal* self,
                  TerminalProcess* _process);
VALA_EXTERN gboolean terminal_settings_get_notify_process_completion (TerminalSettings* self);
VALA_EXTERN const gchar* terminal_process_get_last_foreground_task_command (TerminalProcess* self);
static void ___lambda16__terminal_process_foreground_task_finished (TerminalProcess* _sender,
                                                             gpointer self);
static void __lambda17_ (TerminalTerminal* self,
                  GObject* __process,
                  GParamSpec* spec);
VALA_EXTERN GType terminal_process_context_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalProcessContext terminal_process_get_context (TerminalProcess* self);
static TerminalProcessContext* _terminal_process_context_dup (TerminalProcessContext* self);
static void ___lambda17__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN GType terminal_process_watcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcessWatcher, g_object_unref)
VALA_EXTERN TerminalProcessWatcher* terminal_process_watcher_get_instance (void);
VALA_EXTERN gboolean terminal_process_watcher_watch (TerminalProcessWatcher* self,
                                         TerminalProcess* process);
static void terminal_terminal_spawn_on_flatpak_data_free (gpointer _data);
static gboolean terminal_terminal_spawn_on_flatpak_co (TerminalTerminalSpawnOnFlatpakData* _data_);
static void _vala_array_add3 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_array_add4 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_array_add5 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
VALA_EXTERN void terminal_send_host_command (const gchar* cwd,
                                 GArray* argv,
                                 GArray* envv,
                                 gint* fds,
                                 gint fds_length1,
                                 TerminalHostCommandExitedCallback callback,
                                 gpointer callback_target,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN gboolean terminal_send_host_command_finish (GAsyncResult* _res_,
                                            gint* pid,
                                            GError** error);
static void terminal_terminal_on_host_command_exited (TerminalTerminal* self,
                                               guint _pid,
                                               guint status);
static void _terminal_terminal_on_host_command_exited_terminal_host_command_exited_callback (guint pid,
                                                                                      guint status,
                                                                                      gpointer self);
static void terminal_terminal_spawn_on_flatpak_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
VALA_EXTERN gboolean terminal_settings_get_easy_copy_paste (TerminalSettings* self);
VALA_EXTERN void terminal_terminal_do_copy_clipboard (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_do_paste_clipboard (TerminalTerminal* self);
static void terminal_terminal_get_can_close_data_free (gpointer _data);
VALA_EXTERN void terminal_terminal_get_can_close (TerminalTerminal* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gboolean terminal_terminal_get_can_close_finish (TerminalTerminal* self,
                                                 GAsyncResult* _res_,
                                                 gchar** command);
static gboolean terminal_terminal_get_can_close_co (TerminalTerminalGetCanCloseData* _data_);
VALA_EXTERN void terminal_get_foreground_process (gint terminal_fd,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gint terminal_get_foreground_process_finish (GAsyncResult* _res_);
static void terminal_terminal_get_can_close_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
VALA_EXTERN gchar* terminal_get_process_cmdline (gint pid);
VALA_EXTERN void terminal_terminal_zoom_in (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_zoom_out (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_zoom_default (TerminalTerminal* self);
static void terminal_terminal_do_paste_from_selection_clipboard_data_free (gpointer _data);
VALA_EXTERN void terminal_terminal_do_paste_from_selection_clipboard (TerminalTerminal* self,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
VALA_EXTERN void terminal_terminal_do_paste_from_selection_clipboard_finish (TerminalTerminal* self,
                                                                 GAsyncResult* _res_);
static gboolean terminal_terminal_do_paste_from_selection_clipboard_co (TerminalTerminalDoPasteFromSelectionClipboardData* _data_);
static void terminal_terminal_do_paste_from_selection_clipboard_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
VALA_EXTERN gchar* terminal_terminal_get_current_working_directory (TerminalTerminal* self);
VALA_EXTERN gchar* terminal_terminal_get_current_working_directory_for_new_session (TerminalTerminal* previous_terminal);
VALA_EXTERN guint terminal_settings_get_working_directory_mode (TerminalSettings* self);
VALA_EXTERN const gchar* terminal_settings_get_custom_working_directory (TerminalSettings* self);
VALA_EXTERN GType terminal_working_directory_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalScheme* terminal_terminal_get_scheme (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_set_scheme (TerminalTerminal* self,
                                   TerminalScheme* value);
VALA_EXTERN guint terminal_terminal_get_user_scrollback_lines (TerminalTerminal* self);
VALA_EXTERN guint terminal_settings_get_scrollback_mode (TerminalSettings* self);
VALA_EXTERN GType terminal_scrollback_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint terminal_settings_get_scrollback_lines (TerminalSettings* self);
static void terminal_terminal_finalize (GObject * obj);
static GType terminal_terminal_get_type_once (void);
static void _vala_terminal_terminal_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_terminal_terminal_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const gchar* TERMINAL_CONSTANTS_URL_REGEX_STRINGS[5];

static inline gpointer
terminal_terminal_get_instance_private (TerminalTerminal* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalTerminal_private_offset);
}

/**
   * List of available drop targets for Terminal
   */
static GType
terminal_terminal_drop_targets_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_TERMINAL_DROP_TARGETS_URILIST, "TERMINAL_TERMINAL_DROP_TARGETS_URILIST", "urilist"}, {TERMINAL_TERMINAL_DROP_TARGETS_STRING, "TERMINAL_TERMINAL_DROP_TARGETS_STRING", "string"}, {TERMINAL_TERMINAL_DROP_TARGETS_TEXT, "TERMINAL_TERMINAL_DROP_TARGETS_TEXT", "text"}, {0, NULL, NULL}};
	GType terminal_terminal_drop_targets_type_id;
	terminal_terminal_drop_targets_type_id = g_enum_register_static ("TerminalTerminalDropTargets", values);
	return terminal_terminal_drop_targets_type_id;
}

static GType
terminal_terminal_drop_targets_get_type (void)
{
	static volatile gsize terminal_terminal_drop_targets_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_drop_targets_type_id__once)) {
		GType terminal_terminal_drop_targets_type_id;
		terminal_terminal_drop_targets_type_id = terminal_terminal_drop_targets_get_type_once ();
		g_once_init_leave (&terminal_terminal_drop_targets_type_id__once, terminal_terminal_drop_targets_type_id);
	}
	return terminal_terminal_drop_targets_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 93 "../src/widgets/Terminal.vala"
	return self ? g_object_ref (self) : NULL;
#line 636 "Terminal.c"
}

static void
_terminal_terminal_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                              gint status,
                                                              gpointer self)
{
#line 100 "../src/widgets/Terminal.vala"
	terminal_terminal_on_child_exited ((TerminalTerminal*) self, status);
#line 646 "Terminal.c"
}

static void
_terminal_terminal_on_theme_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 103 "../src/widgets/Terminal.vala"
	terminal_terminal_on_theme_changed ((TerminalTerminal*) self);
#line 656 "Terminal.c"
}

static void
_terminal_terminal_on_font_changed_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 104 "../src/widgets/Terminal.vala"
	terminal_terminal_on_font_changed ((TerminalTerminal*) self);
#line 666 "Terminal.c"
}

static void
_terminal_terminal_on_padding_changed_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 105 "../src/widgets/Terminal.vala"
	terminal_terminal_on_padding_changed ((TerminalTerminal*) self);
#line 676 "Terminal.c"
}

TerminalTerminal*
terminal_terminal_construct (GType object_type,
                             TerminalWindow* window,
                             const gchar* command,
                             const gchar* cwd)
{
	TerminalTerminal * self = NULL;
	guint _tmp0_;
	guint _tmp1_;
	TerminalWindow* _tmp2_;
	TerminalSettings* _tmp3_;
	TerminalThemeProvider* _tmp4_;
	TerminalThemeProvider* _tmp5_;
	TerminalSettings* _tmp6_;
	TerminalSettings* _tmp7_;
	TerminalSettings* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 84 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 85 "../src/widgets/Terminal.vala"
	self = (TerminalTerminal*) g_object_new (object_type, "allow-hyperlink", TRUE, "receives-default", TRUE, "scroll-unit-is-pixels", TRUE, NULL);
#line 91 "../src/widgets/Terminal.vala"
	_tmp0_ = vte_terminal_get_scrollback_lines ((VteTerminal*) self);
#line 91 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/widgets/Terminal.vala"
	self->priv->original_scrollback_lines = _tmp1_;
#line 93 "../src/widgets/Terminal.vala"
	_tmp2_ = _g_object_ref0 (window);
#line 93 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->window);
#line 93 "../src/widgets/Terminal.vala"
	self->window = _tmp2_;
#line 95 "../src/widgets/Terminal.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 96 "../src/widgets/Terminal.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 97 "../src/widgets/Terminal.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 98 "../src/widgets/Terminal.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 100 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((VteTerminal*) self, "child-exited", (GCallback) _terminal_terminal_on_child_exited_vte_terminal_child_exited, self, 0);
#line 102 "../src/widgets/Terminal.vala"
	_tmp3_ = terminal_settings_get_default ();
#line 102 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->settings);
#line 102 "../src/widgets/Terminal.vala"
	self->priv->settings = _tmp3_;
#line 103 "../src/widgets/Terminal.vala"
	_tmp4_ = terminal_theme_provider_get_default ();
#line 103 "../src/widgets/Terminal.vala"
	_tmp5_ = _tmp4_;
#line 103 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::current-theme", (GCallback) _terminal_terminal_on_theme_changed_g_object_notify, self, 0);
#line 103 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_tmp5_);
#line 104 "../src/widgets/Terminal.vala"
	_tmp6_ = self->priv->settings;
#line 104 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp6_, "notify::font", (GCallback) _terminal_terminal_on_font_changed_g_object_notify, self, 0);
#line 105 "../src/widgets/Terminal.vala"
	_tmp7_ = self->priv->settings;
#line 105 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::terminal-padding", (GCallback) _terminal_terminal_on_padding_changed_g_object_notify, self, 0);
#line 106 "../src/widgets/Terminal.vala"
	_tmp8_ = self->priv->settings;
#line 106 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp8_, "notify::opacity", (GCallback) _terminal_terminal_on_theme_changed_g_object_notify, self, 0);
#line 108 "../src/widgets/Terminal.vala"
	terminal_terminal_setup_drag_drop (self);
#line 109 "../src/widgets/Terminal.vala"
	terminal_terminal_setup_regexes (self);
#line 110 "../src/widgets/Terminal.vala"
	terminal_terminal_connect_signals (self);
#line 111 "../src/widgets/Terminal.vala"
	terminal_terminal_bind_data (self);
#line 112 "../src/widgets/Terminal.vala"
	terminal_terminal_on_theme_changed (self);
#line 113 "../src/widgets/Terminal.vala"
	terminal_terminal_on_font_changed (self);
#line 114 "../src/widgets/Terminal.vala"
	terminal_terminal_on_padding_changed (self);
#line 762 "Terminal.c"
	{
#line 117 "../src/widgets/Terminal.vala"
		terminal_terminal_spawn (self, command, cwd, &_inner_error0_);
#line 117 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 768 "Terminal.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 116 "../src/widgets/Terminal.vala"
		e = _inner_error0_;
#line 116 "../src/widgets/Terminal.vala"
		_inner_error0_ = NULL;
#line 120 "../src/widgets/Terminal.vala"
		_tmp9_ = e;
#line 120 "../src/widgets/Terminal.vala"
		_tmp10_ = _tmp9_->message;
#line 120 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:120: %s", _tmp10_);
#line 116 "../src/widgets/Terminal.vala"
		_g_error_free0 (e);
#line 790 "Terminal.c"
	}
	__finally0:
#line 116 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/widgets/Terminal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/widgets/Terminal.vala"
		g_clear_error (&_inner_error0_);
#line 116 "../src/widgets/Terminal.vala"
		return NULL;
#line 801 "Terminal.c"
	}
#line 84 "../src/widgets/Terminal.vala"
	return self;
#line 805 "Terminal.c"
}

TerminalTerminal*
terminal_terminal_new (TerminalWindow* window,
                       const gchar* command,
                       const gchar* cwd)
{
#line 84 "../src/widgets/Terminal.vala"
	return terminal_terminal_construct (TERMINAL_TYPE_TERMINAL, window, command, cwd);
#line 815 "Terminal.c"
}

static void
terminal_terminal_real_dispose (GObject* base)
{
	TerminalTerminal * self;
	GCancellable* _tmp0_ = NULL;
	GCancellable* _tmp1_;
#line 130 "../src/widgets/Terminal.vala"
	self = (TerminalTerminal*) base;
#line 134 "../src/widgets/Terminal.vala"
	_tmp1_ = self->priv->fp_spawn_host_command_callback_cancellable;
#line 134 "../src/widgets/Terminal.vala"
	_tmp0_ = _tmp1_;
#line 134 "../src/widgets/Terminal.vala"
	if (_tmp0_ != NULL) {
#line 134 "../src/widgets/Terminal.vala"
		g_cancellable_cancel (_tmp0_);
#line 834 "Terminal.c"
	}
#line 135 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (terminal_terminal_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, vte_terminal_get_type (), VteTerminal));
#line 838 "Terminal.c"
}

static gboolean
_terminal_terminal_on_drag_data_received_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                               GValue* value,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
	gboolean result;
	result = terminal_terminal_on_drag_data_received ((TerminalTerminal*) self, _sender, value, x, y);
#line 149 "../src/widgets/Terminal.vala"
	return result;
#line 852 "Terminal.c"
}

static void
terminal_terminal_setup_drag_drop (TerminalTerminal* self)
{
	GtkDropTarget* target = NULL;
	GtkDropTarget* _tmp0_;
	GType* _tmp1_;
	GType* _tmp2_;
	gint _tmp2__length1;
	GtkEventController* _tmp3_;
#line 140 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/widgets/Terminal.vala"
	_tmp0_ = gtk_drop_target_new (G_TYPE_INVALID, GDK_ACTION_COPY);
#line 141 "../src/widgets/Terminal.vala"
	target = _tmp0_;
#line 143 "../src/widgets/Terminal.vala"
	_tmp1_ = g_new0 (GType, 3);
#line 143 "../src/widgets/Terminal.vala"
	_tmp1_[0] = gdk_file_list_get_type ();
#line 143 "../src/widgets/Terminal.vala"
	_tmp1_[1] = g_file_get_type ();
#line 143 "../src/widgets/Terminal.vala"
	_tmp1_[2] = G_TYPE_STRING;
#line 143 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 143 "../src/widgets/Terminal.vala"
	_tmp2__length1 = 3;
#line 143 "../src/widgets/Terminal.vala"
	gtk_drop_target_set_gtypes (target, _tmp2_, (gsize) 3);
#line 143 "../src/widgets/Terminal.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 149 "../src/widgets/Terminal.vala"
	g_signal_connect_object (target, "drop", (GCallback) _terminal_terminal_on_drag_data_received_gtk_drop_target_drop, self, 0);
#line 151 "../src/widgets/Terminal.vala"
	_tmp3_ = _g_object_ref0 ((GtkEventController*) target);
#line 151 "../src/widgets/Terminal.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp3_);
#line 140 "../src/widgets/Terminal.vala"
	_g_object_unref0 (target);
#line 894 "Terminal.c"
}

static GdkFileList*
_vala_GdkFileList_copy (GdkFileList* self)
{
#line 163 "../src/widgets/Terminal.vala"
	return g_boxed_copy (gdk_file_list_get_type (), self);
#line 902 "Terminal.c"
}

static gpointer
__vala_GdkFileList_copy0 (gpointer self)
{
#line 163 "../src/widgets/Terminal.vala"
	return self ? _vala_GdkFileList_copy (self) : NULL;
#line 910 "Terminal.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1563 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1564 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1564 "glib-2.0.vapi"
	res_length1 = -1;
#line 1564 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1565 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1565 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1565 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1566 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1566 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1566 "glib-2.0.vapi"
	if (result_length1) {
#line 1566 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 947 "Terminal.c"
	}
#line 1566 "glib-2.0.vapi"
	result = _tmp2_;
#line 1566 "glib-2.0.vapi"
	return result;
#line 953 "Terminal.c"
}

static void
_vala_GdkFileList_free (GdkFileList* self)
{
#line 170 "../src/widgets/Terminal.vala"
	g_boxed_free (gdk_file_list_get_type (), self);
#line 961 "Terminal.c"
}

static gboolean
terminal_terminal_on_drag_data_received (TerminalTerminal* self,
                                         GtkDropTarget* target,
                                         GValue* value,
                                         gdouble x,
                                         gdouble y)
{
	GType vtype = 0UL;
	gboolean result;
#line 154 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (target != NULL, FALSE);
#line 154 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 160 "../src/widgets/Terminal.vala"
	vtype = G_VALUE_TYPE (value);
#line 162 "../src/widgets/Terminal.vala"
	if (vtype == gdk_file_list_get_type ()) {
#line 983 "Terminal.c"
		GdkFileList* list = NULL;
		void* _tmp0_;
		GdkFileList* _tmp1_;
		GdkFileList* _tmp2_;
		GSList* _tmp3_;
#line 163 "../src/widgets/Terminal.vala"
		_tmp0_ = g_value_get_boxed (value);
#line 163 "../src/widgets/Terminal.vala"
		_tmp1_ = __vala_GdkFileList_copy0 ((GdkFileList*) _tmp0_);
#line 163 "../src/widgets/Terminal.vala"
		list = _tmp1_;
#line 165 "../src/widgets/Terminal.vala"
		_tmp2_ = list;
#line 165 "../src/widgets/Terminal.vala"
		_tmp3_ = gdk_file_list_get_files (_tmp2_);
#line 999 "Terminal.c"
		{
			GSList* file_collection = NULL;
			GSList* file_it = NULL;
#line 165 "../src/widgets/Terminal.vala"
			file_collection = _tmp3_;
#line 165 "../src/widgets/Terminal.vala"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 1007 "Terminal.c"
				GFile* file = NULL;
#line 165 "../src/widgets/Terminal.vala"
				file = (GFile*) file_it->data;
#line 1011 "Terminal.c"
				{
					GFile* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
					guint8* _tmp9_;
					gint _tmp9__length1;
					gint _tmp10_ = 0;
					guint8* _tmp11_;
					gint _tmp11__length1;
					guint8* _tmp12_;
					gint _tmp12__length1;
					gint _tmp13_ = 0;
					guint8* _tmp14_;
					gint _tmp14__length1;
#line 166 "../src/widgets/Terminal.vala"
					_tmp4_ = file;
#line 166 "../src/widgets/Terminal.vala"
					_tmp5_ = g_file_get_path (_tmp4_);
#line 166 "../src/widgets/Terminal.vala"
					_tmp6_ = _tmp5_;
#line 166 "../src/widgets/Terminal.vala"
					_tmp7_ = g_shell_quote (_tmp6_);
#line 166 "../src/widgets/Terminal.vala"
					_tmp8_ = _tmp7_;
#line 166 "../src/widgets/Terminal.vala"
					_tmp9_ = string_get_data (_tmp8_, &_tmp10_);
#line 166 "../src/widgets/Terminal.vala"
					_tmp9__length1 = _tmp10_;
#line 166 "../src/widgets/Terminal.vala"
					_tmp11_ = _tmp9_;
#line 166 "../src/widgets/Terminal.vala"
					_tmp11__length1 = _tmp9__length1;
#line 166 "../src/widgets/Terminal.vala"
					vte_terminal_feed_child ((VteTerminal*) self, _tmp11_, (gssize) _tmp11__length1);
#line 166 "../src/widgets/Terminal.vala"
					_g_free0 (_tmp8_);
#line 166 "../src/widgets/Terminal.vala"
					_g_free0 (_tmp6_);
#line 167 "../src/widgets/Terminal.vala"
					_tmp12_ = string_get_data (" ", &_tmp13_);
#line 167 "../src/widgets/Terminal.vala"
					_tmp12__length1 = _tmp13_;
#line 167 "../src/widgets/Terminal.vala"
					_tmp14_ = _tmp12_;
#line 167 "../src/widgets/Terminal.vala"
					_tmp14__length1 = _tmp12__length1;
#line 167 "../src/widgets/Terminal.vala"
					vte_terminal_feed_child ((VteTerminal*) self, _tmp14_, (gssize) _tmp14__length1);
#line 1062 "Terminal.c"
				}
			}
#line 165 "../src/widgets/Terminal.vala"
			(file_collection == NULL) ? NULL : (file_collection = (g_slist_free (file_collection), NULL));
#line 1067 "Terminal.c"
		}
#line 170 "../src/widgets/Terminal.vala"
		result = TRUE;
#line 170 "../src/widgets/Terminal.vala"
		__vala_GdkFileList_free0 (list);
#line 170 "../src/widgets/Terminal.vala"
		return result;
#line 1075 "Terminal.c"
	} else {
#line 172 "../src/widgets/Terminal.vala"
		if (vtype == g_file_get_type ()) {
#line 1079 "Terminal.c"
			GFile* file = NULL;
			GObject* _tmp15_;
			GFile* _tmp16_;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_;
			gchar* _tmp19_ = NULL;
			gchar* path = NULL;
			gchar* _tmp21_;
			const gchar* _tmp22_;
#line 173 "../src/widgets/Terminal.vala"
			_tmp15_ = g_value_get_object (value);
#line 173 "../src/widgets/Terminal.vala"
			_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, g_file_get_type (), GFile));
#line 173 "../src/widgets/Terminal.vala"
			file = _tmp16_;
#line 174 "../src/widgets/Terminal.vala"
			_tmp18_ = file;
#line 174 "../src/widgets/Terminal.vala"
			_tmp17_ = _tmp18_;
#line 174 "../src/widgets/Terminal.vala"
			_tmp19_ = NULL;
#line 174 "../src/widgets/Terminal.vala"
			if (_tmp17_ != NULL) {
#line 1103 "Terminal.c"
				gchar* _tmp20_;
#line 174 "../src/widgets/Terminal.vala"
				_tmp20_ = g_file_get_path (_tmp17_);
#line 174 "../src/widgets/Terminal.vala"
				_g_free0 (_tmp19_);
#line 174 "../src/widgets/Terminal.vala"
				_tmp19_ = _tmp20_;
#line 1111 "Terminal.c"
			}
#line 174 "../src/widgets/Terminal.vala"
			_tmp21_ = _tmp19_;
#line 174 "../src/widgets/Terminal.vala"
			_tmp19_ = NULL;
#line 174 "../src/widgets/Terminal.vala"
			path = _tmp21_;
#line 176 "../src/widgets/Terminal.vala"
			_tmp22_ = path;
#line 176 "../src/widgets/Terminal.vala"
			if (_tmp22_ != NULL) {
#line 1123 "Terminal.c"
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				guint8* _tmp26_;
				gint _tmp26__length1;
				gint _tmp27_ = 0;
				guint8* _tmp28_;
				gint _tmp28__length1;
				guint8* _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_ = 0;
				guint8* _tmp31_;
				gint _tmp31__length1;
#line 177 "../src/widgets/Terminal.vala"
				_tmp23_ = path;
#line 177 "../src/widgets/Terminal.vala"
				_tmp24_ = g_shell_quote (_tmp23_);
#line 177 "../src/widgets/Terminal.vala"
				_tmp25_ = _tmp24_;
#line 177 "../src/widgets/Terminal.vala"
				_tmp26_ = string_get_data (_tmp25_, &_tmp27_);
#line 177 "../src/widgets/Terminal.vala"
				_tmp26__length1 = _tmp27_;
#line 177 "../src/widgets/Terminal.vala"
				_tmp28_ = _tmp26_;
#line 177 "../src/widgets/Terminal.vala"
				_tmp28__length1 = _tmp26__length1;
#line 177 "../src/widgets/Terminal.vala"
				vte_terminal_feed_child ((VteTerminal*) self, _tmp28_, (gssize) _tmp28__length1);
#line 177 "../src/widgets/Terminal.vala"
				_g_free0 (_tmp25_);
#line 178 "../src/widgets/Terminal.vala"
				_tmp29_ = string_get_data (" ", &_tmp30_);
#line 178 "../src/widgets/Terminal.vala"
				_tmp29__length1 = _tmp30_;
#line 178 "../src/widgets/Terminal.vala"
				_tmp31_ = _tmp29_;
#line 178 "../src/widgets/Terminal.vala"
				_tmp31__length1 = _tmp29__length1;
#line 178 "../src/widgets/Terminal.vala"
				vte_terminal_feed_child ((VteTerminal*) self, _tmp31_, (gssize) _tmp31__length1);
#line 1165 "Terminal.c"
			}
#line 181 "../src/widgets/Terminal.vala"
			result = TRUE;
#line 181 "../src/widgets/Terminal.vala"
			_g_free0 (path);
#line 181 "../src/widgets/Terminal.vala"
			_g_free0 (_tmp19_);
#line 181 "../src/widgets/Terminal.vala"
			_g_object_unref0 (file);
#line 181 "../src/widgets/Terminal.vala"
			return result;
#line 1177 "Terminal.c"
		} else {
#line 183 "../src/widgets/Terminal.vala"
			if (vtype == G_TYPE_STRING) {
#line 1181 "Terminal.c"
				gchar* text = NULL;
				const gchar* _tmp32_;
				gchar* _tmp33_;
				const gchar* _tmp34_;
#line 184 "../src/widgets/Terminal.vala"
				_tmp32_ = g_value_get_string (value);
#line 184 "../src/widgets/Terminal.vala"
				_tmp33_ = g_strdup (_tmp32_);
#line 184 "../src/widgets/Terminal.vala"
				text = _tmp33_;
#line 186 "../src/widgets/Terminal.vala"
				_tmp34_ = text;
#line 186 "../src/widgets/Terminal.vala"
				if (_tmp34_ != NULL) {
#line 1196 "Terminal.c"
					const gchar* _tmp35_;
					guint8* _tmp36_;
					gint _tmp36__length1;
					gint _tmp37_ = 0;
					guint8* _tmp38_;
					gint _tmp38__length1;
#line 187 "../src/widgets/Terminal.vala"
					_tmp35_ = text;
#line 187 "../src/widgets/Terminal.vala"
					_tmp36_ = string_get_data (_tmp35_, &_tmp37_);
#line 187 "../src/widgets/Terminal.vala"
					_tmp36__length1 = _tmp37_;
#line 187 "../src/widgets/Terminal.vala"
					_tmp38_ = _tmp36_;
#line 187 "../src/widgets/Terminal.vala"
					_tmp38__length1 = _tmp36__length1;
#line 187 "../src/widgets/Terminal.vala"
					vte_terminal_feed_child ((VteTerminal*) self, _tmp38_, (gssize) _tmp38__length1);
#line 1215 "Terminal.c"
				}
#line 190 "../src/widgets/Terminal.vala"
				result = TRUE;
#line 190 "../src/widgets/Terminal.vala"
				_g_free0 (text);
#line 190 "../src/widgets/Terminal.vala"
				return result;
#line 1223 "Terminal.c"
			}
		}
	}
#line 193 "../src/widgets/Terminal.vala"
	g_warning ("Terminal.vala:193: You dropped something Terminal can't handle yet :(");
#line 194 "../src/widgets/Terminal.vala"
	result = FALSE;
#line 194 "../src/widgets/Terminal.vala"
	return result;
#line 1233 "Terminal.c"
}

static void
terminal_terminal_setup_regexes (TerminalTerminal* self)
{
	GError* _inner_error0_ = NULL;
#line 197 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 1242 "Terminal.c"
	{
		const gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
#line 198 "../src/widgets/Terminal.vala"
		str_collection = TERMINAL_CONSTANTS_URL_REGEX_STRINGS;
#line 198 "../src/widgets/Terminal.vala"
		str_collection_length1 = G_N_ELEMENTS (TERMINAL_CONSTANTS_URL_REGEX_STRINGS);
#line 198 "../src/widgets/Terminal.vala"
		for (str_it = 0; str_it < str_collection_length1; str_it = str_it + 1) {
#line 1254 "Terminal.c"
			const gchar* str = NULL;
#line 198 "../src/widgets/Terminal.vala"
			str = str_collection[str_it];
#line 1258 "Terminal.c"
			{
				{
					VteRegex* reg = NULL;
					const gchar* _tmp0_;
					VteRegex* _tmp1_;
					gint id = 0;
					VteRegex* _tmp2_;
#line 200 "../src/widgets/Terminal.vala"
					_tmp0_ = str;
#line 200 "../src/widgets/Terminal.vala"
					_tmp1_ = vte_regex_new_for_match (_tmp0_, (gssize) -1, (guint32) PCRE2_MULTILINE, &_inner_error0_);
#line 200 "../src/widgets/Terminal.vala"
					reg = _tmp1_;
#line 200 "../src/widgets/Terminal.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1274 "Terminal.c"
						goto __catch0_g_error;
					}
#line 203 "../src/widgets/Terminal.vala"
					_tmp2_ = reg;
#line 203 "../src/widgets/Terminal.vala"
					id = vte_terminal_match_add_regex ((VteTerminal*) self, _tmp2_, (guint32) 0);
#line 204 "../src/widgets/Terminal.vala"
					vte_terminal_match_set_cursor_name ((VteTerminal*) self, id, "pointer");
#line 199 "../src/widgets/Terminal.vala"
					_vte_regex_unref0 (reg);
#line 1285 "Terminal.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp3_;
					const gchar* _tmp4_;
#line 199 "../src/widgets/Terminal.vala"
					e = _inner_error0_;
#line 199 "../src/widgets/Terminal.vala"
					_inner_error0_ = NULL;
#line 207 "../src/widgets/Terminal.vala"
					_tmp3_ = e;
#line 207 "../src/widgets/Terminal.vala"
					_tmp4_ = _tmp3_->message;
#line 207 "../src/widgets/Terminal.vala"
					g_warning ("Terminal.vala:207: %s", _tmp4_);
#line 199 "../src/widgets/Terminal.vala"
					_g_error_free0 (e);
#line 1305 "Terminal.c"
				}
				__finally0:
#line 199 "../src/widgets/Terminal.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/widgets/Terminal.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../src/widgets/Terminal.vala"
					g_clear_error (&_inner_error0_);
#line 199 "../src/widgets/Terminal.vala"
					return;
#line 1316 "Terminal.c"
				}
			}
		}
	}
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 213 "../src/widgets/Terminal.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 1328 "Terminal.c"
}

static void
terminal_terminal_on_font_changed (TerminalTerminal* self)
{
	TerminalSettings* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PangoFontDescription* _tmp3_;
	PangoFontDescription* _tmp4_;
#line 212 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->settings;
#line 213 "../src/widgets/Terminal.vala"
	_tmp1_ = terminal_settings_get_font (_tmp0_);
#line 213 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 213 "../src/widgets/Terminal.vala"
	_tmp3_ = pango_font_description_from_string (_tmp2_);
#line 213 "../src/widgets/Terminal.vala"
	_tmp4_ = _tmp3_;
#line 213 "../src/widgets/Terminal.vala"
	g_object_set ((VteTerminal*) self, "font-desc", _tmp4_, NULL);
#line 213 "../src/widgets/Terminal.vala"
	__vala_PangoFontDescription_free0 (_tmp4_);
#line 1355 "Terminal.c"
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
#line 221 "../src/widgets/Terminal.vala"
	g_boxed_free (gdk_rgba_get_type (), self);
#line 1363 "Terminal.c"
}

static void
terminal_terminal_get_background_color (TerminalTerminal* self,
                                        TerminalScheme* theme,
                                        GdkRGBA* result)
{
	GdkRGBA* bg_transparent = NULL;
	GdkRGBA* _tmp0_;
	GdkRGBA* _tmp1_;
	GdkRGBA* _tmp2_;
	TerminalSettings* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	GdkRGBA* _tmp6_;
	GdkRGBA _tmp7_;
#line 218 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/widgets/Terminal.vala"
	g_return_if_fail (theme != NULL);
#line 219 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_scheme_get_background_color (theme);
#line 219 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 219 "../src/widgets/Terminal.vala"
	_tmp2_ = gdk_rgba_copy (_tmp1_);
#line 219 "../src/widgets/Terminal.vala"
	bg_transparent = _tmp2_;
#line 220 "../src/widgets/Terminal.vala"
	_tmp3_ = self->priv->settings;
#line 220 "../src/widgets/Terminal.vala"
	_tmp4_ = terminal_settings_get_opacity (_tmp3_);
#line 220 "../src/widgets/Terminal.vala"
	_tmp5_ = _tmp4_;
#line 220 "../src/widgets/Terminal.vala"
	(*bg_transparent).alpha = _tmp5_ * 0.01f;
#line 221 "../src/widgets/Terminal.vala"
	_tmp6_ = bg_transparent;
#line 221 "../src/widgets/Terminal.vala"
	_tmp7_ = *_tmp6_;
#line 221 "../src/widgets/Terminal.vala"
	__vala_GdkRGBA_free0 (_tmp6_);
#line 221 "../src/widgets/Terminal.vala"
	*result = _tmp7_;
#line 221 "../src/widgets/Terminal.vala"
	return;
#line 1410 "Terminal.c"
}

static void
terminal_terminal_on_theme_changed (TerminalTerminal* self)
{
	TerminalThemeProvider* theme_provider = NULL;
	TerminalThemeProvider* _tmp0_;
	gchar* theme_name = NULL;
	TerminalThemeProvider* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	TerminalScheme* theme = NULL;
	TerminalThemeProvider* _tmp5_;
	GHashTable* _tmp6_;
	const gchar* _tmp7_;
	gconstpointer _tmp8_;
	TerminalScheme* _tmp9_;
	TerminalScheme* _tmp10_;
	GdkRGBA bg = {0};
	TerminalScheme* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	TerminalScheme* _tmp14_;
	GdkRGBA* _tmp15_;
	GdkRGBA* _tmp16_;
	GdkRGBA _tmp17_;
	TerminalScheme* _tmp18_;
	GArray* _tmp19_;
	GArray* _tmp20_;
	gpointer* _tmp21_;
	gint _tmp21__length1;
#line 224 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_theme_provider_get_default ();
#line 225 "../src/widgets/Terminal.vala"
	theme_provider = _tmp0_;
#line 226 "../src/widgets/Terminal.vala"
	_tmp1_ = theme_provider;
#line 226 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_theme_provider_get_current_theme (_tmp1_);
#line 226 "../src/widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 226 "../src/widgets/Terminal.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 226 "../src/widgets/Terminal.vala"
	theme_name = _tmp4_;
#line 227 "../src/widgets/Terminal.vala"
	_tmp5_ = theme_provider;
#line 227 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp5_->themes;
#line 227 "../src/widgets/Terminal.vala"
	_tmp7_ = theme_name;
#line 227 "../src/widgets/Terminal.vala"
	_tmp8_ = g_hash_table_lookup (_tmp6_, _tmp7_);
#line 227 "../src/widgets/Terminal.vala"
	_tmp9_ = _g_object_ref0 ((TerminalScheme*) _tmp8_);
#line 227 "../src/widgets/Terminal.vala"
	theme = _tmp9_;
#line 229 "../src/widgets/Terminal.vala"
	_tmp10_ = theme;
#line 229 "../src/widgets/Terminal.vala"
	if (_tmp10_ == NULL) {
#line 1474 "Terminal.c"
		const gchar* _tmp11_;
#line 230 "../src/widgets/Terminal.vala"
		_tmp11_ = theme_name;
#line 230 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:230: INVALID THEME '%s'", _tmp11_);
#line 231 "../src/widgets/Terminal.vala"
		_g_object_unref0 (theme);
#line 231 "../src/widgets/Terminal.vala"
		_g_free0 (theme_name);
#line 231 "../src/widgets/Terminal.vala"
		_g_object_unref0 (theme_provider);
#line 231 "../src/widgets/Terminal.vala"
		return;
#line 1488 "Terminal.c"
	}
#line 234 "../src/widgets/Terminal.vala"
	_tmp12_ = theme;
#line 234 "../src/widgets/Terminal.vala"
	terminal_terminal_get_background_color (self, _tmp12_, &_tmp13_);
#line 234 "../src/widgets/Terminal.vala"
	bg = _tmp13_;
#line 235 "../src/widgets/Terminal.vala"
	_tmp14_ = theme;
#line 235 "../src/widgets/Terminal.vala"
	_tmp15_ = terminal_scheme_get_foreground_color (_tmp14_);
#line 235 "../src/widgets/Terminal.vala"
	_tmp16_ = _tmp15_;
#line 235 "../src/widgets/Terminal.vala"
	_tmp17_ = bg;
#line 235 "../src/widgets/Terminal.vala"
	_tmp18_ = theme;
#line 235 "../src/widgets/Terminal.vala"
	_tmp19_ = terminal_scheme_get_palette (_tmp18_);
#line 235 "../src/widgets/Terminal.vala"
	_tmp20_ = _tmp19_;
#line 235 "../src/widgets/Terminal.vala"
	_tmp21_ = _tmp20_->data;
#line 235 "../src/widgets/Terminal.vala"
	_tmp21__length1 = _tmp20_->len;
#line 235 "../src/widgets/Terminal.vala"
	vte_terminal_set_colors ((VteTerminal*) self, _tmp16_, &_tmp17_, _tmp21_, (gsize) _tmp21__length1);
#line 224 "../src/widgets/Terminal.vala"
	_g_object_unref0 (theme);
#line 224 "../src/widgets/Terminal.vala"
	_g_free0 (theme_name);
#line 224 "../src/widgets/Terminal.vala"
	_g_object_unref0 (theme_provider);
#line 1522 "Terminal.c"
}

static void
terminal_terminal_on_padding_changed (TerminalTerminal* self)
{
	TerminalPadding pad = {0};
	TerminalSettings* _tmp0_;
	TerminalPadding _tmp1_ = {0};
	GtkCssProvider* _tmp2_;
	TerminalPadding _tmp5_;
	TerminalPadding _tmp6_;
	TerminalPadding _tmp7_;
	TerminalPadding _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkCssProvider* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkCssProvider* _tmp13_;
#line 243 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 244 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->settings;
#line 244 "../src/widgets/Terminal.vala"
	terminal_settings_get_padding (_tmp0_, &_tmp1_);
#line 244 "../src/widgets/Terminal.vala"
	pad = _tmp1_;
#line 246 "../src/widgets/Terminal.vala"
	_tmp2_ = self->priv->padding_provider;
#line 246 "../src/widgets/Terminal.vala"
	if (_tmp2_ != NULL) {
#line 1553 "Terminal.c"
		GtkStyleContext* _tmp3_;
		GtkCssProvider* _tmp4_;
#line 247 "../src/widgets/Terminal.vala"
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 247 "../src/widgets/Terminal.vala"
		_tmp4_ = self->priv->padding_provider;
#line 247 "../src/widgets/Terminal.vala"
		gtk_style_context_remove_provider (_tmp3_, (GtkStyleProvider*) _tmp4_);
#line 248 "../src/widgets/Terminal.vala"
		_g_object_unref0 (self->priv->padding_provider);
#line 248 "../src/widgets/Terminal.vala"
		self->priv->padding_provider = NULL;
#line 1566 "Terminal.c"
	}
#line 251 "../src/widgets/Terminal.vala"
	_tmp5_ = pad;
#line 251 "../src/widgets/Terminal.vala"
	_tmp6_ = pad;
#line 251 "../src/widgets/Terminal.vala"
	_tmp7_ = pad;
#line 251 "../src/widgets/Terminal.vala"
	_tmp8_ = pad;
#line 251 "../src/widgets/Terminal.vala"
	_tmp9_ = g_strdup_printf ("vte-terminal { padding: %upx %upx %upx %upx; }", _tmp5_.top, _tmp6_.right, _tmp7_.bottom, _tmp8_.left);
#line 251 "../src/widgets/Terminal.vala"
	_tmp10_ = _tmp9_;
#line 251 "../src/widgets/Terminal.vala"
	_tmp11_ = pq_marble_get_css_provider_for_data (_tmp10_);
#line 251 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->padding_provider);
#line 251 "../src/widgets/Terminal.vala"
	self->priv->padding_provider = _tmp11_;
#line 251 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp10_);
#line 260 "../src/widgets/Terminal.vala"
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 260 "../src/widgets/Terminal.vala"
	_tmp13_ = self->priv->padding_provider;
#line 260 "../src/widgets/Terminal.vala"
	gtk_style_context_add_provider (_tmp12_, (GtkStyleProvider*) _tmp13_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 1594 "Terminal.c"
}

static void
terminal_terminal_bind_data (TerminalTerminal* self)
{
	TerminalSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	TerminalSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	TerminalSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	TerminalSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	TerminalSettings* _tmp12_;
	TerminalSettings* _tmp13_;
	TerminalSettings* _tmp14_;
#line 266 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->settings;
#line 267 "../src/widgets/Terminal.vala"
	_tmp1_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp0_);
#line 267 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 267 "../src/widgets/Terminal.vala"
	g_settings_bind (_tmp2_, "theme-bold-is-bright", (GObject*) self, "bold-is-bright", G_SETTINGS_BIND_DEFAULT);
#line 274 "../src/widgets/Terminal.vala"
	_tmp3_ = self->priv->settings;
#line 274 "../src/widgets/Terminal.vala"
	_tmp4_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp3_);
#line 274 "../src/widgets/Terminal.vala"
	_tmp5_ = _tmp4_;
#line 274 "../src/widgets/Terminal.vala"
	g_settings_bind (_tmp5_, "terminal-bell", (GObject*) self, "audible-bell", G_SETTINGS_BIND_DEFAULT);
#line 281 "../src/widgets/Terminal.vala"
	_tmp6_ = self->priv->settings;
#line 281 "../src/widgets/Terminal.vala"
	_tmp7_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp6_);
#line 281 "../src/widgets/Terminal.vala"
	_tmp8_ = _tmp7_;
#line 281 "../src/widgets/Terminal.vala"
	g_settings_bind (_tmp8_, "terminal-cell-width", (GObject*) self, "cell-width-scale", G_SETTINGS_BIND_DEFAULT);
#line 288 "../src/widgets/Terminal.vala"
	_tmp9_ = self->priv->settings;
#line 288 "../src/widgets/Terminal.vala"
	_tmp10_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp9_);
#line 288 "../src/widgets/Terminal.vala"
	_tmp11_ = _tmp10_;
#line 288 "../src/widgets/Terminal.vala"
	g_settings_bind (_tmp11_, "terminal-cell-height", (GObject*) self, "cell-height-scale", G_SETTINGS_BIND_DEFAULT);
#line 295 "../src/widgets/Terminal.vala"
	_tmp12_ = self->priv->settings;
#line 295 "../src/widgets/Terminal.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp12_, "cursor-shape", (GObject*) self, "cursor-shape", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 304 "../src/widgets/Terminal.vala"
	_tmp13_ = self->priv->settings;
#line 304 "../src/widgets/Terminal.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp13_, "cursor-blink-mode", (GObject*) self, "cursor-blink-mode", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 313 "../src/widgets/Terminal.vala"
	g_object_bind_property_with_closures ((GObject*) self, "user-scrollback-lines", (GObject*) self, "scrollback-lines", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 330 "../src/widgets/Terminal.vala"
	_tmp14_ = self->priv->settings;
#line 330 "../src/widgets/Terminal.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp14_, "show-scrollbars", (GObject*) self, "enable-fallback-scrolling", G_BINDING_SYNC_CREATE | G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 1663 "Terminal.c"
}

static gboolean
_terminal_terminal_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                        guint keyval,
                                                                        guint keycode,
                                                                        GdkModifierType state,
                                                                        gpointer self)
{
	gboolean result;
	result = terminal_terminal_on_key_pressed ((TerminalTerminal*) self, keyval, keycode, state);
#line 342 "../src/widgets/Terminal.vala"
	return result;
#line 1677 "Terminal.c"
}

static gpointer
_gdk_event_ref0 (gpointer self)
{
#line 349 "../src/widgets/Terminal.vala"
	return self ? gdk_event_ref (self) : NULL;
#line 1685 "Terminal.c"
}

static void
__lambda11_ (TerminalTerminal* self,
             GtkGestureClick* gesture,
             gint n_clicked,
             gdouble x,
             gdouble y)
{
	GdkEvent* event = NULL;
	GdkEvent* _tmp0_;
	GdkEvent* _tmp1_;
	gchar* pattern = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GdkEvent* _tmp4_;
	const gchar* _tmp6_;
	GtkUriLauncher* _tmp7_;
	GtkUriLauncher* _tmp8_;
	TerminalWindow* _tmp9_;
#line 348 "../src/widgets/Terminal.vala"
	g_return_if_fail (gesture != NULL);
#line 349 "../src/widgets/Terminal.vala"
	_tmp0_ = gtk_event_controller_get_current_event ((GtkEventController*) gesture);
#line 349 "../src/widgets/Terminal.vala"
	_tmp1_ = _gdk_event_ref0 (_tmp0_);
#line 349 "../src/widgets/Terminal.vala"
	event = _tmp1_;
#line 350 "../src/widgets/Terminal.vala"
	_tmp2_ = vte_terminal_check_match_at ((VteTerminal*) self, x, y, NULL);
#line 350 "../src/widgets/Terminal.vala"
	pattern = _tmp2_;
#line 353 "../src/widgets/Terminal.vala"
	_tmp4_ = event;
#line 353 "../src/widgets/Terminal.vala"
	if ((gdk_event_get_modifier_state (_tmp4_) & GDK_CONTROL_MASK) == 0) {
#line 353 "../src/widgets/Terminal.vala"
		_tmp3_ = TRUE;
#line 1724 "Terminal.c"
	} else {
		const gchar* _tmp5_;
#line 354 "../src/widgets/Terminal.vala"
		_tmp5_ = pattern;
#line 354 "../src/widgets/Terminal.vala"
		_tmp3_ = _tmp5_ == NULL;
#line 1731 "Terminal.c"
	}
#line 352 "../src/widgets/Terminal.vala"
	if (_tmp3_) {
#line 356 "../src/widgets/Terminal.vala"
		_g_free0 (pattern);
#line 356 "../src/widgets/Terminal.vala"
		_gdk_event_unref0 (event);
#line 356 "../src/widgets/Terminal.vala"
		return;
#line 1741 "Terminal.c"
	}
#line 360 "../src/widgets/Terminal.vala"
	_tmp6_ = pattern;
#line 360 "../src/widgets/Terminal.vala"
	_tmp7_ = gtk_uri_launcher_new (_tmp6_);
#line 360 "../src/widgets/Terminal.vala"
	_tmp8_ = _tmp7_;
#line 360 "../src/widgets/Terminal.vala"
	_tmp9_ = self->window;
#line 360 "../src/widgets/Terminal.vala"
	gtk_uri_launcher_launch (_tmp8_, (GtkWindow*) _tmp9_, NULL, NULL, NULL);
#line 360 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_tmp8_);
#line 348 "../src/widgets/Terminal.vala"
	_g_free0 (pattern);
#line 348 "../src/widgets/Terminal.vala"
	_gdk_event_unref0 (event);
#line 1759 "Terminal.c"
}

static void
___lambda11__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
#line 348 "../src/widgets/Terminal.vala"
	__lambda11_ ((TerminalTerminal*) self, _sender, n_press, x, y);
#line 1771 "Terminal.c"
}

static void
__lambda12_ (TerminalTerminal* self)
{
#line 366 "../src/widgets/Terminal.vala"
	g_object_notify ((GObject*) self, "user-scrollback-lines");
#line 1779 "Terminal.c"
}

static void
___lambda12__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 364 "../src/widgets/Terminal.vala"
	__lambda12_ ((TerminalTerminal*) self);
#line 1789 "Terminal.c"
}

static void
__lambda13_ (TerminalTerminal* self)
{
#line 371 "../src/widgets/Terminal.vala"
	g_object_notify ((GObject*) self, "user-scrollback-lines");
#line 1797 "Terminal.c"
}

static void
___lambda13__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 369 "../src/widgets/Terminal.vala"
	__lambda13_ ((TerminalTerminal*) self);
#line 1807 "Terminal.c"
}

static void
terminal_terminal_connect_signals (TerminalTerminal* self)
{
	GtkEventControllerKey* kpcontroller = NULL;
	GtkEventControllerKey* _tmp0_;
	GtkEventController* _tmp1_;
	GtkGestureClick* left_click_controller = NULL;
	GtkGestureClick* _tmp2_ = NULL;
	GtkEventController* _tmp3_;
	TerminalSettings* _tmp4_;
	TerminalSettings* _tmp5_;
#line 340 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 341 "../src/widgets/Terminal.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 341 "../src/widgets/Terminal.vala"
	kpcontroller = _tmp0_;
#line 342 "../src/widgets/Terminal.vala"
	g_signal_connect_object (kpcontroller, "key-pressed", (GCallback) _terminal_terminal_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 343 "../src/widgets/Terminal.vala"
	_tmp1_ = _g_object_ref0 ((GtkEventController*) kpcontroller);
#line 343 "../src/widgets/Terminal.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp1_);
#line 345 "../src/widgets/Terminal.vala"
	_tmp2_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 345 "../src/widgets/Terminal.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp2_, (guint) GDK_BUTTON_PRIMARY);
#line 345 "../src/widgets/Terminal.vala"
	left_click_controller = _tmp2_;
#line 348 "../src/widgets/Terminal.vala"
	g_signal_connect_object (left_click_controller, "pressed", (GCallback) ___lambda11__gtk_gesture_click_pressed, self, 0);
#line 362 "../src/widgets/Terminal.vala"
	_tmp3_ = _g_object_ref0 ((GtkEventController*) left_click_controller);
#line 362 "../src/widgets/Terminal.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp3_);
#line 364 "../src/widgets/Terminal.vala"
	_tmp4_ = self->priv->settings;
#line 364 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::scrollback-lines", (GCallback) ___lambda12__g_object_notify, self, 0);
#line 369 "../src/widgets/Terminal.vala"
	_tmp5_ = self->priv->settings;
#line 369 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::scrollback-mode", (GCallback) ___lambda13__g_object_notify, self, 0);
#line 340 "../src/widgets/Terminal.vala"
	_g_object_unref0 (left_click_controller);
#line 340 "../src/widgets/Terminal.vala"
	_g_object_unref0 (kpcontroller);
#line 1857 "Terminal.c"
}

static void
_g_free0_ (gpointer var)
{
#line 376 "../src/widgets/Terminal.vala"
	var = (g_free (var), NULL);
#line 1865 "Terminal.c"
}

static void
_vala_gchar_free_function_content_of (gpointer data)
{
	gchar* self;
#line 376 "../src/widgets/Terminal.vala"
	self = *((gchar**) data);
#line 376 "../src/widgets/Terminal.vala"
	_g_free0_ (self);
#line 1876 "Terminal.c"
}

static void
__lambda15_ (TerminalTerminal* self,
             GObject* o,
             GAsyncResult* _)
{
	GError* _inner_error0_ = NULL;
#line 438 "../src/widgets/Terminal.vala"
	g_return_if_fail (_ != NULL);
#line 1887 "Terminal.c"
	{
		GPid ppid = 0;
		gboolean res = FALSE;
		GPid _tmp0_ = 0;
		gboolean _tmp1_;
#line 441 "../src/widgets/Terminal.vala"
		_tmp1_ = terminal_terminal_spawn_on_flatpak_finish (self, _, &_tmp0_, &_inner_error0_);
#line 441 "../src/widgets/Terminal.vala"
		ppid = _tmp0_;
#line 441 "../src/widgets/Terminal.vala"
		res = _tmp1_;
#line 441 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1901 "Terminal.c"
			goto __catch0_g_error;
		}
#line 442 "../src/widgets/Terminal.vala"
		terminal_terminal_set_pid (self, ppid);
#line 444 "../src/widgets/Terminal.vala"
		if (!res) {
#line 446 "../src/widgets/Terminal.vala"
			g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL], 0, "An unexpected error occurred while spawning a new terminal.");
#line 1910 "Terminal.c"
		} else {
#line 449 "../src/widgets/Terminal.vala"
			terminal_terminal_on_spawn_finished (self);
#line 1914 "Terminal.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 439 "../src/widgets/Terminal.vala"
		e = _inner_error0_;
#line 439 "../src/widgets/Terminal.vala"
		_inner_error0_ = NULL;
#line 453 "../src/widgets/Terminal.vala"
		terminal_terminal_set_pid (self, (GPid) -1);
#line 454 "../src/widgets/Terminal.vala"
		_tmp2_ = e;
#line 454 "../src/widgets/Terminal.vala"
		_tmp3_ = _tmp2_->message;
#line 454 "../src/widgets/Terminal.vala"
		g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL], 0, _tmp3_);
#line 439 "../src/widgets/Terminal.vala"
		_g_error_free0 (e);
#line 1937 "Terminal.c"
	}
	__finally0:
#line 439 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 439 "../src/widgets/Terminal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 439 "../src/widgets/Terminal.vala"
		g_clear_error (&_inner_error0_);
#line 439 "../src/widgets/Terminal.vala"
		return;
#line 1948 "Terminal.c"
	}
}

static void
___lambda15__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 438 "../src/widgets/Terminal.vala"
	__lambda15_ ((TerminalTerminal*) self, source_object, res);
#line 438 "../src/widgets/Terminal.vala"
	g_object_unref (self);
#line 1961 "Terminal.c"
}

static void
terminal_terminal_spawn (TerminalTerminal* self,
                         const gchar* command,
                         const gchar* cwd,
                         GError** error)
{
	GArray* argv = NULL;
	GArray* _tmp0_;
	GArray* envv = NULL;
	GArray* _tmp1_;
	VtePtyFlags flags = 0U;
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp2_;
	gchar** custom_shell_commandv = NULL;
	gint custom_shell_commandv_length1;
	gint _custom_shell_commandv_size_;
	gchar* shell = NULL;
	gboolean _tmp3_ = FALSE;
	TerminalSettings* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_;
	gchar* _tmp20_;
	gchar** _tmp21_ = NULL;
	gint _tmp22_ = 0;
	gchar** _tmp23_;
	gint _tmp21__length1;
	gint __tmp21__size_;
	gchar** _tmp24_ = NULL;
	gchar** _tmp25_;
	gint _tmp25__length1;
	gint _tmp24__length1;
	gint __tmp24__size_;
	gchar** tmp_envv = NULL;
	gchar** _tmp28_;
	gint _tmp28__length1;
	gint tmp_envv_length1;
	gint _tmp_envv_size_;
	gchar** _tmp29_;
	gint _tmp29__length1;
	gchar** _tmp34_;
	gint _tmp34__length1;
	gchar** _tmp39_;
	gint _tmp39__length1;
	GArray* _tmp57_;
	GArray* _tmp58_;
	GError* _inner_error0_ = NULL;
#line 375 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 376 "../src/widgets/Terminal.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
#line 376 "../src/widgets/Terminal.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_gchar_free_function_content_of);
#line 376 "../src/widgets/Terminal.vala"
	argv = _tmp0_;
#line 377 "../src/widgets/Terminal.vala"
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
#line 377 "../src/widgets/Terminal.vala"
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_gchar_free_function_content_of);
#line 377 "../src/widgets/Terminal.vala"
	envv = _tmp1_;
#line 378 "../src/widgets/Terminal.vala"
	flags = VTE_PTY_DEFAULT;
#line 380 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_settings_get_default ();
#line 380 "../src/widgets/Terminal.vala"
	settings = _tmp2_;
#line 381 "../src/widgets/Terminal.vala"
	custom_shell_commandv = NULL;
#line 381 "../src/widgets/Terminal.vala"
	custom_shell_commandv_length1 = 0;
#line 381 "../src/widgets/Terminal.vala"
	_custom_shell_commandv_size_ = custom_shell_commandv_length1;
#line 386 "../src/widgets/Terminal.vala"
	_tmp4_ = settings;
#line 386 "../src/widgets/Terminal.vala"
	_tmp5_ = terminal_settings_get_use_custom_command (_tmp4_);
#line 386 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp5_;
#line 386 "../src/widgets/Terminal.vala"
	if (_tmp6_) {
#line 2048 "Terminal.c"
		TerminalSettings* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 387 "../src/widgets/Terminal.vala"
		_tmp7_ = settings;
#line 387 "../src/widgets/Terminal.vala"
		_tmp8_ = terminal_settings_get_custom_shell_command (_tmp7_);
#line 387 "../src/widgets/Terminal.vala"
		_tmp9_ = _tmp8_;
#line 387 "../src/widgets/Terminal.vala"
		_tmp3_ = g_strcmp0 (_tmp9_, "") != 0;
#line 2060 "Terminal.c"
	} else {
#line 386 "../src/widgets/Terminal.vala"
		_tmp3_ = FALSE;
#line 2064 "Terminal.c"
	}
#line 385 "../src/widgets/Terminal.vala"
	if (_tmp3_) {
#line 2068 "Terminal.c"
		TerminalSettings* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar** _tmp13_ = NULL;
		gint _tmp14_ = 0;
#line 389 "../src/widgets/Terminal.vala"
		_tmp10_ = settings;
#line 389 "../src/widgets/Terminal.vala"
		_tmp11_ = terminal_settings_get_custom_shell_command (_tmp10_);
#line 389 "../src/widgets/Terminal.vala"
		_tmp12_ = _tmp11_;
#line 389 "../src/widgets/Terminal.vala"
		g_shell_parse_argv (_tmp12_, &_tmp14_, &_tmp13_, &_inner_error0_);
#line 389 "../src/widgets/Terminal.vala"
		custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
#line 389 "../src/widgets/Terminal.vala"
		custom_shell_commandv = _tmp13_;
#line 389 "../src/widgets/Terminal.vala"
		custom_shell_commandv_length1 = _tmp14_;
#line 389 "../src/widgets/Terminal.vala"
		_custom_shell_commandv_size_ = custom_shell_commandv_length1;
#line 389 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "../src/widgets/Terminal.vala"
			g_propagate_error (error, _inner_error0_);
#line 389 "../src/widgets/Terminal.vala"
			_g_free0 (shell);
#line 389 "../src/widgets/Terminal.vala"
			custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
#line 389 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 389 "../src/widgets/Terminal.vala"
			_g_array_unref0 (envv);
#line 389 "../src/widgets/Terminal.vala"
			_g_array_unref0 (argv);
#line 389 "../src/widgets/Terminal.vala"
			return;
#line 2106 "Terminal.c"
		}
	}
#line 394 "../src/widgets/Terminal.vala"
	_tmp16_ = terminal_fp_guess_shell (NULL, &_inner_error0_);
#line 394 "../src/widgets/Terminal.vala"
	_tmp15_ = _tmp16_;
#line 394 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 394 "../src/widgets/Terminal.vala"
		g_propagate_error (error, _inner_error0_);
#line 394 "../src/widgets/Terminal.vala"
		_g_free0 (shell);
#line 394 "../src/widgets/Terminal.vala"
		custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
#line 394 "../src/widgets/Terminal.vala"
		_g_object_unref0 (settings);
#line 394 "../src/widgets/Terminal.vala"
		_g_array_unref0 (envv);
#line 394 "../src/widgets/Terminal.vala"
		_g_array_unref0 (argv);
#line 394 "../src/widgets/Terminal.vala"
		return;
#line 2129 "Terminal.c"
	}
#line 394 "../src/widgets/Terminal.vala"
	_tmp18_ = _tmp15_;
#line 394 "../src/widgets/Terminal.vala"
	_tmp15_ = NULL;
#line 394 "../src/widgets/Terminal.vala"
	_tmp17_ = _tmp18_;
#line 394 "../src/widgets/Terminal.vala"
	if (_tmp17_ == NULL) {
#line 2139 "Terminal.c"
		gchar* _tmp19_;
#line 394 "../src/widgets/Terminal.vala"
		_tmp19_ = g_strdup ("/usr/bin/bash");
#line 394 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp17_);
#line 394 "../src/widgets/Terminal.vala"
		_tmp17_ = _tmp19_;
#line 2147 "Terminal.c"
	}
#line 394 "../src/widgets/Terminal.vala"
	_tmp20_ = _tmp17_;
#line 394 "../src/widgets/Terminal.vala"
	_tmp17_ = NULL;
#line 394 "../src/widgets/Terminal.vala"
	_g_free0 (shell);
#line 394 "../src/widgets/Terminal.vala"
	shell = _tmp20_;
#line 396 "../src/widgets/Terminal.vala"
	flags = VTE_PTY_NO_CTTY;
#line 398 "../src/widgets/Terminal.vala"
	_tmp23_ = terminal_fp_get_env (NULL, &_tmp22_, &_inner_error0_);
#line 398 "../src/widgets/Terminal.vala"
	_tmp21_ = _tmp23_;
#line 398 "../src/widgets/Terminal.vala"
	_tmp21__length1 = _tmp22_;
#line 398 "../src/widgets/Terminal.vala"
	__tmp21__size_ = _tmp21__length1;
#line 398 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 398 "../src/widgets/Terminal.vala"
		g_propagate_error (error, _inner_error0_);
#line 398 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp17_);
#line 398 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp15_);
#line 398 "../src/widgets/Terminal.vala"
		_g_free0 (shell);
#line 398 "../src/widgets/Terminal.vala"
		custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
#line 398 "../src/widgets/Terminal.vala"
		_g_object_unref0 (settings);
#line 398 "../src/widgets/Terminal.vala"
		_g_array_unref0 (envv);
#line 398 "../src/widgets/Terminal.vala"
		_g_array_unref0 (argv);
#line 398 "../src/widgets/Terminal.vala"
		return;
#line 2187 "Terminal.c"
	}
#line 398 "../src/widgets/Terminal.vala"
	_tmp25_ = _tmp21_;
#line 398 "../src/widgets/Terminal.vala"
	_tmp25__length1 = _tmp21__length1;
#line 398 "../src/widgets/Terminal.vala"
	_tmp21_ = NULL;
#line 398 "../src/widgets/Terminal.vala"
	_tmp21__length1 = 0;
#line 398 "../src/widgets/Terminal.vala"
	_tmp24_ = _tmp25_;
#line 398 "../src/widgets/Terminal.vala"
	_tmp24__length1 = _tmp25__length1;
#line 398 "../src/widgets/Terminal.vala"
	__tmp24__size_ = _tmp24__length1;
#line 398 "../src/widgets/Terminal.vala"
	if (_tmp24_ == NULL) {
#line 2205 "Terminal.c"
		gchar** _tmp26_;
		gchar** _tmp27_;
#line 398 "../src/widgets/Terminal.vala"
		_tmp27_ = _tmp26_ = g_get_environ ();
#line 398 "../src/widgets/Terminal.vala"
		_tmp24_ = (_vala_array_free (_tmp24_, _tmp24__length1, (GDestroyNotify) g_free), NULL);
#line 398 "../src/widgets/Terminal.vala"
		_tmp24_ = _tmp27_;
#line 398 "../src/widgets/Terminal.vala"
		_tmp24__length1 = _vala_array_length (_tmp26_);
#line 398 "../src/widgets/Terminal.vala"
		__tmp24__size_ = _tmp24__length1;
#line 2218 "Terminal.c"
	}
#line 398 "../src/widgets/Terminal.vala"
	_tmp28_ = _tmp24_;
#line 398 "../src/widgets/Terminal.vala"
	_tmp28__length1 = _tmp24__length1;
#line 398 "../src/widgets/Terminal.vala"
	_tmp24_ = NULL;
#line 398 "../src/widgets/Terminal.vala"
	_tmp24__length1 = 0;
#line 398 "../src/widgets/Terminal.vala"
	tmp_envv = _tmp28_;
#line 398 "../src/widgets/Terminal.vala"
	tmp_envv_length1 = _tmp28__length1;
#line 398 "../src/widgets/Terminal.vala"
	_tmp_envv_size_ = tmp_envv_length1;
#line 400 "../src/widgets/Terminal.vala"
	_tmp29_ = tmp_envv;
#line 400 "../src/widgets/Terminal.vala"
	_tmp29__length1 = tmp_envv_length1;
#line 2238 "Terminal.c"
	{
		gchar** env_collection = NULL;
		gint env_collection_length1 = 0;
		gint _env_collection_size_ = 0;
		gint env_it = 0;
#line 400 "../src/widgets/Terminal.vala"
		env_collection = _tmp29_;
#line 400 "../src/widgets/Terminal.vala"
		env_collection_length1 = _tmp29__length1;
#line 400 "../src/widgets/Terminal.vala"
		for (env_it = 0; env_it < env_collection_length1; env_it = env_it + 1) {
#line 2250 "Terminal.c"
			gchar* _tmp30_;
			gchar* env = NULL;
#line 400 "../src/widgets/Terminal.vala"
			_tmp30_ = g_strdup (env_collection[env_it]);
#line 400 "../src/widgets/Terminal.vala"
			env = _tmp30_;
#line 2257 "Terminal.c"
			{
				GArray* _tmp31_;
				const gchar* _tmp32_;
				gchar* _tmp33_;
#line 401 "../src/widgets/Terminal.vala"
				_tmp31_ = envv;
#line 401 "../src/widgets/Terminal.vala"
				_tmp32_ = env;
#line 401 "../src/widgets/Terminal.vala"
				_tmp33_ = g_strdup (_tmp32_);
#line 401 "../src/widgets/Terminal.vala"
				g_array_append_val (_tmp31_, _tmp33_);
#line 400 "../src/widgets/Terminal.vala"
				_g_free0 (env);
#line 2272 "Terminal.c"
			}
		}
	}
#line 404 "../src/widgets/Terminal.vala"
	_tmp34_ = terminal_terminal_blackbox_envv;
#line 404 "../src/widgets/Terminal.vala"
	_tmp34__length1 = terminal_terminal_blackbox_envv_length1;
#line 2280 "Terminal.c"
	{
		gchar** env_collection = NULL;
		gint env_collection_length1 = 0;
		gint _env_collection_size_ = 0;
		gint env_it = 0;
#line 404 "../src/widgets/Terminal.vala"
		env_collection = _tmp34_;
#line 404 "../src/widgets/Terminal.vala"
		env_collection_length1 = _tmp34__length1;
#line 404 "../src/widgets/Terminal.vala"
		for (env_it = 0; env_it < env_collection_length1; env_it = env_it + 1) {
#line 2292 "Terminal.c"
			gchar* _tmp35_;
			gchar* env = NULL;
#line 404 "../src/widgets/Terminal.vala"
			_tmp35_ = g_strdup (env_collection[env_it]);
#line 404 "../src/widgets/Terminal.vala"
			env = _tmp35_;
#line 2299 "Terminal.c"
			{
				GArray* _tmp36_;
				const gchar* _tmp37_;
				gchar* _tmp38_;
#line 405 "../src/widgets/Terminal.vala"
				_tmp36_ = envv;
#line 405 "../src/widgets/Terminal.vala"
				_tmp37_ = env;
#line 405 "../src/widgets/Terminal.vala"
				_tmp38_ = g_strdup (_tmp37_);
#line 405 "../src/widgets/Terminal.vala"
				g_array_append_val (_tmp36_, _tmp38_);
#line 404 "../src/widgets/Terminal.vala"
				_g_free0 (env);
#line 2314 "Terminal.c"
			}
		}
	}
#line 421 "../src/widgets/Terminal.vala"
	_tmp39_ = custom_shell_commandv;
#line 421 "../src/widgets/Terminal.vala"
	_tmp39__length1 = custom_shell_commandv_length1;
#line 421 "../src/widgets/Terminal.vala"
	if (_tmp39_ != NULL) {
#line 2324 "Terminal.c"
		gchar** _tmp40_;
		gint _tmp40__length1;
#line 422 "../src/widgets/Terminal.vala"
		_tmp40_ = custom_shell_commandv;
#line 422 "../src/widgets/Terminal.vala"
		_tmp40__length1 = custom_shell_commandv_length1;
#line 2331 "Terminal.c"
		{
			gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 422 "../src/widgets/Terminal.vala"
			s_collection = _tmp40_;
#line 422 "../src/widgets/Terminal.vala"
			s_collection_length1 = _tmp40__length1;
#line 422 "../src/widgets/Terminal.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 2343 "Terminal.c"
				const gchar* s = NULL;
#line 422 "../src/widgets/Terminal.vala"
				s = s_collection[s_it];
#line 2347 "Terminal.c"
				{
					GArray* _tmp41_;
					const gchar* _tmp42_;
					gchar* _tmp43_;
#line 423 "../src/widgets/Terminal.vala"
					_tmp41_ = argv;
#line 423 "../src/widgets/Terminal.vala"
					_tmp42_ = s;
#line 423 "../src/widgets/Terminal.vala"
					_tmp43_ = g_strdup (_tmp42_);
#line 423 "../src/widgets/Terminal.vala"
					g_array_append_val (_tmp41_, _tmp43_);
#line 2360 "Terminal.c"
				}
			}
		}
	} else {
		GArray* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gboolean _tmp47_ = FALSE;
		TerminalSettings* _tmp48_;
		gboolean _tmp49_;
		gboolean _tmp50_;
#line 427 "../src/widgets/Terminal.vala"
		_tmp44_ = argv;
#line 427 "../src/widgets/Terminal.vala"
		_tmp45_ = shell;
#line 427 "../src/widgets/Terminal.vala"
		_tmp46_ = g_strdup (_tmp45_);
#line 427 "../src/widgets/Terminal.vala"
		g_array_append_val (_tmp44_, _tmp46_);
#line 428 "../src/widgets/Terminal.vala"
		_tmp48_ = settings;
#line 428 "../src/widgets/Terminal.vala"
		_tmp49_ = terminal_settings_get_command_as_login_shell (_tmp48_);
#line 428 "../src/widgets/Terminal.vala"
		_tmp50_ = _tmp49_;
#line 428 "../src/widgets/Terminal.vala"
		if (_tmp50_) {
#line 428 "../src/widgets/Terminal.vala"
			_tmp47_ = command == NULL;
#line 2390 "Terminal.c"
		} else {
#line 428 "../src/widgets/Terminal.vala"
			_tmp47_ = FALSE;
#line 2394 "Terminal.c"
		}
#line 428 "../src/widgets/Terminal.vala"
		if (_tmp47_) {
#line 2398 "Terminal.c"
			GArray* _tmp51_;
			gchar* _tmp52_;
#line 429 "../src/widgets/Terminal.vala"
			_tmp51_ = argv;
#line 429 "../src/widgets/Terminal.vala"
			_tmp52_ = g_strdup ("--login");
#line 429 "../src/widgets/Terminal.vala"
			g_array_append_val (_tmp51_, _tmp52_);
#line 2407 "Terminal.c"
		}
	}
#line 432 "../src/widgets/Terminal.vala"
	if (command != NULL) {
#line 2412 "Terminal.c"
		GArray* _tmp53_;
		gchar* _tmp54_;
		GArray* _tmp55_;
		gchar* _tmp56_;
#line 433 "../src/widgets/Terminal.vala"
		_tmp53_ = argv;
#line 433 "../src/widgets/Terminal.vala"
		_tmp54_ = g_strdup ("-c");
#line 433 "../src/widgets/Terminal.vala"
		g_array_append_val (_tmp53_, _tmp54_);
#line 434 "../src/widgets/Terminal.vala"
		_tmp55_ = argv;
#line 434 "../src/widgets/Terminal.vala"
		_tmp56_ = g_strdup (command);
#line 434 "../src/widgets/Terminal.vala"
		g_array_append_val (_tmp55_, _tmp56_);
#line 2429 "Terminal.c"
	}
#line 438 "../src/widgets/Terminal.vala"
	_tmp57_ = argv;
#line 438 "../src/widgets/Terminal.vala"
	_tmp58_ = envv;
#line 438 "../src/widgets/Terminal.vala"
	terminal_terminal_spawn_on_flatpak (self, flags, cwd, _tmp57_, _tmp58_, ___lambda15__gasync_ready_callback, g_object_ref (self));
#line 375 "../src/widgets/Terminal.vala"
	tmp_envv = (_vala_array_free (tmp_envv, tmp_envv_length1, (GDestroyNotify) g_free), NULL);
#line 375 "../src/widgets/Terminal.vala"
	_tmp24_ = (_vala_array_free (_tmp24_, _tmp24__length1, (GDestroyNotify) g_free), NULL);
#line 375 "../src/widgets/Terminal.vala"
	_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 375 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp17_);
#line 375 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp15_);
#line 375 "../src/widgets/Terminal.vala"
	_g_free0 (shell);
#line 375 "../src/widgets/Terminal.vala"
	custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
#line 375 "../src/widgets/Terminal.vala"
	_g_object_unref0 (settings);
#line 375 "../src/widgets/Terminal.vala"
	_g_array_unref0 (envv);
#line 375 "../src/widgets/Terminal.vala"
	_g_array_unref0 (argv);
#line 2457 "Terminal.c"
}

static void
__lambda16_ (TerminalTerminal* self,
             TerminalProcess* _process)
{
	gboolean desktop_notifications_enabled = FALSE;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
#line 491 "../src/widgets/Terminal.vala"
	g_return_if_fail (_process != NULL);
#line 492 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_settings_get_default ();
#line 492 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 492 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_settings_get_notify_process_completion (_tmp1_);
#line 492 "../src/widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 492 "../src/widgets/Terminal.vala"
	_tmp4_ = _tmp3_;
#line 492 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_tmp1_);
#line 492 "../src/widgets/Terminal.vala"
	desktop_notifications_enabled = _tmp4_;
#line 496 "../src/widgets/Terminal.vala"
	if (desktop_notifications_enabled) {
#line 2490 "Terminal.c"
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 497 "../src/widgets/Terminal.vala"
		g_object_get ((GtkWidget*) self, "has-focus", &_tmp7_, NULL);
#line 497 "../src/widgets/Terminal.vala"
		_tmp8_ = _tmp7_;
#line 497 "../src/widgets/Terminal.vala"
		_tmp6_ = !_tmp8_;
#line 2499 "Terminal.c"
	} else {
#line 496 "../src/widgets/Terminal.vala"
		_tmp6_ = FALSE;
#line 2503 "Terminal.c"
	}
#line 496 "../src/widgets/Terminal.vala"
	if (_tmp6_) {
#line 2507 "Terminal.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 498 "../src/widgets/Terminal.vala"
		_tmp9_ = terminal_process_get_last_foreground_task_command (_process);
#line 498 "../src/widgets/Terminal.vala"
		_tmp10_ = _tmp9_;
#line 498 "../src/widgets/Terminal.vala"
		_tmp5_ = _tmp10_ != NULL;
#line 2516 "Terminal.c"
	} else {
#line 496 "../src/widgets/Terminal.vala"
		_tmp5_ = FALSE;
#line 2520 "Terminal.c"
	}
#line 495 "../src/widgets/Terminal.vala"
	if (_tmp5_) {
#line 2524 "Terminal.c"
		GNotification* n = NULL;
		GNotification* _tmp11_;
		GNotification* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		TerminalWindow* _tmp15_;
		GtkApplication* _tmp16_;
		GtkApplication* _tmp17_;
		GNotification* _tmp18_;
		GApplication* _tmp19_;
		GNotification* _tmp20_;
#line 500 "../src/widgets/Terminal.vala"
		_tmp11_ = g_notification_new (_ ("Command completed"));
#line 500 "../src/widgets/Terminal.vala"
		n = _tmp11_;
#line 501 "../src/widgets/Terminal.vala"
		_tmp12_ = n;
#line 501 "../src/widgets/Terminal.vala"
		_tmp13_ = terminal_process_get_last_foreground_task_command (_process);
#line 501 "../src/widgets/Terminal.vala"
		_tmp14_ = _tmp13_;
#line 501 "../src/widgets/Terminal.vala"
		g_notification_set_body (_tmp12_, _tmp14_);
#line 510 "../src/widgets/Terminal.vala"
		_tmp15_ = self->window;
#line 510 "../src/widgets/Terminal.vala"
		_tmp16_ = gtk_window_get_application ((GtkWindow*) _tmp15_);
#line 510 "../src/widgets/Terminal.vala"
		_tmp17_ = _tmp16_;
#line 510 "../src/widgets/Terminal.vala"
		_tmp18_ = n;
#line 510 "../src/widgets/Terminal.vala"
		g_application_send_notification ((GApplication*) _tmp17_, NULL, _tmp18_);
#line 514 "../src/widgets/Terminal.vala"
		_tmp19_ = g_application_get_default ();
#line 514 "../src/widgets/Terminal.vala"
		_tmp20_ = n;
#line 514 "../src/widgets/Terminal.vala"
		g_application_send_notification (_tmp19_, NULL, _tmp20_);
#line 495 "../src/widgets/Terminal.vala"
		_g_object_unref0 (n);
#line 2566 "Terminal.c"
	}
}

static void
___lambda16__terminal_process_foreground_task_finished (TerminalProcess* _sender,
                                                        gpointer self)
{
#line 491 "../src/widgets/Terminal.vala"
	__lambda16_ ((TerminalTerminal*) self, _sender);
#line 2576 "Terminal.c"
}

static TerminalProcessContext*
_terminal_process_context_dup (TerminalProcessContext* self)
{
	TerminalProcessContext* dup;
#line 519 "../src/widgets/Terminal.vala"
	dup = g_new0 (TerminalProcessContext, 1);
#line 519 "../src/widgets/Terminal.vala"
	memcpy (dup, self, sizeof (TerminalProcessContext));
#line 519 "../src/widgets/Terminal.vala"
	return dup;
#line 2589 "Terminal.c"
}

static gpointer
__terminal_process_context_dup0 (gpointer self)
{
#line 519 "../src/widgets/Terminal.vala"
	return self ? _terminal_process_context_dup (self) : NULL;
#line 2597 "Terminal.c"
}

static void
__lambda17_ (TerminalTerminal* self,
             GObject* __process,
             GParamSpec* spec)
{
	TerminalProcess* _tmp0_ = NULL;
	TerminalProcess* _tmp1_;
	TerminalProcessContext* _tmp2_ = NULL;
	TerminalProcessContext* _tmp6_ = NULL;
	TerminalProcessContext* _tmp7_;
	TerminalProcessContext* context = NULL;
	TerminalProcessContext* _tmp10_;
#line 518 "../src/widgets/Terminal.vala"
	g_return_if_fail (__process != NULL);
#line 518 "../src/widgets/Terminal.vala"
	g_return_if_fail (spec != NULL);
#line 519 "../src/widgets/Terminal.vala"
	_tmp1_ = self->priv->_process;
#line 519 "../src/widgets/Terminal.vala"
	_tmp0_ = TERMINAL_IS_PROCESS (_tmp1_) ? ((TerminalProcess*) _tmp1_) : NULL;
#line 519 "../src/widgets/Terminal.vala"
	_tmp2_ = NULL;
#line 519 "../src/widgets/Terminal.vala"
	if (_tmp0_ != NULL) {
#line 2624 "Terminal.c"
		TerminalProcessContext _tmp3_;
		TerminalProcessContext _tmp4_;
		TerminalProcessContext* _tmp5_;
#line 519 "../src/widgets/Terminal.vala"
		_tmp3_ = terminal_process_get_context (_tmp0_);
#line 519 "../src/widgets/Terminal.vala"
		_tmp4_ = _tmp3_;
#line 519 "../src/widgets/Terminal.vala"
		_tmp5_ = __terminal_process_context_dup0 (&_tmp4_);
#line 519 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp2_);
#line 519 "../src/widgets/Terminal.vala"
		_tmp2_ = _tmp5_;
#line 2638 "Terminal.c"
	}
#line 519 "../src/widgets/Terminal.vala"
	_tmp7_ = _tmp2_;
#line 519 "../src/widgets/Terminal.vala"
	_tmp2_ = NULL;
#line 519 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp7_;
#line 519 "../src/widgets/Terminal.vala"
	if (_tmp6_ == NULL) {
#line 2648 "Terminal.c"
		TerminalProcessContext _tmp8_;
		TerminalProcessContext* _tmp9_;
#line 519 "../src/widgets/Terminal.vala"
		_tmp8_ = TERMINAL_PROCESS_CONTEXT_DEFAULT;
#line 519 "../src/widgets/Terminal.vala"
		_tmp9_ = __terminal_process_context_dup0 (&_tmp8_);
#line 519 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp6_);
#line 519 "../src/widgets/Terminal.vala"
		_tmp6_ = _tmp9_;
#line 2659 "Terminal.c"
	}
#line 519 "../src/widgets/Terminal.vala"
	_tmp10_ = _tmp6_;
#line 519 "../src/widgets/Terminal.vala"
	_tmp6_ = NULL;
#line 519 "../src/widgets/Terminal.vala"
	context = _tmp10_;
#line 521 "../src/widgets/Terminal.vala"
	g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL], 0, *context);
#line 518 "../src/widgets/Terminal.vala"
	_g_free0 (context);
#line 518 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp6_);
#line 518 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp2_);
#line 2675 "Terminal.c"
}

static void
___lambda17__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 518 "../src/widgets/Terminal.vala"
	__lambda17_ ((TerminalTerminal*) self, _sender, pspec);
#line 2685 "Terminal.c"
}

static void
terminal_terminal_on_spawn_finished (TerminalTerminal* self)
{
	VtePty* _tmp0_;
	VtePty* _tmp1_;
	GPid _tmp2_;
	TerminalProcess* _tmp3_ = NULL;
	TerminalProcess* _tmp4_;
	TerminalProcess* _tmp5_;
	TerminalProcess* _tmp6_;
	TerminalProcessWatcher* _tmp7_;
	TerminalProcessWatcher* _tmp8_;
	TerminalProcess* _tmp9_;
	TerminalProcess* _tmp10_;
	TerminalProcessContext _tmp11_;
	TerminalProcessContext _tmp12_;
#line 480 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 481 "../src/widgets/Terminal.vala"
	if (self->priv->_pid < ((GPid) 0)) {
#line 482 "../src/widgets/Terminal.vala"
		return;
#line 2710 "Terminal.c"
	}
#line 485 "../src/widgets/Terminal.vala"
	_tmp0_ = vte_terminal_get_pty ((VteTerminal*) self);
#line 485 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 485 "../src/widgets/Terminal.vala"
	_tmp2_ = self->priv->_pid;
#line 485 "../src/widgets/Terminal.vala"
	_tmp3_ = terminal_process_new ();
#line 485 "../src/widgets/Terminal.vala"
	terminal_process_set_terminal_fd (_tmp3_, vte_pty_get_fd (_tmp1_));
#line 485 "../src/widgets/Terminal.vala"
	terminal_process_set_pid (_tmp3_, _tmp2_);
#line 485 "../src/widgets/Terminal.vala"
	terminal_process_set_foreground_pid (_tmp3_, (GPid) -1);
#line 485 "../src/widgets/Terminal.vala"
	_tmp4_ = _tmp3_;
#line 485 "../src/widgets/Terminal.vala"
	terminal_terminal_set_process (self, _tmp4_);
#line 485 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_tmp4_);
#line 491 "../src/widgets/Terminal.vala"
	_tmp5_ = self->priv->_process;
#line 491 "../src/widgets/Terminal.vala"
	g_signal_connect_object (_tmp5_, "foreground-task-finished", (GCallback) ___lambda16__terminal_process_foreground_task_finished, self, 0);
#line 518 "../src/widgets/Terminal.vala"
	_tmp6_ = self->priv->_process;
#line 518 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp6_, "notify::context", (GCallback) ___lambda17__g_object_notify, self, 0);
#line 531 "../src/widgets/Terminal.vala"
	_tmp7_ = terminal_process_watcher_get_instance ();
#line 531 "../src/widgets/Terminal.vala"
	_tmp8_ = _tmp7_;
#line 531 "../src/widgets/Terminal.vala"
	_tmp9_ = self->priv->_process;
#line 531 "../src/widgets/Terminal.vala"
	terminal_process_watcher_watch (_tmp8_, _tmp9_);
#line 531 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_tmp8_);
#line 533 "../src/widgets/Terminal.vala"
	_tmp10_ = self->priv->_process;
#line 533 "../src/widgets/Terminal.vala"
	_tmp11_ = terminal_process_get_context (_tmp10_);
#line 533 "../src/widgets/Terminal.vala"
	_tmp12_ = _tmp11_;
#line 533 "../src/widgets/Terminal.vala"
	g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL], 0, _tmp12_);
#line 2758 "Terminal.c"
}

static void
terminal_terminal_spawn_on_flatpak_data_free (gpointer _data)
{
	TerminalTerminalSpawnOnFlatpakData* _data_;
	_data_ = _data;
#line 21 "../src/widgets/Terminal.vala"
	_g_free0 (_data_->cwd);
#line 21 "../src/widgets/Terminal.vala"
	_g_array_unref0 (_data_->argv);
#line 21 "../src/widgets/Terminal.vala"
	_g_array_unref0 (_data_->envv);
#line 21 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/widgets/Terminal.vala"
	g_slice_free (TerminalTerminalSpawnOnFlatpakData, _data_);
#line 2776 "Terminal.c"
}

static gpointer
_g_array_ref0 (gpointer self)
{
#line 21 "../src/widgets/Terminal.vala"
	return self ? g_array_ref (self) : NULL;
#line 2784 "Terminal.c"
}

static void
terminal_terminal_spawn_on_flatpak (TerminalTerminal* self,
                                    VtePtyFlags flags,
                                    const gchar* cwd,
                                    GArray* argv,
                                    GArray* envv,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	TerminalTerminalSpawnOnFlatpakData* _data_;
	TerminalTerminal* _tmp0_;
	gchar* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (argv != NULL);
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (envv != NULL);
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_slice_new0 (TerminalTerminalSpawnOnFlatpakData);
#line 21 "../src/widgets/Terminal.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/widgets/Terminal.vala"
	g_task_set_task_data (_data_->_async_result, _data_, terminal_terminal_spawn_on_flatpak_data_free);
#line 21 "../src/widgets/Terminal.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/widgets/Terminal.vala"
	_data_->self = _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	_data_->flags = flags;
#line 21 "../src/widgets/Terminal.vala"
	_tmp1_ = g_strdup (cwd);
#line 21 "../src/widgets/Terminal.vala"
	_g_free0 (_data_->cwd);
#line 21 "../src/widgets/Terminal.vala"
	_data_->cwd = _tmp1_;
#line 21 "../src/widgets/Terminal.vala"
	_tmp2_ = _g_array_ref0 (argv);
#line 21 "../src/widgets/Terminal.vala"
	_g_array_unref0 (_data_->argv);
#line 21 "../src/widgets/Terminal.vala"
	_data_->argv = _tmp2_;
#line 21 "../src/widgets/Terminal.vala"
	_tmp3_ = _g_array_ref0 (envv);
#line 21 "../src/widgets/Terminal.vala"
	_g_array_unref0 (_data_->envv);
#line 21 "../src/widgets/Terminal.vala"
	_data_->envv = _tmp3_;
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_spawn_on_flatpak_co (_data_);
#line 2839 "Terminal.c"
}

static gboolean
terminal_terminal_spawn_on_flatpak_finish (TerminalTerminal* self,
                                           GAsyncResult* _res_,
                                           GPid* p,
                                           GError** error)
{
	gboolean result;
	TerminalTerminalSpawnOnFlatpakData* _data_;
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 21 "../src/widgets/Terminal.vala"
	if (NULL == _data_) {
#line 2854 "Terminal.c"
		gboolean _tmp0_ = FALSE;
#line 21 "../src/widgets/Terminal.vala"
		return _tmp0_;
#line 2858 "Terminal.c"
	}
#line 21 "../src/widgets/Terminal.vala"
	if (p) {
#line 21 "../src/widgets/Terminal.vala"
		*p = _data_->p;
#line 2864 "Terminal.c"
	}
#line 21 "../src/widgets/Terminal.vala"
	result = _data_->result;
#line 21 "../src/widgets/Terminal.vala"
	return result;
#line 2870 "Terminal.c"
}

static void
_vala_array_add3 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 567 "../src/widgets/Terminal.vala"
	if ((*length) == (*size)) {
#line 567 "../src/widgets/Terminal.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 567 "../src/widgets/Terminal.vala"
		*array = g_renew (gint, *array, *size);
#line 2885 "Terminal.c"
	}
#line 567 "../src/widgets/Terminal.vala"
	(*array)[(*length)++] = value;
#line 2889 "Terminal.c"
}

static void
_vala_array_add4 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 574 "../src/widgets/Terminal.vala"
	if ((*length) == (*size)) {
#line 574 "../src/widgets/Terminal.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 574 "../src/widgets/Terminal.vala"
		*array = g_renew (gint, *array, *size);
#line 2904 "Terminal.c"
	}
#line 574 "../src/widgets/Terminal.vala"
	(*array)[(*length)++] = value;
#line 2908 "Terminal.c"
}

static void
_vala_array_add5 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 575 "../src/widgets/Terminal.vala"
	if ((*length) == (*size)) {
#line 575 "../src/widgets/Terminal.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 575 "../src/widgets/Terminal.vala"
		*array = g_renew (gint, *array, *size);
#line 2923 "Terminal.c"
	}
#line 575 "../src/widgets/Terminal.vala"
	(*array)[(*length)++] = value;
#line 2927 "Terminal.c"
}

static void
_terminal_terminal_on_host_command_exited_terminal_host_command_exited_callback (guint pid,
                                                                                 guint status,
                                                                                 gpointer self)
{
#line 579 "../src/widgets/Terminal.vala"
	terminal_terminal_on_host_command_exited ((TerminalTerminal*) self, pid, status);
#line 2937 "Terminal.c"
}

static void
terminal_terminal_spawn_on_flatpak_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	TerminalTerminalSpawnOnFlatpakData* _data_;
#line 579 "../src/widgets/Terminal.vala"
	_data_ = _user_data_;
#line 579 "../src/widgets/Terminal.vala"
	_data_->_source_object_ = source_object;
#line 579 "../src/widgets/Terminal.vala"
	_data_->_res_ = _res_;
#line 579 "../src/widgets/Terminal.vala"
	terminal_terminal_spawn_on_flatpak_co (_data_);
#line 2954 "Terminal.c"
}

static gboolean
terminal_terminal_spawn_on_flatpak_co (TerminalTerminalSpawnOnFlatpakData* _data_)
{
#line 536 "../src/widgets/Terminal.vala"
	switch (_data_->_state_) {
#line 536 "../src/widgets/Terminal.vala"
		case 0:
#line 2964 "Terminal.c"
		goto _state_0;
#line 536 "../src/widgets/Terminal.vala"
		case 1:
#line 2968 "Terminal.c"
		goto _state_1;
		default:
#line 536 "../src/widgets/Terminal.vala"
		g_assert_not_reached ();
#line 2973 "Terminal.c"
	}
	_state_0:
#line 542 "../src/widgets/Terminal.vala"
	_data_->p = (GPid) -1;
#line 2978 "Terminal.c"
	{
#line 546 "../src/widgets/Terminal.vala"
		_data_->_tmp1_ = vte_pty_new_sync (_data_->flags, NULL, &_data_->_inner_error0_);
#line 546 "../src/widgets/Terminal.vala"
		_data_->_tmp0_ = _data_->_tmp1_;
#line 546 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2986 "Terminal.c"
			goto __catch0_g_error;
		}
#line 546 "../src/widgets/Terminal.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 546 "../src/widgets/Terminal.vala"
		_data_->_tmp0_ = NULL;
#line 546 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 546 "../src/widgets/Terminal.vala"
		_data_->_ppty = _data_->_tmp2_;
#line 545 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 2999 "Terminal.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 545 "../src/widgets/Terminal.vala"
		_data_->e = _data_->_inner_error0_;
#line 545 "../src/widgets/Terminal.vala"
		_data_->_inner_error0_ = NULL;
#line 549 "../src/widgets/Terminal.vala"
		_data_->_tmp3_ = _data_->e;
#line 549 "../src/widgets/Terminal.vala"
		_data_->_tmp4_ = _data_->_tmp3_->message;
#line 549 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:549: %s", _data_->_tmp4_);
#line 550 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 550 "../src/widgets/Terminal.vala"
		_g_error_free0 (_data_->e);
#line 550 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 550 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 550 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 550 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 550 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3028 "Terminal.c"
			}
		}
#line 550 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 550 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3035 "Terminal.c"
	}
	__finally0:
#line 545 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 545 "../src/widgets/Terminal.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 545 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 545 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 545 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3048 "Terminal.c"
	}
#line 553 "../src/widgets/Terminal.vala"
	_data_->_tmp5_ = _data_->_ppty;
#line 553 "../src/widgets/Terminal.vala"
	_data_->pty_master = vte_pty_get_fd (_data_->_tmp5_);
#line 555 "../src/widgets/Terminal.vala"
	if (grantpt (_data_->pty_master) != 0) {
#line 556 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:556: Failed granting access to slave pseudoterminal devi" \
"ce");
#line 557 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 557 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 557 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 557 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 557 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 557 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3070 "Terminal.c"
			}
		}
#line 557 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 557 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3077 "Terminal.c"
	}
#line 560 "../src/widgets/Terminal.vala"
	if (unlockpt (_data_->pty_master) != 0) {
#line 561 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:561: Failed unlocking slave pseudoterminal device");
#line 562 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 562 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 562 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 562 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 562 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 562 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3095 "Terminal.c"
			}
		}
#line 562 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 562 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3102 "Terminal.c"
	}
#line 565 "../src/widgets/Terminal.vala"
	_data_->_tmp6_ = g_new0 (gint, 0);
#line 565 "../src/widgets/Terminal.vala"
	_data_->pty_slaves = _data_->_tmp6_;
#line 565 "../src/widgets/Terminal.vala"
	_data_->pty_slaves_length1 = 0;
#line 565 "../src/widgets/Terminal.vala"
	_data_->_pty_slaves_size_ = _data_->pty_slaves_length1;
#line 567 "../src/widgets/Terminal.vala"
	_data_->_tmp7_ = ptsname (_data_->pty_master);
#line 567 "../src/widgets/Terminal.vala"
	_vala_array_add3 (&_data_->pty_slaves, &_data_->pty_slaves_length1, &_data_->_pty_slaves_size_, open (_data_->_tmp7_, O_RDWR | O_CLOEXEC, (mode_t) 0));
#line 569 "../src/widgets/Terminal.vala"
	_data_->_tmp8_ = _data_->pty_slaves;
#line 569 "../src/widgets/Terminal.vala"
	_data_->_tmp8__length1 = _data_->pty_slaves_length1;
#line 569 "../src/widgets/Terminal.vala"
	_data_->_tmp9_ = _data_->_tmp8_[0];
#line 569 "../src/widgets/Terminal.vala"
	if (_data_->_tmp9_ < 0) {
#line 570 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:570: Failed opening slave pseudoterminal device");
#line 571 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 571 "../src/widgets/Terminal.vala"
		_data_->pty_slaves = (g_free (_data_->pty_slaves), NULL);
#line 571 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 571 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 571 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 571 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 571 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3140 "Terminal.c"
			}
		}
#line 571 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 571 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3147 "Terminal.c"
	}
#line 574 "../src/widgets/Terminal.vala"
	_data_->_tmp10_ = _data_->pty_slaves;
#line 574 "../src/widgets/Terminal.vala"
	_data_->_tmp10__length1 = _data_->pty_slaves_length1;
#line 574 "../src/widgets/Terminal.vala"
	_data_->_tmp11_ = _data_->_tmp10_[0];
#line 574 "../src/widgets/Terminal.vala"
	_vala_array_add4 (&_data_->pty_slaves, &_data_->pty_slaves_length1, &_data_->_pty_slaves_size_, dup (_data_->_tmp11_));
#line 575 "../src/widgets/Terminal.vala"
	_data_->_tmp12_ = _data_->pty_slaves;
#line 575 "../src/widgets/Terminal.vala"
	_data_->_tmp12__length1 = _data_->pty_slaves_length1;
#line 575 "../src/widgets/Terminal.vala"
	_data_->_tmp13_ = _data_->_tmp12_[0];
#line 575 "../src/widgets/Terminal.vala"
	_vala_array_add5 (&_data_->pty_slaves, &_data_->pty_slaves_length1, &_data_->_pty_slaves_size_, dup (_data_->_tmp13_));
#line 577 "../src/widgets/Terminal.vala"
	_data_->_tmp14_ = g_cancellable_new ();
#line 577 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->self->priv->fp_spawn_host_command_callback_cancellable);
#line 577 "../src/widgets/Terminal.vala"
	_data_->self->priv->fp_spawn_host_command_callback_cancellable = _data_->_tmp14_;
#line 579 "../src/widgets/Terminal.vala"
	_data_->_tmp15_ = _data_->pty_slaves;
#line 579 "../src/widgets/Terminal.vala"
	_data_->_tmp15__length1 = _data_->pty_slaves_length1;
#line 579 "../src/widgets/Terminal.vala"
	_data_->_tmp16_ = _data_->self->priv->fp_spawn_host_command_callback_cancellable;
#line 579 "../src/widgets/Terminal.vala"
	_data_->_tmp17_ = 0;
#line 579 "../src/widgets/Terminal.vala"
	_data_->_state_ = 1;
#line 579 "../src/widgets/Terminal.vala"
	terminal_send_host_command (_data_->cwd, _data_->argv, _data_->envv, _data_->_tmp15_, (gint) _data_->_tmp15__length1, _terminal_terminal_on_host_command_exited_terminal_host_command_exited_callback, _data_->self, _data_->_tmp16_, terminal_terminal_spawn_on_flatpak_ready, _data_);
#line 579 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3185 "Terminal.c"
	_state_1:
#line 579 "../src/widgets/Terminal.vala"
	_data_->_tmp18_ = terminal_send_host_command_finish (_data_->_res_, &_data_->_tmp17_, &_data_->_inner_error0_);
#line 579 "../src/widgets/Terminal.vala"
	_data_->p = (GPid) _data_->_tmp17_;
#line 579 "../src/widgets/Terminal.vala"
	_data_->res = _data_->_tmp18_;
#line 579 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 579 "../src/widgets/Terminal.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 579 "../src/widgets/Terminal.vala"
		_data_->pty_slaves = (g_free (_data_->pty_slaves), NULL);
#line 579 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 579 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 579 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3205 "Terminal.c"
	}
#line 589 "../src/widgets/Terminal.vala"
	_data_->_tmp19_ = _data_->_ppty;
#line 589 "../src/widgets/Terminal.vala"
	vte_terminal_set_pty ((VteTerminal*) _data_->self, _data_->_tmp19_);
#line 591 "../src/widgets/Terminal.vala"
	_data_->result = _data_->res;
#line 591 "../src/widgets/Terminal.vala"
	_data_->pty_slaves = (g_free (_data_->pty_slaves), NULL);
#line 591 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->_ppty);
#line 591 "../src/widgets/Terminal.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 591 "../src/widgets/Terminal.vala"
	if (_data_->_state_ != 0) {
#line 591 "../src/widgets/Terminal.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 591 "../src/widgets/Terminal.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3225 "Terminal.c"
		}
	}
#line 591 "../src/widgets/Terminal.vala"
	g_object_unref (_data_->_async_result);
#line 591 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3232 "Terminal.c"
}

static void
terminal_terminal_on_host_command_exited (TerminalTerminal* self,
                                          guint _pid,
                                          guint status)
{
#line 594 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 595 "../src/widgets/Terminal.vala"
	g_signal_emit_by_name ((VteTerminal*) self, "child-exited", (gint) status);
#line 3244 "Terminal.c"
}

static void
terminal_terminal_on_child_exited (TerminalTerminal* self,
                                   gint status)
{
#line 600 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 601 "../src/widgets/Terminal.vala"
	g_debug ("Terminal.vala:601: Child exited with code %d", status);
#line 602 "../src/widgets/Terminal.vala"
	terminal_terminal_set_pid (self, (GPid) -1);
#line 606 "../src/widgets/Terminal.vala"
	terminal_terminal_set_process (self, NULL);
#line 607 "../src/widgets/Terminal.vala"
	g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_EXIT_SIGNAL], 0);
#line 3261 "Terminal.c"
}

static gboolean
terminal_terminal_on_key_pressed (TerminalTerminal* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 619 "../src/widgets/Terminal.vala"
	static GQuark _tmp2_label0 = 0;
#line 619 "../src/widgets/Terminal.vala"
	static GQuark _tmp2_label1 = 0;
#line 3277 "Terminal.c"
	gboolean result;
#line 610 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 615 "../src/widgets/Terminal.vala"
	if ((state & GDK_CONTROL_MASK) == 0) {
#line 616 "../src/widgets/Terminal.vala"
		result = FALSE;
#line 616 "../src/widgets/Terminal.vala"
		return result;
#line 3287 "Terminal.c"
	}
#line 619 "../src/widgets/Terminal.vala"
	_tmp0_ = gdk_keyval_name (keyval);
#line 619 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 619 "../src/widgets/Terminal.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 619 "../src/widgets/Terminal.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("c")))) {
#line 619 "../src/widgets/Terminal.vala"
		switch (0) {
#line 3299 "Terminal.c"
			default:
			{
				{
					gboolean _tmp4_ = FALSE;
#line 622 "../src/widgets/Terminal.vala"
					if (vte_terminal_get_has_selection ((VteTerminal*) self)) {
#line 3306 "Terminal.c"
						TerminalSettings* _tmp5_;
						TerminalSettings* _tmp6_;
						gboolean _tmp7_;
						gboolean _tmp8_;
#line 623 "../src/widgets/Terminal.vala"
						_tmp5_ = terminal_settings_get_default ();
#line 623 "../src/widgets/Terminal.vala"
						_tmp6_ = _tmp5_;
#line 623 "../src/widgets/Terminal.vala"
						_tmp7_ = terminal_settings_get_easy_copy_paste (_tmp6_);
#line 623 "../src/widgets/Terminal.vala"
						_tmp8_ = _tmp7_;
#line 623 "../src/widgets/Terminal.vala"
						_tmp4_ = _tmp8_;
#line 623 "../src/widgets/Terminal.vala"
						_g_object_unref0 (_tmp6_);
#line 3323 "Terminal.c"
					} else {
#line 622 "../src/widgets/Terminal.vala"
						_tmp4_ = FALSE;
#line 3327 "Terminal.c"
					}
#line 621 "../src/widgets/Terminal.vala"
					if (_tmp4_) {
#line 625 "../src/widgets/Terminal.vala"
						terminal_terminal_do_copy_clipboard (self);
#line 626 "../src/widgets/Terminal.vala"
						vte_terminal_unselect_all ((VteTerminal*) self);
#line 627 "../src/widgets/Terminal.vala"
						result = TRUE;
#line 627 "../src/widgets/Terminal.vala"
						return result;
#line 3339 "Terminal.c"
					}
#line 629 "../src/widgets/Terminal.vala"
					result = FALSE;
#line 629 "../src/widgets/Terminal.vala"
					return result;
#line 3345 "Terminal.c"
				}
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("v")))) {
#line 619 "../src/widgets/Terminal.vala"
		switch (0) {
#line 3352 "Terminal.c"
			default:
			{
				{
					TerminalSettings* _tmp9_;
					TerminalSettings* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					gboolean _tmp13_;
#line 632 "../src/widgets/Terminal.vala"
					_tmp9_ = terminal_settings_get_default ();
#line 632 "../src/widgets/Terminal.vala"
					_tmp10_ = _tmp9_;
#line 632 "../src/widgets/Terminal.vala"
					_tmp11_ = terminal_settings_get_easy_copy_paste (_tmp10_);
#line 632 "../src/widgets/Terminal.vala"
					_tmp12_ = _tmp11_;
#line 632 "../src/widgets/Terminal.vala"
					_tmp13_ = _tmp12_;
#line 632 "../src/widgets/Terminal.vala"
					_g_object_unref0 (_tmp10_);
#line 632 "../src/widgets/Terminal.vala"
					if (_tmp13_) {
#line 633 "../src/widgets/Terminal.vala"
						terminal_terminal_do_paste_clipboard (self);
#line 634 "../src/widgets/Terminal.vala"
						result = TRUE;
#line 634 "../src/widgets/Terminal.vala"
						return result;
#line 3381 "Terminal.c"
					}
#line 636 "../src/widgets/Terminal.vala"
					result = FALSE;
#line 636 "../src/widgets/Terminal.vala"
					return result;
#line 3387 "Terminal.c"
				}
			}
		}
	}
#line 640 "../src/widgets/Terminal.vala"
	result = FALSE;
#line 640 "../src/widgets/Terminal.vala"
	return result;
#line 3396 "Terminal.c"
}

static void
terminal_terminal_get_can_close_data_free (gpointer _data)
{
	TerminalTerminalGetCanCloseData* _data_;
	_data_ = _data;
#line 21 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/widgets/Terminal.vala"
	g_slice_free (TerminalTerminalGetCanCloseData, _data_);
#line 3408 "Terminal.c"
}

void
terminal_terminal_get_can_close (TerminalTerminal* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	TerminalTerminalGetCanCloseData* _data_;
	TerminalTerminal* _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_slice_new0 (TerminalTerminalGetCanCloseData);
#line 21 "../src/widgets/Terminal.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/widgets/Terminal.vala"
	g_task_set_task_data (_data_->_async_result, _data_, terminal_terminal_get_can_close_data_free);
#line 21 "../src/widgets/Terminal.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/widgets/Terminal.vala"
	_data_->self = _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_get_can_close_co (_data_);
#line 3432 "Terminal.c"
}

gboolean
terminal_terminal_get_can_close_finish (TerminalTerminal* self,
                                        GAsyncResult* _res_,
                                        gchar** command)
{
	gboolean result;
	TerminalTerminalGetCanCloseData* _data_;
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 21 "../src/widgets/Terminal.vala"
	if (command) {
#line 21 "../src/widgets/Terminal.vala"
		*command = _data_->command;
#line 3448 "Terminal.c"
	} else {
#line 21 "../src/widgets/Terminal.vala"
		_g_free0 (_data_->command);
#line 3452 "Terminal.c"
	}
#line 21 "../src/widgets/Terminal.vala"
	_data_->command = NULL;
#line 21 "../src/widgets/Terminal.vala"
	result = _data_->result;
#line 21 "../src/widgets/Terminal.vala"
	return result;
#line 3460 "Terminal.c"
}

static void
terminal_terminal_get_can_close_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	TerminalTerminalGetCanCloseData* _data_;
#line 656 "../src/widgets/Terminal.vala"
	_data_ = _user_data_;
#line 656 "../src/widgets/Terminal.vala"
	_data_->_source_object_ = source_object;
#line 656 "../src/widgets/Terminal.vala"
	_data_->_res_ = _res_;
#line 656 "../src/widgets/Terminal.vala"
	terminal_terminal_get_can_close_co (_data_);
#line 3477 "Terminal.c"
}

static gboolean
terminal_terminal_get_can_close_co (TerminalTerminalGetCanCloseData* _data_)
{
#line 643 "../src/widgets/Terminal.vala"
	switch (_data_->_state_) {
#line 643 "../src/widgets/Terminal.vala"
		case 0:
#line 3487 "Terminal.c"
		goto _state_0;
#line 643 "../src/widgets/Terminal.vala"
		case 1:
#line 3491 "Terminal.c"
		goto _state_1;
		default:
#line 643 "../src/widgets/Terminal.vala"
		g_assert_not_reached ();
#line 3496 "Terminal.c"
	}
	_state_0:
#line 644 "../src/widgets/Terminal.vala"
	_g_free0 (_data_->command);
#line 644 "../src/widgets/Terminal.vala"
	_data_->command = NULL;
#line 646 "../src/widgets/Terminal.vala"
	_data_->_tmp1_ = _data_->self->priv->_pid;
#line 646 "../src/widgets/Terminal.vala"
	if (_data_->_tmp1_ < ((GPid) 0)) {
#line 646 "../src/widgets/Terminal.vala"
		_data_->_tmp0_ = TRUE;
#line 3509 "Terminal.c"
	} else {
#line 646 "../src/widgets/Terminal.vala"
		_data_->_tmp2_ = vte_terminal_get_pty ((VteTerminal*) _data_->self);
#line 646 "../src/widgets/Terminal.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 646 "../src/widgets/Terminal.vala"
		_data_->_tmp0_ = _data_->_tmp3_ == NULL;
#line 3517 "Terminal.c"
	}
#line 646 "../src/widgets/Terminal.vala"
	if (_data_->_tmp0_) {
#line 647 "../src/widgets/Terminal.vala"
		_data_->result = TRUE;
#line 647 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 647 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 647 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 647 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3531 "Terminal.c"
			}
		}
#line 647 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 647 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3538 "Terminal.c"
	}
#line 650 "../src/widgets/Terminal.vala"
	_data_->_tmp4_ = vte_terminal_get_pty ((VteTerminal*) _data_->self);
#line 650 "../src/widgets/Terminal.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 650 "../src/widgets/Terminal.vala"
	_data_->_tmp6_ = vte_pty_get_fd (_data_->_tmp5_);
#line 650 "../src/widgets/Terminal.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 650 "../src/widgets/Terminal.vala"
	_data_->fd = _data_->_tmp7_;
#line 651 "../src/widgets/Terminal.vala"
	if (_data_->fd == -1) {
#line 652 "../src/widgets/Terminal.vala"
		_data_->result = TRUE;
#line 652 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 652 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 652 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 652 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3562 "Terminal.c"
			}
		}
#line 652 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 652 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3569 "Terminal.c"
	}
#line 656 "../src/widgets/Terminal.vala"
	_data_->_state_ = 1;
#line 656 "../src/widgets/Terminal.vala"
	terminal_get_foreground_process (_data_->fd, NULL, terminal_terminal_get_can_close_ready, _data_);
#line 656 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3577 "Terminal.c"
	_state_1:
#line 656 "../src/widgets/Terminal.vala"
	_data_->fgpid = terminal_get_foreground_process_finish (_data_->_res_);
#line 657 "../src/widgets/Terminal.vala"
	if (_data_->fgpid == -1) {
#line 658 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 658 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 658 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 658 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 658 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3593 "Terminal.c"
			}
		}
#line 658 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 658 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3600 "Terminal.c"
	}
#line 661 "../src/widgets/Terminal.vala"
	_data_->_tmp8_ = _data_->self->priv->_pid;
#line 661 "../src/widgets/Terminal.vala"
	if (_data_->fgpid == ((gint) _data_->_tmp8_)) {
#line 662 "../src/widgets/Terminal.vala"
		_data_->result = TRUE;
#line 662 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 662 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 662 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 662 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3616 "Terminal.c"
			}
		}
#line 662 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 662 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3623 "Terminal.c"
	}
#line 665 "../src/widgets/Terminal.vala"
	_data_->_tmp9_ = terminal_get_process_cmdline (_data_->fgpid);
#line 665 "../src/widgets/Terminal.vala"
	_g_free0 (_data_->command);
#line 665 "../src/widgets/Terminal.vala"
	_data_->command = _data_->_tmp9_;
#line 667 "../src/widgets/Terminal.vala"
	_data_->_tmp10_ = _data_->command;
#line 667 "../src/widgets/Terminal.vala"
	_data_->result = _data_->_tmp10_ == NULL;
#line 667 "../src/widgets/Terminal.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 667 "../src/widgets/Terminal.vala"
	if (_data_->_state_ != 0) {
#line 667 "../src/widgets/Terminal.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 667 "../src/widgets/Terminal.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3643 "Terminal.c"
		}
	}
#line 667 "../src/widgets/Terminal.vala"
	g_object_unref (_data_->_async_result);
#line 667 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3650 "Terminal.c"
}

void
terminal_terminal_zoom_in (TerminalTerminal* self)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 670 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 671 "../src/widgets/Terminal.vala"
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
#line 671 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 671 "../src/widgets/Terminal.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, MIN ((gdouble) 10, _tmp1_ + 0.1));
#line 3666 "Terminal.c"
}

void
terminal_terminal_zoom_out (TerminalTerminal* self)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 674 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 675 "../src/widgets/Terminal.vala"
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
#line 675 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 675 "../src/widgets/Terminal.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, MAX (0.1, _tmp1_ - 0.1));
#line 3682 "Terminal.c"
}

void
terminal_terminal_zoom_default (TerminalTerminal* self)
{
#line 678 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 679 "../src/widgets/Terminal.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, 1.0);
#line 3692 "Terminal.c"
}

void
terminal_terminal_do_paste_clipboard (TerminalTerminal* self)
{
#line 682 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 683 "../src/widgets/Terminal.vala"
	vte_terminal_paste_clipboard ((VteTerminal*) self);
#line 3702 "Terminal.c"
}

void
terminal_terminal_do_copy_clipboard (TerminalTerminal* self)
{
#line 686 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 687 "../src/widgets/Terminal.vala"
	vte_terminal_copy_clipboard ((VteTerminal*) self);
#line 3712 "Terminal.c"
}

static void
terminal_terminal_do_paste_from_selection_clipboard_data_free (gpointer _data)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
	_data_ = _data;
#line 21 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/widgets/Terminal.vala"
	g_slice_free (TerminalTerminalDoPasteFromSelectionClipboardData, _data_);
#line 3724 "Terminal.c"
}

void
terminal_terminal_do_paste_from_selection_clipboard (TerminalTerminal* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
	TerminalTerminal* _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_slice_new0 (TerminalTerminalDoPasteFromSelectionClipboardData);
#line 21 "../src/widgets/Terminal.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/widgets/Terminal.vala"
	g_task_set_task_data (_data_->_async_result, _data_, terminal_terminal_do_paste_from_selection_clipboard_data_free);
#line 21 "../src/widgets/Terminal.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/widgets/Terminal.vala"
	_data_->self = _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_do_paste_from_selection_clipboard_co (_data_);
#line 3748 "Terminal.c"
}

void
terminal_terminal_do_paste_from_selection_clipboard_finish (TerminalTerminal* self,
                                                            GAsyncResult* _res_)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3758 "Terminal.c"
}

static void
terminal_terminal_do_paste_from_selection_clipboard_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
#line 696 "../src/widgets/Terminal.vala"
	_data_ = _user_data_;
#line 696 "../src/widgets/Terminal.vala"
	_data_->_source_object_ = source_object;
#line 696 "../src/widgets/Terminal.vala"
	_data_->_res_ = _res_;
#line 696 "../src/widgets/Terminal.vala"
	terminal_terminal_do_paste_from_selection_clipboard_co (_data_);
#line 3775 "Terminal.c"
}

static gboolean
terminal_terminal_do_paste_from_selection_clipboard_co (TerminalTerminalDoPasteFromSelectionClipboardData* _data_)
{
#line 690 "../src/widgets/Terminal.vala"
	switch (_data_->_state_) {
#line 690 "../src/widgets/Terminal.vala"
		case 0:
#line 3785 "Terminal.c"
		goto _state_0;
#line 690 "../src/widgets/Terminal.vala"
		case 1:
#line 3789 "Terminal.c"
		goto _state_1;
		default:
#line 690 "../src/widgets/Terminal.vala"
		g_assert_not_reached ();
#line 3794 "Terminal.c"
	}
	_state_0:
#line 694 "../src/widgets/Terminal.vala"
	_data_->_tmp0_ = gdk_display_get_default ();
#line 694 "../src/widgets/Terminal.vala"
	_data_->_tmp1_ = gdk_display_get_primary_clipboard (_data_->_tmp0_);
#line 694 "../src/widgets/Terminal.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->_tmp1_);
#line 694 "../src/widgets/Terminal.vala"
	_data_->clipboard = _data_->_tmp2_;
#line 3805 "Terminal.c"
	{
#line 696 "../src/widgets/Terminal.vala"
		_data_->_state_ = 1;
#line 696 "../src/widgets/Terminal.vala"
		gdk_clipboard_read_text_async (_data_->clipboard, NULL, terminal_terminal_do_paste_from_selection_clipboard_ready, _data_);
#line 696 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3813 "Terminal.c"
		_state_1:
#line 696 "../src/widgets/Terminal.vala"
		_data_->_tmp3_ = gdk_clipboard_read_text_finish (_data_->clipboard, _data_->_res_, &_data_->_inner_error0_);
#line 696 "../src/widgets/Terminal.vala"
		_data_->text = _data_->_tmp3_;
#line 696 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3821 "Terminal.c"
			goto __catch0_g_error;
		}
#line 697 "../src/widgets/Terminal.vala"
		vte_terminal_paste_text ((VteTerminal*) _data_->self, _data_->text);
#line 695 "../src/widgets/Terminal.vala"
		_g_free0 (_data_->text);
#line 3828 "Terminal.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 695 "../src/widgets/Terminal.vala"
		_data_->e = _data_->_inner_error0_;
#line 695 "../src/widgets/Terminal.vala"
		_data_->_inner_error0_ = NULL;
#line 700 "../src/widgets/Terminal.vala"
		_data_->_tmp4_ = _data_->e;
#line 700 "../src/widgets/Terminal.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 700 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:700: %s", _data_->_tmp5_);
#line 695 "../src/widgets/Terminal.vala"
		_g_error_free0 (_data_->e);
#line 3845 "Terminal.c"
	}
	__finally0:
#line 695 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 695 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->clipboard);
#line 695 "../src/widgets/Terminal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 695 "../src/widgets/Terminal.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 695 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 695 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3860 "Terminal.c"
	}
#line 690 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->clipboard);
#line 690 "../src/widgets/Terminal.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 690 "../src/widgets/Terminal.vala"
	if (_data_->_state_ != 0) {
#line 690 "../src/widgets/Terminal.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 690 "../src/widgets/Terminal.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3872 "Terminal.c"
		}
	}
#line 690 "../src/widgets/Terminal.vala"
	g_object_unref (_data_->_async_result);
#line 690 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3879 "Terminal.c"
}

gchar*
terminal_terminal_get_current_working_directory (TerminalTerminal* self)
{
	gchar* cwd = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 704 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 705 "../src/widgets/Terminal.vala"
	_tmp0_ = vte_terminal_get_current_directory_uri ((VteTerminal*) self);
#line 705 "../src/widgets/Terminal.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 705 "../src/widgets/Terminal.vala"
	cwd = _tmp1_;
#line 707 "../src/widgets/Terminal.vala"
	_tmp2_ = cwd;
#line 707 "../src/widgets/Terminal.vala"
	if (_tmp2_ != NULL) {
#line 3903 "Terminal.c"
		{
			gchar* path = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 709 "../src/widgets/Terminal.vala"
			_tmp3_ = cwd;
#line 709 "../src/widgets/Terminal.vala"
			_tmp4_ = g_filename_from_uri (_tmp3_, NULL, &_inner_error0_);
#line 709 "../src/widgets/Terminal.vala"
			path = _tmp4_;
#line 709 "../src/widgets/Terminal.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 709 "../src/widgets/Terminal.vala"
				if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 3920 "Terminal.c"
					goto __catch0_g_convert_error;
				}
#line 709 "../src/widgets/Terminal.vala"
				_g_free0 (cwd);
#line 709 "../src/widgets/Terminal.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 709 "../src/widgets/Terminal.vala"
				g_clear_error (&_inner_error0_);
#line 709 "../src/widgets/Terminal.vala"
				return NULL;
#line 3931 "Terminal.c"
			}
#line 710 "../src/widgets/Terminal.vala"
			_tmp5_ = path;
#line 710 "../src/widgets/Terminal.vala"
			_tmp6_ = g_strdup (_tmp5_);
#line 710 "../src/widgets/Terminal.vala"
			_g_free0 (cwd);
#line 710 "../src/widgets/Terminal.vala"
			cwd = _tmp6_;
#line 708 "../src/widgets/Terminal.vala"
			_g_free0 (path);
#line 3943 "Terminal.c"
		}
		goto __finally0;
		__catch0_g_convert_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
#line 708 "../src/widgets/Terminal.vala"
			e = _inner_error0_;
#line 708 "../src/widgets/Terminal.vala"
			_inner_error0_ = NULL;
#line 713 "../src/widgets/Terminal.vala"
			_tmp7_ = e;
#line 713 "../src/widgets/Terminal.vala"
			_tmp8_ = _tmp7_->message;
#line 713 "../src/widgets/Terminal.vala"
			g_warning ("Terminal.vala:713: %s", _tmp8_);
#line 714 "../src/widgets/Terminal.vala"
			_g_free0 (cwd);
#line 714 "../src/widgets/Terminal.vala"
			cwd = NULL;
#line 708 "../src/widgets/Terminal.vala"
			_g_error_free0 (e);
#line 3967 "Terminal.c"
		}
		__finally0:
#line 708 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 708 "../src/widgets/Terminal.vala"
			_g_free0 (cwd);
#line 708 "../src/widgets/Terminal.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 708 "../src/widgets/Terminal.vala"
			g_clear_error (&_inner_error0_);
#line 708 "../src/widgets/Terminal.vala"
			return NULL;
#line 3980 "Terminal.c"
		}
	}
#line 718 "../src/widgets/Terminal.vala"
	result = cwd;
#line 718 "../src/widgets/Terminal.vala"
	return result;
#line 3987 "Terminal.c"
}

gchar*
terminal_terminal_get_current_working_directory_for_new_session (TerminalTerminal* previous_terminal)
{
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp0_;
	guint mode = 0U;
	TerminalSettings* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gchar* custom_working_directory = NULL;
	TerminalSettings* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 724 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_settings_get_default ();
#line 724 "../src/widgets/Terminal.vala"
	settings = _tmp0_;
#line 725 "../src/widgets/Terminal.vala"
	_tmp1_ = settings;
#line 725 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_settings_get_working_directory_mode (_tmp1_);
#line 725 "../src/widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 725 "../src/widgets/Terminal.vala"
	mode = _tmp3_;
#line 726 "../src/widgets/Terminal.vala"
	_tmp4_ = settings;
#line 726 "../src/widgets/Terminal.vala"
	_tmp5_ = terminal_settings_get_custom_working_directory (_tmp4_);
#line 726 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp5_;
#line 726 "../src/widgets/Terminal.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 726 "../src/widgets/Terminal.vala"
	custom_working_directory = _tmp7_;
#line 728 "../src/widgets/Terminal.vala"
	switch (mode) {
#line 728 "../src/widgets/Terminal.vala"
		case TERMINAL_WORKING_DIRECTORY_MODE_CUSTOM:
#line 4031 "Terminal.c"
		{
#line 730 "../src/widgets/Terminal.vala"
			result = custom_working_directory;
#line 730 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 730 "../src/widgets/Terminal.vala"
			return result;
#line 4039 "Terminal.c"
		}
#line 728 "../src/widgets/Terminal.vala"
		case TERMINAL_WORKING_DIRECTORY_MODE_HOME_DIRECTORY:
#line 4043 "Terminal.c"
		{
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 732 "../src/widgets/Terminal.vala"
			_tmp8_ = g_get_home_dir ();
#line 732 "../src/widgets/Terminal.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 732 "../src/widgets/Terminal.vala"
			result = _tmp9_;
#line 732 "../src/widgets/Terminal.vala"
			_g_free0 (custom_working_directory);
#line 732 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 732 "../src/widgets/Terminal.vala"
			return result;
#line 4059 "Terminal.c"
		}
#line 728 "../src/widgets/Terminal.vala"
		case TERMINAL_WORKING_DIRECTORY_MODE_PREVIOUS_SESSION:
#line 4063 "Terminal.c"
		{
			{
#line 734 "../src/widgets/Terminal.vala"
				if (previous_terminal != NULL) {
#line 4068 "Terminal.c"
					gchar* _tmp10_;
#line 735 "../src/widgets/Terminal.vala"
					_tmp10_ = terminal_terminal_get_current_working_directory (previous_terminal);
#line 735 "../src/widgets/Terminal.vala"
					result = _tmp10_;
#line 735 "../src/widgets/Terminal.vala"
					_g_free0 (custom_working_directory);
#line 735 "../src/widgets/Terminal.vala"
					_g_object_unref0 (settings);
#line 735 "../src/widgets/Terminal.vala"
					return result;
#line 4080 "Terminal.c"
				}
#line 737 "../src/widgets/Terminal.vala"
				break;
#line 4084 "Terminal.c"
			}
		}
		default:
#line 728 "../src/widgets/Terminal.vala"
		break;
#line 4090 "Terminal.c"
	}
#line 741 "../src/widgets/Terminal.vala"
	result = NULL;
#line 741 "../src/widgets/Terminal.vala"
	_g_free0 (custom_working_directory);
#line 741 "../src/widgets/Terminal.vala"
	_g_object_unref0 (settings);
#line 741 "../src/widgets/Terminal.vala"
	return result;
#line 4100 "Terminal.c"
}

TerminalScheme*
terminal_terminal_get_scheme (TerminalTerminal* self)
{
	TerminalScheme* result;
	TerminalScheme* _tmp0_;
#line 56 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->_scheme;
#line 56 "../src/widgets/Terminal.vala"
	result = _tmp0_;
#line 56 "../src/widgets/Terminal.vala"
	return result;
#line 4116 "Terminal.c"
}

void
terminal_terminal_set_scheme (TerminalTerminal* self,
                              TerminalScheme* value)
{
	TerminalScheme* old_value;
#line 56 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/widgets/Terminal.vala"
	old_value = terminal_terminal_get_scheme (self);
#line 56 "../src/widgets/Terminal.vala"
	if (old_value != value) {
#line 4130 "Terminal.c"
		TerminalScheme* _tmp0_;
#line 56 "../src/widgets/Terminal.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 56 "../src/widgets/Terminal.vala"
		_g_object_unref0 (self->priv->_scheme);
#line 56 "../src/widgets/Terminal.vala"
		self->priv->_scheme = _tmp0_;
#line 56 "../src/widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_SCHEME_PROPERTY]);
#line 4140 "Terminal.c"
	}
}

GPid
terminal_terminal_get_pid (TerminalTerminal* self)
{
	GPid result;
#line 57 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 57 "../src/widgets/Terminal.vala"
	result = self->priv->_pid;
#line 57 "../src/widgets/Terminal.vala"
	return result;
#line 4154 "Terminal.c"
}

void
terminal_terminal_set_pid (TerminalTerminal* self,
                           GPid value)
{
	GPid old_value;
#line 57 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/widgets/Terminal.vala"
	old_value = terminal_terminal_get_pid (self);
#line 57 "../src/widgets/Terminal.vala"
	if (old_value != value) {
#line 57 "../src/widgets/Terminal.vala"
		self->priv->_pid = value;
#line 57 "../src/widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_PID_PROPERTY]);
#line 4172 "Terminal.c"
	}
}

TerminalProcess*
terminal_terminal_get_process (TerminalTerminal* self)
{
	TerminalProcess* result;
	TerminalProcess* _tmp0_;
#line 58 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->_process;
#line 58 "../src/widgets/Terminal.vala"
	result = _tmp0_;
#line 58 "../src/widgets/Terminal.vala"
	return result;
#line 4189 "Terminal.c"
}

void
terminal_terminal_set_process (TerminalTerminal* self,
                               TerminalProcess* value)
{
	TerminalProcess* old_value;
#line 58 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/widgets/Terminal.vala"
	old_value = terminal_terminal_get_process (self);
#line 58 "../src/widgets/Terminal.vala"
	if (old_value != value) {
#line 4203 "Terminal.c"
		TerminalProcess* _tmp0_;
#line 58 "../src/widgets/Terminal.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 58 "../src/widgets/Terminal.vala"
		_g_object_unref0 (self->priv->_process);
#line 58 "../src/widgets/Terminal.vala"
		self->priv->_process = _tmp0_;
#line 58 "../src/widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_PROCESS_PROPERTY]);
#line 4213 "Terminal.c"
	}
}

guint
terminal_terminal_get_user_scrollback_lines (TerminalTerminal* self)
{
	guint result;
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
#line 61 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 62 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_settings_get_default ();
#line 62 "../src/widgets/Terminal.vala"
	settings = _tmp0_;
#line 64 "../src/widgets/Terminal.vala"
	_tmp1_ = settings;
#line 64 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_settings_get_scrollback_mode (_tmp1_);
#line 64 "../src/widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 64 "../src/widgets/Terminal.vala"
	switch (_tmp3_) {
#line 64 "../src/widgets/Terminal.vala"
		case TERMINAL_SCROLLBACK_MODE_FIXED:
#line 4242 "Terminal.c"
		{
			TerminalSettings* _tmp4_;
			guint _tmp5_;
			guint _tmp6_;
#line 65 "../src/widgets/Terminal.vala"
			_tmp4_ = settings;
#line 65 "../src/widgets/Terminal.vala"
			_tmp5_ = terminal_settings_get_scrollback_lines (_tmp4_);
#line 65 "../src/widgets/Terminal.vala"
			_tmp6_ = _tmp5_;
#line 65 "../src/widgets/Terminal.vala"
			result = _tmp6_;
#line 65 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 65 "../src/widgets/Terminal.vala"
			return result;
#line 4259 "Terminal.c"
		}
#line 64 "../src/widgets/Terminal.vala"
		case TERMINAL_SCROLLBACK_MODE_UNLIMITED:
#line 4263 "Terminal.c"
		{
#line 66 "../src/widgets/Terminal.vala"
			result = (guint) -1;
#line 66 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 66 "../src/widgets/Terminal.vala"
			return result;
#line 4271 "Terminal.c"
		}
#line 64 "../src/widgets/Terminal.vala"
		case TERMINAL_SCROLLBACK_MODE_DISABLED:
#line 4275 "Terminal.c"
		{
#line 67 "../src/widgets/Terminal.vala"
			result = (guint) 0;
#line 67 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 67 "../src/widgets/Terminal.vala"
			return result;
#line 4283 "Terminal.c"
		}
		default:
		{
			TerminalSettings* _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
#line 69 "../src/widgets/Terminal.vala"
			_tmp7_ = settings;
#line 69 "../src/widgets/Terminal.vala"
			_tmp8_ = terminal_settings_get_scrollback_mode (_tmp7_);
#line 69 "../src/widgets/Terminal.vala"
			_tmp9_ = _tmp8_;
#line 69 "../src/widgets/Terminal.vala"
			g_error ("Terminal.vala:69: Invalid scrollback-mode %u", _tmp9_);
#line 4298 "Terminal.c"
		}
	}
}

static void
terminal_terminal_class_init (TerminalTerminalClass * klass,
                              gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/widgets/Terminal.vala"
	g_type_class_adjust_private_offset (klass, &TerminalTerminal_private_offset);
#line 21 "../src/widgets/Terminal.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) terminal_terminal_real_dispose;
#line 21 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_terminal_get_property;
#line 21 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_terminal_set_property;
#line 21 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_terminal_finalize;
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_SCHEME_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_SCHEME_PROPERTY] = g_param_spec_object ("scheme", "scheme", "scheme", TERMINAL_TYPE_SCHEME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_PID_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, (GPid) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_PROCESS_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_PROCESS_PROPERTY] = g_param_spec_object ("process", "process", "process", TERMINAL_TYPE_PROCESS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY] = g_param_spec_uint ("user-scrollback-lines", "user-scrollback-lines", "user-scrollback-lines", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4335 "Terminal.c"
	/**
	   * This signal is emitted when the terminal process exits. Something should
	   * listen for this signal and close the tab that contains this terminal.
	   */
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_signals[TERMINAL_TERMINAL_EXIT_SIGNAL] = g_signal_new ("exit", TERMINAL_TYPE_TERMINAL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_signals[TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL] = g_signal_new ("spawn-failed", TERMINAL_TYPE_TERMINAL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_signals[TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL] = g_signal_new ("context-changed", TERMINAL_TYPE_TERMINAL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, TERMINAL_TYPE_PROCESS_CONTEXT);
#line 32 "../src/widgets/Terminal.vala"
	_tmp0_ = g_strdup ("TERM=xterm-256color");
#line 32 "../src/widgets/Terminal.vala"
	_tmp1_ = g_strdup ("COLORTERM=truecolor");
#line 32 "../src/widgets/Terminal.vala"
	_tmp2_ = g_strdup_printf ("TERM_PROGRAM=%s", TERMINAL_APP_NAME);
#line 32 "../src/widgets/Terminal.vala"
	_tmp3_ = terminal_constants_get_user_schemes_dir ();
#line 32 "../src/widgets/Terminal.vala"
	_tmp4_ = _tmp3_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp5_ = g_strdup_printf ("BLACKBOX_THEMES_DIR=%s", _tmp4_);
#line 32 "../src/widgets/Terminal.vala"
	_tmp6_ = g_strdup_printf ("VTE_VERSION=%u", (guint) (((VTE_MAJOR_VERSION * 10000) + (VTE_MINOR_VERSION * 100)) + VTE_MICRO_VERSION));
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_ = g_new0 (gchar*, 5 + 1);
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[0] = _tmp0_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[1] = _tmp1_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[2] = _tmp2_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[3] = _tmp5_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[4] = _tmp6_;
#line 32 "../src/widgets/Terminal.vala"
	terminal_terminal_blackbox_envv = _tmp7_;
#line 32 "../src/widgets/Terminal.vala"
	terminal_terminal_blackbox_envv_length1 = 5;
#line 32 "../src/widgets/Terminal.vala"
	_terminal_terminal_blackbox_envv_size_ = terminal_terminal_blackbox_envv_length1;
#line 4378 "Terminal.c"
}

static void
terminal_terminal_instance_init (TerminalTerminal * self,
                                 gpointer klass)
{
#line 21 "../src/widgets/Terminal.vala"
	self->priv = terminal_terminal_get_instance_private (self);
#line 57 "../src/widgets/Terminal.vala"
	self->priv->_pid = (GPid) -1;
#line 58 "../src/widgets/Terminal.vala"
	self->priv->_process = NULL;
#line 78 "../src/widgets/Terminal.vala"
	self->priv->fp_spawn_host_command_callback_cancellable = NULL;
#line 242 "../src/widgets/Terminal.vala"
	self->priv->padding_provider = NULL;
#line 4395 "Terminal.c"
}

static void
terminal_terminal_finalize (GObject * obj)
{
	TerminalTerminal * self;
#line 21 "../src/widgets/Terminal.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_TERMINAL, TerminalTerminal);
#line 56 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->_scheme);
#line 58 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->_process);
#line 76 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->window);
#line 78 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->fp_spawn_host_command_callback_cancellable);
#line 82 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->settings);
#line 242 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->padding_provider);
#line 21 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (terminal_terminal_parent_class)->finalize (obj);
#line 4418 "Terminal.c"
}

static GType
terminal_terminal_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalTerminalClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_terminal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalTerminal), 0, (GInstanceInitFunc) terminal_terminal_instance_init, NULL };
	GType terminal_terminal_type_id;
	terminal_terminal_type_id = g_type_register_static (vte_terminal_get_type (), "TerminalTerminal", &g_define_type_info, 0);
	TerminalTerminal_private_offset = g_type_add_instance_private (terminal_terminal_type_id, sizeof (TerminalTerminalPrivate));
	return terminal_terminal_type_id;
}

GType
terminal_terminal_get_type (void)
{
	static volatile gsize terminal_terminal_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_type_id__once)) {
		GType terminal_terminal_type_id;
		terminal_terminal_type_id = terminal_terminal_get_type_once ();
		g_once_init_leave (&terminal_terminal_type_id__once, terminal_terminal_type_id);
	}
	return terminal_terminal_type_id__once;
}

static void
_vala_terminal_terminal_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	TerminalTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL, TerminalTerminal);
#line 21 "../src/widgets/Terminal.vala"
	switch (property_id) {
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_SCHEME_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_object (value, terminal_terminal_get_scheme (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_PID_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_int (value, terminal_terminal_get_pid (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_PROCESS_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_object (value, terminal_terminal_get_process (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_uint (value, terminal_terminal_get_user_scrollback_lines (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 4477 "Terminal.c"
		default:
#line 21 "../src/widgets/Terminal.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 4483 "Terminal.c"
	}
}

static void
_vala_terminal_terminal_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	TerminalTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL, TerminalTerminal);
#line 21 "../src/widgets/Terminal.vala"
	switch (property_id) {
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_SCHEME_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		terminal_terminal_set_scheme (self, g_value_get_object (value));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_PID_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		terminal_terminal_set_pid (self, g_value_get_int (value));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_PROCESS_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		terminal_terminal_set_process (self, g_value_get_object (value));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 4515 "Terminal.c"
		default:
#line 21 "../src/widgets/Terminal.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 4521 "Terminal.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

